package new_mobile_api_controllers

import (
	"fmt"
	"strconv"
	"time"

	"XT_New/controllers/mobile_api_controllers"
	"XT_New/enums"
	"XT_New/models"
	"XT_New/service"
	"XT_New/utils"
	"github.com/jinzhu/gorm"
)

type NewManageApiController struct {
	mobile_api_controllers.MobileBaseAPIAuthController
}

func (this *NewManageApiController) GetEquitAutoInfo() {

	adminUser := this.GetMobileAdminUserInfo()
	orgid := adminUser.Org.Id
	remander, err := service.GetRemanderData(orgid)

	if err != nil {
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
		return
	}
	this.ServeSuccessJSON(map[string]interface{}{
		"remander": remander,
	})
}

func (this *NewManageApiController) GetDisInfectionTime() {
	adminUser := this.GetMobileAdminUserInfo()
	orgid := adminUser.Org.Id
	bedid, _ := this.GetInt64("bed_id")
	scheduletype, _ := this.GetInt64("schedule_type")
	scheduleweek, _ := this.GetInt64("schedule_week")
	fmt.Println(scheduleweek)
	scheduledate, _ := this.GetInt64("schedule_date")

	//根据床位号获取设备型号
	unitType, _ := service.GetUnitType(bedid, orgid)
	//查询使用登记最后一条消毒记录
	infomation, err := service.GetLaseDeviceInfomation(orgid, bedid, scheduledate, scheduletype)
	fmt.Println("err", err)
	if err == gorm.ErrRecordNotFound {
		//查询改设备是否有消毒计划
		plan, errcode := service.GetDisInfectionTime(orgid, unitType.UnitType, scheduletype, scheduleweek)
		//如果没有消毒计划，去查询该设备的上次消毒时间
		if errcode == gorm.ErrRecordNotFound {
			infor, errco := service.GetLaseDeviceInfomationTwo(orgid, bedid, scheduletype)
			if errco != nil {
				this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
				return
			}
			this.ServeSuccessJSON(map[string]interface{}{
				"plan":    infor.LongTime,
				"planObj": plan,
			})
		} else if errcode == nil {
			this.ServeSuccessJSON(map[string]interface{}{
				"plan":    plan.DisinfecTime,
				"planObj": plan,
			})
		}
	} else if err == nil {
		this.ServeSuccessJSON(map[string]interface{}{
			"plan":       infomation.LongTime,
			"infomation": infomation,
			"planObj":    "",
		})
	}
	//查询改设备是否有消毒计划
	//plan, err := service.GetDisInfectionTime(orgid, bedid, scheduletype, scheduleweek)
	//if err == gorm.ErrRecordNotFound {
	//	//去查询使用登记最后一条数据
	//	infomation, err := service.GetLaseDeviceInfomation(orgid, bedid)
	//	if err != nil {
	//		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
	//		return
	//	}
	//	this.ServeSuccessJSON(map[string]interface{}{
	//		"plan": infomation.LongTime,
	//	})
	//} else if err == nil {
	//	if err != nil {
	//		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
	//		return
	//	}
	//	this.ServeSuccessJSON(map[string]interface{}{
	//		"plan": plan.DisinfecTime,
	//	})
	//} else {
	//
	//}

}

func (this *NewManageApiController) SaveDisInfectionInfo() {
	adminUser := this.GetMobileAdminUserInfo()
	orgid := adminUser.Org.Id
	bedid, _ := this.GetInt64("bed_id")
	start_time := this.GetString("start_time")
	disinfectime, _ := this.GetInt64("disinfec_time")
	endtime := this.GetString("end_time")
	scheduledate, _ := this.GetInt64("schedule_date")
	zoneid, _ := this.GetInt64("zone_id")
	patientid, _ := this.GetInt64("patient_id")
	modeid, _ := this.GetInt64("mode_id")
	scheduletype, _ := this.GetInt64("schedule_type")
	timeLayout := "2006-01-02"
	loc, _ := time.LoadLocation("Local")
	var startdateunix int64
	if len(start_time) > 0 {
		theTime, err := time.ParseInLocation(timeLayout+" 15:04", start_time, loc)
		if err != nil {
			this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeParamWrong)
			return
		}
		startdateunix = theTime.Unix()
	}
	var enddateunix int64
	if len(endtime) > 0 {
		theTime, err := time.ParseInLocation(timeLayout+" 15:04", endtime, loc)
		if err != nil {
			utils.ErrorLog(err.Error())
			this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeParamWrong)
			return
		}
		enddateunix = theTime.Unix()
	}

	//查询病人信息
	patients, _ := service.GetPatientInfoMation(patientid)
	var con = ""
	if patients.IsInfectious == 0 {
		con = ""
	}
	if patients.IsInfectious == 1 {
		con = "无"
	}
	if patients.IsInfectious == 2 {
		con = "有"
	}
	//查询病人上机信息
	order, _ := service.GetPatientOrderInfo(scheduledate, patientid, orgid)
	//查询病人今日透后评估数据
	dislysis, _ := service.GetAssessmentAfterDissDataTwo(patientid, orgid, scheduledate)

	assessmentBeforThrity, _ := service.GetAssessmentBeforThrity(orgid, patientid, scheduledate)

	var weight_los float64

	weight_los = assessmentBeforThrity.WeightBefore - dislysis.WeightAfter

	fmt.Println("透析减少", dislysis.WeightLoss)
	//			//根据床位号获取设备id
	addmacher, _ := service.GetEquimentIDTwo(bedid, orgid)

	plan, errplan := service.GetDisinfectionTwo(addmacher.UnitType, scheduletype, orgid)

	if errplan == gorm.ErrRecordNotFound {
		returnData := make(map[string]interface{}, 0)
		returnData["msstatus"] = "2"
		this.ServeSuccessJSON(returnData)
		return
	} else {
		information := models.DeviceInformation{
			Date:                  scheduledate,
			Zone:                  zoneid,
			Class:                 scheduletype,
			BedNumber:             bedid,
			PatientId:             patientid,
			DialysisMode:          modeid,
			LongTime:              strconv.FormatInt(disinfectime, 10),
			Disinfection:          1,
			DialysisConcentration: 1,
			DisinfectionStatus:    1,
			Move:                  1,
			UserOrgId:             orgid,
			DisinfectType:         plan.Way,
			DisinfectantType:      plan.MachineDisinfectant,
			FluidPath:             plan.DisinfectanWay, //液路消毒方式
			Disinfectant:          plan.Disinfectant,
			Ctime:                 time.Now().Unix(),
			Status:                1,
			SignName:              order.FinishNurse,
			EquimentId:            addmacher.ID,
			DisinfectionResidue:   2,
			Bed:                   addmacher.BedNumber,
			StartTime:             order.StartTime,
			EndTime:               order.EndTime,
			Contagion:             con,
			WeightLoss:            weight_los,
			Hyperfiltratio:        dislysis.ActualUltrafiltration,
			DialysisHour:          strconv.FormatInt(dislysis.ActualTreatmentHour, 10),
			MachineRun:            1,
			DisinfecStartime:      startdateunix,
			DisinfecEndtime:       enddateunix,
		}
		service.DeleteInformation(patientid, scheduledate, orgid)
		err := service.CreateInformationTwo(&information)
		fmt.Println("报错", err)
		if err != nil {
			this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
			return
		}
		this.ServeSuccessJSON(map[string]interface{}{
			"information": information,
		})

	}
}

func (this *NewManageApiController) GetDeviceInformation() {

	adminUser := this.GetMobileAdminUserInfo()
	orgid := adminUser.Org.Id

	scheduleDate := this.GetString("schedule_date")
	recordDate, parseErr := utils.ParseTimeStringToTime("2006-01-02", scheduleDate)
	if parseErr != nil {
		this.ErrorLog("时间解析失败:%v", parseErr)
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeParamWrong)
		return
	}
	//查询今日所有设备使用登记
	information, err := service.GetDeviceInfomation(orgid, recordDate.Unix())
	//获取所有设备型号
	devicetype, _ := service.GetAllMode(orgid)
	if err != nil {
		this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
		return
	}
	this.ServeSuccessJSON(map[string]interface{}{
		"information": information,
		"devicetype":  devicetype,
	})
}

func (this *NewManageApiController) SaveDisinfectionInfoOne() {

	adminUser := this.GetMobileAdminUserInfo()
	orgid := adminUser.Org.Id
	bedid, _ := this.GetInt64("bed_id")
	start_time := this.GetString("start_time")
	disinfectime, _ := this.GetInt64("disinfec_time")
	endtime := this.GetString("end_time")
	scheduledate, _ := this.GetInt64("schedule_date")
	zoneid, _ := this.GetInt64("zone_id")
	patientid, _ := this.GetInt64("patient_id")
	modeid, _ := this.GetInt64("mode_id")
	scheduletype, _ := this.GetInt64("schedule_type")

	wayone, _ := this.GetInt64("way")

	machine_disinfectant, _ := this.GetInt64("machine_disinfectant")

	disinfectant_way, _ := this.GetInt64("disinfectant_way")

	disinfectant, _ := this.GetInt64("disinfectant")

	bed_way, _ := this.GetInt64("bed_way")

	dialysis_checked, _ := this.GetInt64("dialysis_checked")

	clean, _ := this.GetInt64("clean")

	germ_checked, _ := this.GetInt64("germ_checked")

	timeLayout := "2006-01-02"
	loc, _ := time.LoadLocation("Local")
	var startdateunix int64
	if len(start_time) > 0 {
		theTime, err := time.ParseInLocation(timeLayout+" 15:04", start_time, loc)
		if err != nil {
			this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeParamWrong)
			return
		}
		startdateunix = theTime.Unix()
	}
	var enddateunix int64
	if len(endtime) > 0 {
		theTime, err := time.ParseInLocation(timeLayout+" 15:04", endtime, loc)
		if err != nil {
			utils.ErrorLog(err.Error())
			this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeParamWrong)
			return
		}
		enddateunix = theTime.Unix()
	}

	//查询病人信息
	patients, _ := service.GetPatientInfoMation(patientid)
	var con = ""
	if patients.IsInfectious == 0 {
		con = ""
	}
	if patients.IsInfectious == 1 {
		con = "无"
	}
	if patients.IsInfectious == 2 {
		con = "有"
	}
	//查询病人上机信息
	order, _ := service.GetPatientOrderInfo(scheduledate, patientid, orgid)
	//查询病人今日透后评估数据
	dislysis, _ := service.GetAssessmentAfterDissDataTwo(patientid, orgid, scheduledate)

	assessmentBeforThrity, _ := service.GetAssessmentBeforThrity(orgid, patientid, scheduledate)

	var weight_los float64

	weight_los = assessmentBeforThrity.WeightBefore - dislysis.WeightAfter

	fmt.Println("透析减少", dislysis.WeightLoss)
	//			//根据床位号获取设备id
	addmacher, _ := service.GetEquimentIDTwo(bedid, orgid)

	_, errplan := service.GetDisinfectionTwo(addmacher.UnitType, scheduletype, orgid)

	if errplan == gorm.ErrRecordNotFound {
		returnData := make(map[string]interface{}, 0)
		returnData["msstatus"] = "2"
		this.ServeSuccessJSON(returnData)
		return
	} else {
		information := models.DeviceInformation{
			Date:                  scheduledate,
			Zone:                  zoneid,
			Class:                 scheduletype,
			BedNumber:             bedid,
			PatientId:             patientid,
			DialysisMode:          modeid,
			LongTime:              strconv.FormatInt(disinfectime, 10),
			Disinfection:          1,
			DialysisConcentration: 1,
			DisinfectionStatus:    1,
			Move:                  1,
			UserOrgId:             orgid,
			DisinfectType:         wayone,
			DisinfectantType:      machine_disinfectant,
			FluidPath:             disinfectant_way, //液路消毒方式
			Disinfectant:          disinfectant,
			Ctime:                 time.Now().Unix(),
			Status:                1,
			SignName:              order.FinishNurse,
			EquimentId:            addmacher.ID,
			DisinfectionResidue:   2,
			Bed:                   addmacher.BedNumber,
			StartTime:             order.StartTime,
			EndTime:               order.EndTime,
			Contagion:             con,
			WeightLoss:            weight_los,
			Hyperfiltratio:        dislysis.ActualUltrafiltration,
			DialysisHour:          strconv.FormatInt(dislysis.ActualTreatmentHour, 10),
			MachineRun:            1,
			DisinfecStartime:      startdateunix,
			DisinfecEndtime:       enddateunix,
			BedWay:                bed_way,
			DialysisChecked:       dialysis_checked,
			Clean:                 clean,
			GermChecked:           germ_checked,
		}
		service.DeleteInformation(patientid, scheduledate, orgid)
		err := service.CreateInformationTwo(&information)
		fmt.Println("报错", err)
		if err != nil {
			this.ServeFailJSONWithSGJErrorCode(enums.ErrorCodeSystemError)
			return
		}
		this.ServeSuccessJSON(map[string]interface{}{
			"information": information,
		})

	}
}
