package main

import (
	"encoding/xml"
	"net/http"

	_ "XT_New/routers"
	"XT_New/service"
	"github.com/astaxie/beego"
)

func init() {
	service.ConnectDB()
	go func() {
		http.ListenAndServe("localhost:6060", nil)
	}()
}

func main() {
	//service.NewAutoCreateWeekSchedules()

	//service.BeginAutoCreateWeekDisinfectionJob()
	//service.BeginAutoCreatePlanJob()
	//	//service.AutoClearSchedules()
	//service.BeginAutoCreateStaffScheduleJob()
	//service.BeginAutoCreateDrugJob()
	//service.BeginAutoCreateStockJob()

	//beego.BConfig.WebConfig.Session.SessionGCMaxLifetime = 6000
	//beego.BConfig.WebConfig.AutoRender = false
	//

	beego.Run()

}

type Envelope struct {
	XMLName xml.Name `xml:"soap:Envelope"`
	Soap    string   `xml:"xmlns:soap,attr"`
	Xsi     string   `xml:"xmlns:xsi,attr"`
	Xsd     string   `xml:"xmlns:xsd,attr"`
	Body    Body     `xml:"soap:Body"`
}

type Body struct {
	XMLName      xml.Name     `xml:"soap:Body"`
	GetReportReq GetReportReq `xml:"GetReportList"`
}

type GetReportReq struct {
	XMLName       xml.Name `xml:"http://tempuri.org/ GetReportList"`
	Key           string   `xml:"key"`
	BeginDateTime string   `xml:"BeginDateTime"`
	EndDateTime   string   `xml:"EndDateTime"`
	DateType      int      `xml:"DateType"`
	PrintState    int      `xml:"PrintState"`
}

type EnvelopeTwo struct {
	XMLName xml.Name     `xml:"http://schemas.xmlsoap.org/soap/envelope/ Envelope"`
	Body    EnvelopeBody `xml:"Body"`
}

type EnvelopeBody struct {
	GetReportListResponse GetReportListResponse `xml:"GetReportListResponse"`
}

type GetReportListResponse struct {
	XMLName             xml.Name `xml:"http://tempuri.org/ GetReportListResponse"`
	GetReportListResult string   `xml:"GetReportListResult"`
}

type ReportData struct {
	Res   int    `json:"Res"`
	Error string `json:"Error"`
	Data  []Data `json:"Data"`
}

type Data struct {
	RecordID           string `json:"RecordID"`
	PatientName        string `json:"PatientName"`
	Sex                string `json:"Sex"`
	Age                int    `json:"Age"`
	AgeUnit            string `json:"AgeUnit"`
	OfficeName         string `json:"OfficeName"`
	BedCode            string `json:"BedCode"`
	Barcode            string `json:"Barcode"`
	CustomerBarcode    string `json:"CustomerBarcode"`
	SampleCode         string `json:"SampleCode"`
	SampleCategory     string `json:"SampleCategory"`
	SampleDescription  string `json:"SampleDescription"`
	Diagnostics        string `json:"Diagnostics"`
	TakeSampleDateTime string `json:"TakeSampleDateTime"`
	ReceiveDateTime    string `json:"ReceiveDateTime"`
	AuditDateTime      string `json:"AuditDateTime"`
	InspectDate        string `json:"InspectDate"`
	SendDoctor         string `json:"SendDoctor"`
	InspectDoctorName  string `json:"InspectDoctorName"`
	AuditorName        string `json:"AuditorName"`
	Instrument         string `json:"Instrument"`
	Comment            string `json:"Comment"`
}
