package models

type BaseDrugLib struct {
	ID                          int64                  `gorm:"column:id" json:"id" form:"id"`
	DrugName                    string                 `gorm:"column:drug_name" json:"drug_name" form:"drug_name"`
	Pinyin                      string                 `gorm:"column:pinyin" json:"pinyin" form:"pinyin"`
	Wubi                        string                 `gorm:"column:wubi" json:"wubi" form:"wubi"`
	DrugAlias                   string                 `gorm:"column:drug_alias" json:"drug_alias" form:"drug_alias"`
	DrugAliasPinyin             string                 `gorm:"column:drug_alias_pinyin" json:"drug_alias_pinyin" form:"drug_alias_pinyin"`
	DrugAliasWubi               string                 `gorm:"column:drug_alias_wubi" json:"drug_alias_wubi" form:"drug_alias_wubi"`
	DrugCategory                int64                  `gorm:"column:drug_category" json:"drug_category" form:"drug_category"`
	DrugSpec                    string                 `gorm:"column:drug_spec" json:"drug_spec" form:"drug_spec"`
	DrugType                    int64                  `gorm:"column:drug_type" json:"drug_type" form:"drug_type"`
	DrugStockLimit              string                 `gorm:"column:drug_stock_limit" json:"drug_stock_limit" form:"drug_stock_limit"`
	DrugOriginPlace             string                 `gorm:"column:drug_origin_place" json:"drug_origin_place" form:"drug_origin_place"`
	DrugDosageForm              int64                  `gorm:"column:drug_dosage_form" json:"drug_dosage_form" form:"drug_dosage_form"`
	MedicalInsuranceLevel       int64                  `gorm:"column:medical_insurance_level" json:"medical_insurance_level" form:"medical_insurance_level"`
	MaxUnit                     string                 `gorm:"column:max_unit" json:"max_unit" form:"max_unit"`
	MinNumber                   int64                  `gorm:"column:min_number" json:"min_number" form:"min_number"`
	MinUnit                     string                 `gorm:"column:min_unit" json:"min_unit" form:"min_unit"`
	Dose                        string                 `gorm:"column:dose" json:"dose" form:"dose"`
	DoseUnit                    string                 `gorm:"column:dose_unit" json:"dose_unit" form:"dose_unit"`
	MinPrice                    float64                `gorm:"column:min_price" json:"min_price" form:"min_price"`
	UnitMatrixing               string                 `gorm:"column:unit_matrixing" json:"unit_matrixing" form:"unit_matrixing"`
	RetailPrice                 float64                `gorm:"column:retail_price" json:"retail_price" form:"retail_price"`
	LastPrice                   float64                `gorm:"column:last_price" json:"last_price" form:"last_price"`
	DrugControl                 int64                  `gorm:"column:drug_control" json:"drug_control" form:"drug_control"`
	Number                      string                 `gorm:"column:number" json:"number" form:"number"`
	DrugClassify                string                 `gorm:"column:drug_classify" json:"drug_classify" form:"drug_classify"`
	DrugDose                    float64                `gorm:"column:drug_dose" json:"drug_dose" form:"drug_dose"`
	DrugDoseUnit                int64                  `gorm:"column:drug_dose_unit" json:"drug_dose_unit" form:"drug_dose_unit"`
	MedicalInsuranceNumber      string                 `gorm:"column:medical_insurance_number" json:"medical_insurance_number" form:"medical_insurance_number"`
	ProvincesCode               string                 `gorm:"column:provinces_code" json:"provinces_code" form:"provinces_code"`
	Manufacturer                int64                  `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	PharmacologyCategory        int64                  `gorm:"column:pharmacology_category" json:"pharmacology_category" form:"pharmacology_category"`
	StatisticsCategory          int64                  `gorm:"column:statistics_category" json:"statistics_category" form:"statistics_category"`
	Code                        string                 `gorm:"column:code" json:"code" form:"code"`
	IsSpecialDiseases           int64                  `gorm:"column:is_special_diseases" json:"is_special_diseases" form:"is_special_diseases"`
	IsRecord                    int64                  `gorm:"column:is_record" json:"is_record" form:"is_record"`
	Agent                       string                 `gorm:"column:agent" json:"agent" form:"agent"`
	DrugStatus                  string                 `gorm:"column:drug_status" json:"drug_status" form:"drug_status"`
	LimitRemark                 string                 `gorm:"column:limit_remark" json:"limit_remark" form:"limit_remark"`
	DeliveryWay                 string                 `gorm:"column:delivery_way" json:"delivery_way" form:"delivery_way"`
	ExecutionFrequency          string                 `gorm:"column:execution_frequency" json:"execution_frequency" form:"execution_frequency"`
	SingleDose                  float64                `gorm:"column:single_dose" json:"single_dose" form:"single_dose"`
	PrescribingNumber           float64                `gorm:"column:prescribing_number" json:"prescribing_number" form:"prescribing_number"`
	Label                       int64                  `gorm:"column:label" json:"label" form:"label"`
	Sort                        int64                  `gorm:"column:sort" json:"sort" form:"sort"`
	IsUseDoctorAdvice           int64                  `gorm:"column:is_use_doctor_advice" json:"is_use_doctor_advice" form:"is_use_doctor_advice"`
	IsDefault                   int64                  `gorm:"column:is_default" json:"is_default" form:"is_default"`
	IsChargePredict             int64                  `gorm:"column:is_charge_predict" json:"is_charge_predict" form:"is_charge_predict"`
	IsStatisticsWork            int64                  `gorm:"column:is_statistics_work" json:"is_statistics_work" form:"is_statistics_work"`
	IsChargeUse                 int64                  `gorm:"column:is_charge_use" json:"is_charge_use" form:"is_charge_use"`
	Status                      int64                  `gorm:"column:status" json:"status" form:"status"`
	Ctime                       int64                  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                       int64                  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	OrgId                       int64                  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	DrugCode                    string                 `gorm:"column:drug_code" json:"drug_code" form:"drug_code"`
	Dealer                      int64                  `gorm:"column:dealer" json:"dealer" form:"dealer"`
	PrescriptionMark            int64                  `gorm:"column:prescription_mark" json:"prescription_mark" form:"prescription_mark"`
	RecordDate                  int64                  `gorm:"column:record_date" json:"record_date" form:"record_date"`
	DrugRemark                  string                 `gorm:"column:drug_remark" json:"drug_remark" form:"drug_remark"`
	SocialSecurityDirectoryCode string                 `gorm:"column:social_security_directory_code" json:"social_security_directory_code" form:"social_security_directory_code"`
	DoseCode                    string                 `gorm:"column:dose_code" json:"dose_code" form:"dose_code"`
	IsMark                      int64                  `gorm:"column:is_mark" json:"is_mark" form:"is_mark"`
	HospApprFlag                int64                  `gorm:"column:hosp_appr_flag" json:"hosp_appr_flag" form:"hosp_appr_flag"`
	LmtUsedFlag                 int64                  `gorm:"column:lmt_used_flag" json:"lmt_used_flag" form:"lmt_used_flag"`
	DrugDay                     string                 `gorm:"column:drug_day" json:"drug_day" form:"drug_day"`
	Total                       float64                `gorm:"column:total" json:"total" form:"total"`
	PrescribingNumberUnit       string                 `gorm:"column:prescribing_number_unit" json:"prescribing_number_unit" form:"prescribing_number_unit"`
	DrugWarehouseInfo           []*XtDrugWarehouseInfo `gorm:"ForeignKey:DrugId;AssociationForeignKey:ID" json:"drug_warehouse_info"`
	LastDrugWarehouseInfo       XtDrugWarehouseInfo    `gorm:"ForeignKey:DrugId;AssociationForeignKey:ID" json:"first_drug_warehouse_info"`
	IsUse                       int64                  `gorm:"column:is_user" json:"is_user" form:"is_user"`
	BatchRetaiPrice             float64                `gorm:"column:batch_retai_price" json:"batch_retai_price" form:"batch_retai_price"`
	SumCount                    int64                  `gorm:"column:sum_count" json:"sum_count" form:"sum_count"`
	SumInCount                  int64                  `gorm:"column:sum_in_count" json:"sum_in_count" form:"sum_in_count"`
	IsPharmacy                  int64                  `gorm:"column:is_pharmacy" json:"is_pharmacy" form:"is_pharmacy"`
	TotalCount                  int64                  `gorm:"column:total_count" json:"total_count" form:"total_count"`
	DrugStockLimitCount         int64                  `gorm:"column:drug_stock_limit_count" json:"drug_stock_limit_count" form:"drug_stock_limit_count"`
	SumOutCount                 int64                  `gorm:"column:sum_out_count" json:"sum_out_count" form:"sum_out_count"`
	SumCancelCount              int64                  `gorm:"column:sum_cancel_count" json:"sum_cancel_count" form:"sum_cancel_count"`

	ZuobiaoId string `gorm:"column:zuobiao_id" json:"zuobiao_id" form:"zuobiao_id"`
	Bck01b    string `gorm:"column:bck01b" json:"bck01b" form:"bck01b"`
	Bby01     string `gorm:"column:bby01" json:"bby01" form:"bby01"`
	Bbx01     string `gorm:"column:bbx01" json:"bbx01" form:"bbx01"`

	FirstLetter        string `gorm:"column:first_letter" json:"first_letter" form:"first_letter"`
	IsProject          int64  `gorm:"column:is_project" json:"is_project" form:"is_project"`
	DrugDosageFormName string `gorm:"column:drug_dosage_form_name" json:"drug_dosage_form_name" form:"drug_dosage_form_name"`
	IsShow             int64  `gorm:"column:is_show" json:"is_show" form:"is_show"`
	IsSelfDrug         int64  `gorm:"column:is_self_drug" json:"is_self_drug" form:"is_self_drug"`
	SpecificationName  string `gorm:"column:specification_name" json:"specification_name" form:"specification_name"`
}

func (BaseDrugLib) TableName() string {
	return "xt_base_drug"
}

type BaseDrugLibSeven struct {
	ID         int64  `gorm:"column:id" json:"id" form:"id"`
	DrugName   string `gorm:"column:drug_name" json:"drug_name" form:"drug_name"`
	MaxUnit    string `gorm:"column:max_unit" json:"max_unit" form:"max_unit"`
	MinNumber  int64  `gorm:"column:min_number" json:"min_number" form:"min_number"`
	MinUnit    string `gorm:"column:min_unit" json:"min_unit" form:"min_unit"`
	SumCount   int64  `gorm:"column:sum_count" json:"sum_count" form:"sum_count"`
	IsUse      int64  `gorm:"column:is_user" json:"is_user" form:"is_user"`
	IsPharmacy int64  `gorm:"column:is_pharmacy" json:"is_pharmacy" form:"is_pharmacy"`
	OrgId      int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	IsProject  int64  `gorm:"column:is_project" json:"is_project" form:"is_project"`
	DrugType   int64  `gorm:"column:drug_type" json:"drug_type" form:"drug_type"`
	IsSelfDrug int64  `gorm:"column:is_self_drug" json:"is_self_drug" form:"is_self_drug"`
	Dose       string `gorm:"column:dose" json:"dose" form:"dose"`
	DoseUnit   string `gorm:"column:dose_unit" json:"dose_unit" form:"dose_unit"`
}

func (BaseDrugLibSeven) TableName() string {
	return "xt_base_drug"
}

type BaseDrugLibTwentyOne struct {
	ID           int64   `gorm:"column:id" json:"id" form:"id"`
	DrugName     string  `gorm:"column:drug_name" json:"drug_name" form:"drug_name"`
	MaxUnit      string  `gorm:"column:max_unit" json:"max_unit" form:"max_unit"`
	MinUnit      string  `gorm:"column:min_unit" json:"min_unit" form:"min_unit"`
	RetailPrice  float64 `gorm:"column:retail_price" json:"retail_price" form:"retail_price"`
	LastPrice    float64 `gorm:"column:last_price" json:"last_price" form:"last_price"`
	DrugDose     float64 `gorm:"column:drug_dose" json:"drug_dose" form:"drug_dose"`
	DrugDoseUnit int64   `gorm:"column:drug_dose_unit" json:"drug_dose_unit" form:"drug_dose_unit"`
	Manufacturer int64   `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	Status       int64   `gorm:"column:status" json:"status" form:"status"`
	OrgId        int64   `gorm:"column:org_id" json:"org_id" form:"org_id"`
	MinNumber    int64   `gorm:"column:min_number" json:"min_number" form:"min_number"`
	Dose         string  `gorm:"column:dose" json:"dose" form:"dose"`
	DoseUnit     string  `gorm:"column:dose_unit" json:"dose_unit" form:"dose_unit"`
	DrugDay      string  `gorm:"column:drug_day" json:"drug_day" form:"drug_day"`
	MinPrice     float64 `gorm:"column:min_price" json:"min_price" form:"min_price"`
}

func (BaseDrugLibTwentyOne) TableName() string {
	return "xt_base_drug"
}

type BaseDrugLibEleven struct {
	ID               int64  `gorm:"column:id" json:"id" form:"id"`
	DrugName         string `gorm:"column:drug_name" json:"drug_name" form:"drug_name"`
	Manufacturer     int64  `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	ManufacturerName string `gorm:"column:manufacturer_name" json:"manufacturer_name"`
	MaxUnit          string `gorm:"column:max_unit" json:"max_unit" form:"max_unit"`
	MinNumber        int64  `gorm:"column:min_number" json:"min_number" form:"min_number"`
	MinUnit          string `gorm:"column:min_unit" json:"min_unit" form:"min_unit"`
	Dose             string `gorm:"column:dose" json:"dose" form:"dose"`
	DoseUnit         string `gorm:"column:dose_unit" json:"dose_unit" form:"dose_unit"`
}

func (BaseDrugLibEleven) TableName() string {
	return "xt_base_drug"
}

type BaseDrugLibTen struct {
	ID                  int64 `gorm:"column:id" json:"id" form:"id"`
	OrgId               int64 `gorm:"column:org_id" json:"org_id" form:"org_id"`
	TotalCount          int64 `gorm:"column:total_count" json:"total_count" form:"total_count"`
	DrugStockLimitCount int64 `gorm:"column:drug_stock_limit_count" json:"drug_stock_limit_count" form:"drug_stock_limit_count"`
	Status              int64 `gorm:"column:status" json:"status" form:"status"`
}

func (BaseDrugLibTen) TableName() string {
	return "xt_base_drug"
}

type DrugUnitSafeguard struct {
	ID               int64  `gorm:"column:id" json:"id" form:"id"`
	Unit             string `gorm:"column:unit" json:"unit" form:"unit"`
	ConversionFactor string `gorm:"column:conversion_factor" json:"conversion_factor" form:"conversion_factor"`
	IsStockUse       int64  `gorm:"column:is_stock_use" json:"is_stock_use" form:"is_stock_use"`
	UserOrgId        int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Ctime            int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime            int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status           int64  `gorm:"column:status" json:"status" form:"status"`
	DrugId           int64  `gorm:"column:drug_id" json:"drug_id" form:"drug_id"`
}

func (DrugUnitSafeguard) TableName() string {
	return "xt_drug_unit_safeguard"
}

type MedicineInsurancePercentage struct {
	ID                    int64   `gorm:"column:id" json:"id" form:"id"`
	MedicineInsuranceType int64   `gorm:"column:medicine_insurance_type" json:"medicine_insurance_type" form:"medicine_insurance_type"`
	Percent               float64 `gorm:"column:percent" json:"percent" form:"percent"`
	UserOrgId             int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status                int64   `gorm:"column:status" json:"status" form:"status"`
	Ctime                 int64   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                 int64   `gorm:"column:mtime" json:"mtime" form:"mtime"`
	TypeId                int64   `gorm:"column:type_id" json:"drug_id" form:"type_id"`
	RecordTime            int64   `gorm:"column:record_time" json:"record_time" form:"record_time"`
	Module                int64   `gorm:"column:module" json:"module" form:"module"`
	GoodId                int64   `gorm:"column:good_id" json:"good_id" form:"good_id"`
}

func (MedicineInsurancePercentage) TableName() string {
	return "xt_medicine_insurance_percentage"
}

type BaseDrugLibNight struct {
	ID                          int64                   `gorm:"column:id" json:"id" form:"id"`
	DrugName                    string                  `gorm:"column:drug_name" json:"drug_name" form:"drug_name"`
	Pinyin                      string                  `gorm:"column:pinyin" json:"pinyin" form:"pinyin"`
	Wubi                        string                  `gorm:"column:wubi" json:"wubi" form:"wubi"`
	DrugAlias                   string                  `gorm:"column:drug_alias" json:"drug_alias" form:"drug_alias"`
	DrugAliasPinyin             string                  `gorm:"column:drug_alias_pinyin" json:"drug_alias_pinyin" form:"drug_alias_pinyin"`
	DrugAliasWubi               string                  `gorm:"column:drug_alias_wubi" json:"drug_alias_wubi" form:"drug_alias_wubi"`
	DrugCategory                int64                   `gorm:"column:drug_category" json:"drug_category" form:"drug_category"`
	DrugSpec                    string                  `gorm:"column:drug_spec" json:"drug_spec" form:"drug_spec"`
	DrugType                    int64                   `gorm:"column:drug_type" json:"drug_type" form:"drug_type"`
	DrugStockLimit              string                  `gorm:"column:drug_stock_limit" json:"drug_stock_limit" form:"drug_stock_limit"`
	DrugOriginPlace             string                  `gorm:"column:drug_origin_place" json:"drug_origin_place" form:"drug_origin_place"`
	DrugDosageForm              int64                   `gorm:"column:drug_dosage_form" json:"drug_dosage_form" form:"drug_dosage_form"`
	MedicalInsuranceLevel       int64                   `gorm:"column:medical_insurance_level" json:"medical_insurance_level" form:"medical_insurance_level"`
	MaxUnit                     string                  `gorm:"column:max_unit" json:"max_unit" form:"max_unit"`
	MinNumber                   int64                   `gorm:"column:min_number" json:"min_number" form:"min_number"`
	MinUnit                     string                  `gorm:"column:min_unit" json:"min_unit" form:"min_unit"`
	Dose                        string                  `gorm:"column:dose" json:"dose" form:"dose"`
	DoseUnit                    string                  `gorm:"column:dose_unit" json:"dose_unit" form:"dose_unit"`
	MinPrice                    float64                 `gorm:"column:min_price" json:"min_price" form:"min_price"`
	UnitMatrixing               string                  `gorm:"column:unit_matrixing" json:"unit_matrixing" form:"unit_matrixing"`
	RetailPrice                 float64                 `gorm:"column:retail_price" json:"retail_price" form:"retail_price"`
	LastPrice                   float64                 `gorm:"column:last_price" json:"last_price" form:"last_price"`
	DrugControl                 int64                   `gorm:"column:drug_control" json:"drug_control" form:"drug_control"`
	Number                      string                  `gorm:"column:number" json:"number" form:"number"`
	DrugClassify                string                  `gorm:"column:drug_classify" json:"drug_classify" form:"drug_classify"`
	DrugDose                    float64                 `gorm:"column:drug_dose" json:"drug_dose" form:"drug_dose"`
	DrugDoseUnit                int64                   `gorm:"column:drug_dose_unit" json:"drug_dose_unit" form:"drug_dose_unit"`
	MedicalInsuranceNumber      string                  `gorm:"column:medical_insurance_number" json:"medical_insurance_number" form:"medical_insurance_number"`
	ProvincesCode               string                  `gorm:"column:provinces_code" json:"provinces_code" form:"provinces_code"`
	Manufacturer                int64                   `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	PharmacologyCategory        int64                   `gorm:"column:pharmacology_category" json:"pharmacology_category" form:"pharmacology_category"`
	StatisticsCategory          int64                   `gorm:"column:statistics_category" json:"statistics_category" form:"statistics_category"`
	Code                        string                  `gorm:"column:code" json:"code" form:"code"`
	IsSpecialDiseases           int64                   `gorm:"column:is_special_diseases" json:"is_special_diseases" form:"is_special_diseases"`
	IsRecord                    int64                   `gorm:"column:is_record" json:"is_record" form:"is_record"`
	Agent                       string                  `gorm:"column:agent" json:"agent" form:"agent"`
	DrugStatus                  string                  `gorm:"column:drug_status" json:"drug_status" form:"drug_status"`
	LimitRemark                 string                  `gorm:"column:limit_remark" json:"limit_remark" form:"limit_remark"`
	DeliveryWay                 string                  `gorm:"column:delivery_way" json:"delivery_way" form:"delivery_way"`
	ExecutionFrequency          string                  `gorm:"column:execution_frequency" json:"execution_frequency" form:"execution_frequency"`
	SingleDose                  float64                 `gorm:"column:single_dose" json:"single_dose" form:"single_dose"`
	PrescribingNumber           float64                 `gorm:"column:prescribing_number" json:"prescribing_number" form:"prescribing_number"`
	Label                       int64                   `gorm:"column:label" json:"label" form:"label"`
	Sort                        int64                   `gorm:"column:sort" json:"sort" form:"sort"`
	IsUseDoctorAdvice           int64                   `gorm:"column:is_use_doctor_advice" json:"is_use_doctor_advice" form:"is_use_doctor_advice"`
	IsDefault                   int64                   `gorm:"column:is_default" json:"is_default" form:"is_default"`
	IsChargePredict             int64                   `gorm:"column:is_charge_predict" json:"is_charge_predict" form:"is_charge_predict"`
	IsStatisticsWork            int64                   `gorm:"column:is_statistics_work" json:"is_statistics_work" form:"is_statistics_work"`
	IsChargeUse                 int64                   `gorm:"column:is_charge_use" json:"is_charge_use" form:"is_charge_use"`
	Status                      int64                   `gorm:"column:status" json:"status" form:"status"`
	Ctime                       int64                   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                       int64                   `gorm:"column:mtime" json:"mtime" form:"mtime"`
	OrgId                       int64                   `gorm:"column:org_id" json:"org_id" form:"org_id"`
	DrugCode                    string                  `gorm:"column:drug_code" json:"drug_code" form:"drug_code"`
	Dealer                      int64                   `gorm:"column:dealer" json:"dealer" form:"dealer"`
	PrescriptionMark            int64                   `gorm:"column:prescription_mark" json:"prescription_mark" form:"prescription_mark"`
	RecordDate                  int64                   `gorm:"column:record_date" json:"record_date" form:"record_date"`
	DrugRemark                  string                  `gorm:"column:drug_remark" json:"drug_remark" form:"drug_remark"`
	SocialSecurityDirectoryCode string                  `gorm:"column:social_security_directory_code" json:"social_security_directory_code" form:"social_security_directory_code"`
	DoseCode                    string                  `gorm:"column:dose_code" json:"dose_code" form:"dose_code"`
	IsMark                      int64                   `gorm:"column:is_mark" json:"is_mark" form:"is_mark"`
	HospApprFlag                int64                   `gorm:"column:hosp_appr_flag" json:"hosp_appr_flag" form:"hosp_appr_flag"`
	LmtUsedFlag                 int64                   `gorm:"column:lmt_used_flag" json:"lmt_used_flag" form:"lmt_used_flag"`
	DrugDay                     string                  `gorm:"column:drug_day" json:"drug_day" form:"drug_day"`
	Total                       float64                 `gorm:"column:total" json:"total" form:"total"`
	PrescribingNumberUnit       string                  `gorm:"column:prescribing_number_unit" json:"prescribing_number_unit" form:"prescribing_number_unit"`
	DrugWarehouseInfo           []*XtDrugWarehouseInfo  `gorm:"ForeignKey:DrugId;AssociationForeignKey:ID" json:"drug_warehouse_info"`
	XtDrugWarehouseInfo         []*XtDrugWarehouseInfo  `gorm:"ForeignKey:DrugId;AssociationForeignKey:ID" json:"drug_warehouse_info"`
	DrugWarehouseOutInfo        []*DrugWarehouseOutInfo `gorm:"ForeignKey:DrugId;AssociationForeignKey:ID" json:"drug_warehouse_out"`
	DrugCancelStockInfo         []*DrugCancelStockInfo  `gorm:"ForeignKey:DrugId;AssociationForeignKey:ID" json:"drug_cancel_info"`
	IsUse                       int64                   `gorm:"column:is_user" json:"is_user" form:"is_user"`
	BatchRetaiPrice             float64                 `gorm:"column:batch_retai_price" json:"batch_retai_price" form:"batch_retai_price"`
	SumCount                    int64                   `gorm:"column:sum_count" json:"sum_count" form:"sum_count"`
	SumInCount                  int64                   `gorm:"column:sum_in_count" json:"sum_in_count" form:"sum_in_count"`
	IsPharmacy                  int64                   `gorm:"column:is_pharmacy" json:"is_pharmacy" form:"is_pharmacy"`
}

func (BaseDrugLibNight) TableName() string {
	return "xt_base_drug"
}

type BaseDrugLibTwenty struct {
	ID             int64  `gorm:"column:id" json:"id" form:"id"`
	DrugName       string `gorm:"column:drug_name" json:"drug_name" form:"drug_name"`
	Status         int64  `gorm:"column:status" json:"status" form:"status"`
	OrgId          int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	MaxUnit        string `gorm:"column:max_unit" json:"max_unit" form:"max_unit"`
	MinNumber      int64  `gorm:"column:min_number" json:"min_number" form:"min_number"`
	MinUnit        string `gorm:"column:min_unit" json:"min_unit" form:"min_unit"`
	Dose           string `gorm:"column:dose" json:"dose" form:"dose"`
	DoseUnit       string `gorm:"column:dose_unit" json:"dose_unit" form:"dose_unit"`
	DrugStatus     string `gorm:"column:drug_status" json:"drug_status" form:"drug_status"`
	DrugStockLimit string `gorm:"column:drug_stock_limit" json:"drug_stock_limit_count" form:"drug_stock_limit"`
	Manufacturer   int64  `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
}

func (BaseDrugLibTwenty) TableName() string {
	return "xt_base_drug"
}

type BaseDrugLibThrity struct {
	ID                    int64                      `gorm:"column:id" json:"id" form:"id"`
	DrugName              string                     `gorm:"column:drug_name" json:"drug_name" form:"drug_name"`
	Manufacturer          int64                      `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	ManufacturerName      string                     `gorm:"column:manufacturer_name" json:"manufacturer_name"`
	MaxUnit               string                     `gorm:"column:max_unit" json:"max_unit" form:"max_unit"`
	MinNumber             int64                      `gorm:"column:min_number" json:"min_number" form:"min_number"`
	MinUnit               string                     `gorm:"column:min_unit" json:"min_unit" form:"min_unit"`
	Dose                  string                     `gorm:"column:dose" json:"dose" form:"dose"`
	DoseUnit              string                     `gorm:"column:dose_unit" json:"dose_unit" form:"dose_unit"`
	IsSelfDrug            int64                      `gorm:"column:is_self_drug" json:"is_self_drug" form:"is_self_drug"`
	OrgId                 int64                      `gorm:"column:org_id" json:"org_id" form:"org_id"`
	Status                int64                      `gorm:"column:status" json:"status" form:"status"`
	Dealer                int64                      `gorm:"column:dealer" json:"dealer" form:"dealer"`
	DrugType              int64                      `gorm:"column:drug_type" json:"drug_type" form:"drug_type"`
	LastDrugWarehouseInfo XtSelfDrugWarehouseInfo    `gorm:"ForeignKey:DrugId;AssociationForeignKey:ID" json:"first_drug_warehouse_info"`
	DrugWarehouseInfo     []*XtSelfDrugWarehouseInfo `gorm:"ForeignKey:DrugId;AssociationForeignKey:ID" json:"drug_warehouse_info"`
}

func (BaseDrugLibThrity) TableName() string {
	return "xt_base_drug"
}

type XtSelfDrugWarehouseInfo struct {
	ID                        int64            `gorm:"column:id" json:"id" form:"id"`
	WarehousingId             int64            `gorm:"column:warehousing_id" json:"warehousing_id" form:"warehousing_id"`
	DrugId                    int64            `gorm:"column:drug_id" json:"drug_id" form:"drug_id"`
	Number                    string           `gorm:"column:number" json:"number" form:"number"`
	ProductDate               int64            `gorm:"column:product_date" json:"product_date" form:"product_date"`
	ExpiryDate                int64            `gorm:"column:expiry_date" json:"expiry_date" form:"expiry_date"`
	WarehousingCount          int64            `gorm:"column:warehousing_count" json:"warehousing_count" form:"warehousing_count"`
	WarehouseingUnit          string           `gorm:"column:warehouseing_unit" json:"warehouseing_unit" form:"warehouseing_unit"`
	MaxUnit                   string           `gorm:"column:max_unit" json:"max_unit" form:"max_unit"`
	MinUnit                   string           `gorm:"column:min_unit" json:"min_unit" form:"min_unit"`
	StockMaxNumber            int64            `gorm:"column:stock_max_number" json:"stock_max_number" form:"stock_max_number"`
	StockMinNumber            int64            `gorm:"column:stock_min_number" json:"stock_min_number" form:"stock_min_number"`
	Price                     float64          `gorm:"column:price" json:"price" form:"price"`
	TotalPrice                float64          `gorm:"column:total_price" json:"total_price" form:"total_price"`
	Dealer                    int64            `gorm:"column:dealer" json:"dealer" form:"dealer"`
	Manufacturer              int64            `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	Remark                    string           `gorm:"column:remark" json:"remark" form:"remark"`
	Ctime                     int64            `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                     int64            `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status                    int64            `gorm:"column:status" json:"status" form:"status"`
	OrgId                     int64            `gorm:"column:org_id" json:"org_id" form:"org_id"`
	IsReturn                  int64            `gorm:"column:is_return" json:"is_return" form:"is_return"`
	WarehousingOrder          string           `gorm:"column:warehousing_order" json:"warehousing_order" form:"warehousing_order"`
	Type                      int64            `gorm:"column:type" json:"type" form:"type"`
	RetailPrice               float64          `gorm:"column:retail_price" json:"retail_price" form:"retail_price"`
	RetailTotalPrice          float64          `gorm:"column:retail_total_price" json:"retail_total_price" form:"retail_total_price"`
	BatchNumber               string           `gorm:"column:batch_number" json:"batch_number" form:"batch_number"`
	WarehousingInfoId         int64            `gorm:"column:warehousing_info_id" json:"warehousing_info_id" form:"warehousing_info_id"`
	SupplyWarehouseId         int64            `gorm:"column:supply_warehouse_id" json:"supply_warehouse_id" form:"supply_warehouse_id"`
	SupplyWarehouseDetailInfo int64            `gorm:"column:supply_warehouse_detail_info" json:"supply_warehouse_detail_info" form:"supply_warehouse_detail_info"`
	StorehouseId              int64            `gorm:"column:storehouse_id" json:"storehouse_id" form:"storehouse_id"`
	SecondWarehouseInfoId     int64            `gorm:"column:second_warehouse_info_id" json:"second_warehouse_info_id" form:"second_warehouse_info_id"`
	PharmacyId                int64            `gorm:"column:pharmacy_id" json:"pharmacy_id" form:"pharmacy_id"`
	IsCheck                   int64            `gorm:"column:is_check" json:"is_check" form:"is_check"`
	ManafacturerName          string           `gorm:"column:manafacturer_name" json:"manafacturer_name" form:"manafacturer_name"`
	DealerName                string           `gorm:"column:dealer_name" json:"dealer_name" form:"dealer_name"`
	PatientId                 int64            `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Creater                   int64            `gorm:"column:creater" json:"creater" form:"creater"`
	IsSys                     int64            `gorm:"column:is_sys" json:"is_sys" form:"is_sys"`
	RecordDate                int64            `gorm:"column:record_date" json:"record_date" form:"record_date"`
	BaseDrugLib               BaseDrugLibSeven `gorm:"ForeignKey:ID;AssociationForeignKey:DrugId"json:"drug" `
	AdviceId                  int64            `gorm:"column:advice_id" json:"advice_id" form:"advice_id"`
}

func (XtSelfDrugWarehouseInfo) TableName() string {
	return "xt_self_drug_warehouse_info"
}

type XtSelfDrugWarehouse struct {
	ID                int64  `gorm:"column:id" json:"id" form:"id"`
	WarehousingOrder  string `gorm:"column:warehousing_order" json:"warehousing_order" form:"warehousing_order"`
	OperationTime     int64  `gorm:"column:operation_time" json:"operation_time" form:"operation_time"`
	OrgId             int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	Creater           int64  `gorm:"column:creater" json:"creater" form:"creater"`
	Ctime             int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Modifier          int64  `gorm:"column:modifier" json:"modifier" form:"modifier"`
	Mtime             int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status            int64  `gorm:"column:status" json:"status" form:"status"`
	WarehousingTime   int64  `gorm:"column:warehousing_time" json:"warehousing_time" form:"warehousing_time"`
	Dealer            int64  `gorm:"column:dealer" json:"dealer" form:"dealer"`
	Manufacturer      int64  `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	Type              int64  `gorm:"column:type" json:"type" form:"type"`
	SupplyWarehouseId int64  `gorm:"column:supply_warehouse_id" json:"supply_warehouse_id" form:"supply_warehouse_id"`
	StorehouseId      int64  `gorm:"column:storehouse_id" json:"storehouse_id" form:"storehouse_id"`
	SecondWarehouseId int64  `gorm:"column:second_warehouse_id" json:"second_warehouse_id" form:"second_warehouse_id"`
	IsSys             int64  `gorm:"column:is_sys" json:"is_sys" form:"is_sys"`
	IsCheck           int64  `gorm:"column:is_check" json:"is_check" form:"is_check"`
	Checker           int64  `gorm:"column:checker" json:"checker" form:"checker"`
	PatientId         int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
}

func (XtSelfDrugWarehouse) TableName() string {
	return "xt_self_drug_warehouse"
}

type XtSelfDrugFlow struct {
	ID                        int64       `gorm:"column:id" json:"id" form:"id"`
	WarehousingId             int64       `gorm:"column:warehousing_id" json:"warehousing_id" form:"warehousing_id"`
	DrugId                    int64       `gorm:"column:drug_id" json:"drug_id" form:"drug_id"`
	Number                    string      `gorm:"column:number" json:"number" form:"number"`
	BatchNumber               string      `gorm:"column:batch_number" json:"batch_number" form:"batch_number"`
	Count                     int64       `gorm:"column:count" json:"count" form:"count"`
	UserOrgId                 int64       `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId                 int64       `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	SystemTime                int64       `gorm:"column:system_time" json:"system_time" form:"system_time"`
	ConsumableType            int64       `gorm:"column:consumable_type" json:"consumable_type" form:"consumable_type"`
	IsSys                     int64       `gorm:"column:is_sys" json:"is_sys" form:"is_sys"`
	WarehousingOrder          string      `gorm:"column:warehousing_order" json:"warehousing_order" form:"warehousing_order"`
	WarehouseOutId            int64       `gorm:"column:warehouse_out_id" json:"warehouse_out_id" form:"warehouse_out_id"`
	WarehouseOutOrderNumber   string      `gorm:"column:warehouse_out_order_number" json:"warehouse_out_order_number" form:"warehouse_out_order_number"`
	IsEdit                    int64       `gorm:"column:is_edit" json:"is_edit" form:"is_edit"`
	CancelStockId             int64       `gorm:"column:cancel_stock_id" json:"cancel_stock_id" form:"cancel_stock_id"`
	CancelOrderNumber         string      `gorm:"column:cancel_order_number" json:"cancel_order_number" form:"cancel_order_number"`
	Manufacturer              int64       `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	Dealer                    int64       `gorm:"column:dealer" json:"dealer" form:"dealer"`
	Creator                   int64       `gorm:"column:creator" json:"creator" form:"creator"`
	UpdateCreator             int64       `gorm:"column:update_creator" json:"update_creator" form:"update_creator"`
	Status                    int64       `gorm:"column:status" json:"status" form:"status"`
	Ctime                     int64       `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                     int64       `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Price                     float64     `gorm:"column:price" json:"price" form:"price"`
	WarehousingDetailId       int64       `gorm:"column:warehousing_detail_id" json:"warehousing_detail_id" form:"warehousing_detail_id"`
	WarehouseOutDetailId      int64       `gorm:"column:warehouse_out_detail_id" json:"warehouse_out_detail_id" form:"warehouse_out_detail_id"`
	CancelOutDetailId         int64       `gorm:"column:cancel_out_detail_id" json:"cancel_out_detail_id" form:"cancel_out_detail_id"`
	ExpireDate                int64       `gorm:"column:expire_date" json:"expire_date" form:"expire_date"`
	ProductDate               int64       `gorm:"column:product_date" json:"product_date" form:"product_date"`
	MaxUnit                   string      `gorm:"column:max_unit" json:"max_unit" form:"max_unit"`
	MinUnit                   string      `gorm:"column:min_unit" json:"min_unit" form:"min_unit"`
	StockMaxNumber            int64       `gorm:"column:stock_max_number" json:"stock_max_number" form:"stock_max_number"`
	StockMinNumber            int64       `gorm:"column:stock_min_number" json:"stock_min_number" form:"stock_min_number"`
	LastStockMaxNumber        int64       `gorm:"column:last_stock_max_number" json:"last_stock_max_number" form:"last_stock_max_number"`
	LastStockMinNumber        int64       `gorm:"column:last_stock_min_number" json:"last_stock_min_number" form:"last_stock_min_number"`
	AdviceId                  int64       `gorm:"column:advice_id" json:"advice_id" form:"advice_id"`
	SupplyWarehouseId         int64       `gorm:"column:supply_warehouse_id" json:"supply_warehouse_id" form:"supply_warehouse_id"`
	SupplyCancelOutId         int64       `gorm:"column:supply_cancel_out_id" json:"supply_cancel_out_id" form:"supply_cancel_out_id"`
	SupplyWarehouseDetailInfo int64       `gorm:"column:supply_warehouse_detail_info" json:"supply_warehouse_detail_info" form:"supply_warehouse_detail_info"`
	StorehouseId              int64       `gorm:"column:storehouse_id" json:"storehouse_id" form:"storehouse_id"`
	SecondWarehouseInfoId     int64       `gorm:"column:second_warehouse_info_id" json:"second_warehouse_info_id" form:"second_warehouse_info_id"`
	AdminUserId               int64       `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
	LastPrice                 float64     `gorm:"column:last_price" json:"last_price" form:"last_price"`
	StockCount                string      `gorm:"column:stock_count" json:"stock_count" form:"stock_count"`
	PharmacyId                int64       `gorm:"column:pharmacy_id" json:"pharmacy_id" form:"pharmacy_id"`
	IsRead                    int64       `gorm:"column:is_read" json:"is_read" form:"is_read"`
	OverCount                 int64       `gorm:"column:over_count" json:"over_count" form:"over_count"`
	IsCheck                   int64       `gorm:"column:is_check" json:"is_check" form:"is_check"`
	RetailPrice               float64     `gorm:"column:retail_price" json:"retail_price" form:"retail_price"`
	OrderId                   int64       `gorm:"column:order_id" json:"order_id" form:"order_id"`
	FlushOverCount            int64       `gorm:"column:flush_over_count" json:"flush_over_count" form:"flush_over_count"`
	Remark                    string      `gorm:"column:remark" json:"remark" form:"remark"`
	OperateTime               int64       `gorm:"column:operate_time" json:"operate_time" form:"operate_time"`
	BaseDrugLib               BaseDrugLib `gorm:"ForeignKey:ID;AssociationForeignKey:DrugId"json:"drug" `
}

func (XtSelfDrugFlow) TableName() string {
	return "xt_self_drug_flow"
}

type XtSelfDrugStockCount struct {
	ID             int64       `gorm:"column:id" json:"id" form:"id"`
	UserOrgId      int64       `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId      int64       `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	SumInCount     int64       `gorm:"column:sum_in_count" json:"sum_in_count" form:"sum_in_count"`
	SumOutCount    int64       `gorm:"column:sum_out_count" json:"sum_out_count" form:"sum_out_count"`
	SumCancelCount int64       `gorm:"column:sum_cancel_count" json:"sum_cancel_count" form:"sum_cancel_count"`
	DrugId         int64       `gorm:"column:drug_id" json:"drug_id" form:"drug_id"`
	Ctime          int64       `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime          int64       `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status         int64       `gorm:"column:status" json:"status" form:"status"`
	FlushCount     int64       `gorm:"column:flush_count" json:"flush_count" form:"flush_count"`
	SumActOutCount int64       `gorm:"column:sum_act_out_count" json:"sum_act_out_count" form:"sum_act_out_count"`
	SumOldCount    int64       `gorm:"column:sum_old_count" json:"sum_old_count" form:"sum_old_count"`
	BaseDrugLib    BaseDrugLib `gorm:"ForeignKey:ID;AssociationForeignKey:DrugId"json:"drug" `
}

func (XtSelfDrugStockCount) TableName() string {
	return "xt_self_drug_stock_count"
}

type XtSelfDrugWarehouseOut struct {
	ID                      int64  `gorm:"column:id" json:"id" form:"id"`
	WarehouseOutOrderNumber string `gorm:"column:warehouse_out_order_number" json:"warehouse_out_order_number" form:"warehouse_out_order_number"`
	OperationTime           int64  `gorm:"column:operation_time" json:"operation_time" form:"operation_time"`
	Creater                 int64  `gorm:"column:creater" json:"creater" form:"creater"`
	OrgId                   int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	Modifier                int64  `gorm:"column:modifier" json:"modifier" form:"modifier"`
	Remark                  string `gorm:"column:remark" json:"remark" form:"remark"`
	Ctime                   int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                   int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status                  int64  `gorm:"column:status" json:"status" form:"status"`
	WarehouseOutTime        int64  `gorm:"column:warehouse_out_time" json:"warehouse_out_time" form:"warehouse_out_time"`
	Dealer                  int64  `gorm:"column:dealer" json:"dealer" form:"dealer"`
	Manufacturer            int64  `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	Type                    int64  `gorm:"column:type" json:"type" form:"type"`
	IsSys                   int64  `gorm:"column:is_sys" json:"is_sys" form:"is_sys"`
	SupplyCancelOutId       int64  `gorm:"column:supply_cancel_out_id" json:"supply_cancel_out_id" form:"supply_cancel_out_id"`
	SupplyWarehouseId       int64  `gorm:"column:supply_warehouse_id" json:"supply_warehouse_id" form:"supply_warehouse_id"`
	StorehouseId            int64  `gorm:"column:storehouse_id" json:"storehouse_id" form:"storehouse_id"`
	SecondWarehouseId       int64  `gorm:"column:second_warehouse_id" json:"second_warehouse_id" form:"second_warehouse_id"`
	IsCheck                 int64  `gorm:"column:is_check" json:"is_check" form:"is_check"`
	OrderId                 int64  `gorm:"column:order_id" json:"order_id" form:"order_id"`
	PatientId               int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
}

func (XtSelfDrugWarehouseOut) TableName() string {
	return "xt_self_drug_warehouse_out"
}

type XtSelfDrugWarehouseOutInfo struct {
	ID                      int64       `gorm:"column:id" json:"id" form:"id"`
	WarehouseOutId          int64       `gorm:"column:warehouse_out_id" json:"warehouse_out_id" form:"warehouse_out_id"`
	DrugId                  int64       `gorm:"column:drug_id" json:"drug_id" form:"drug_id"`
	WarehousingOutTarget    int64       `gorm:"column:warehousing_out_target" json:"warehousing_out_target" form:"warehousing_out_target"`
	Count                   int64       `gorm:"column:count" json:"count" form:"count"`
	CountUnit               string      `gorm:"column:count_unit" json:"count_unit" form:"count_unit"`
	Price                   float64     `gorm:"column:price" json:"price" form:"price"`
	TotalPrice              float64     `gorm:"column:total_price" json:"total_price" form:"total_price"`
	ProductDate             int64       `gorm:"column:product_date" json:"product_date" form:"product_date"`
	ExpiryDate              int64       `gorm:"column:expiry_date" json:"expiry_date" form:"expiry_date"`
	Mtime                   int64       `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Ctime                   int64       `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Status                  int64       `gorm:"column:status" json:"status" form:"status"`
	OrgId                   int64       `gorm:"column:org_id" json:"org_id" form:"org_id"`
	Remark                  string      `gorm:"column:remark" json:"remark" form:"remark"`
	IsCancel                int64       `gorm:"column:is_cancel" json:"is_cancel" form:"is_cancel"`
	WarehouseOutOrderNumber string      `gorm:"column:warehouse_out_order_number" json:"warehouse_out_order_number" form:"warehouse_out_order_number"`
	Type                    int64       `gorm:"column:type" json:"type" form:"type"`
	Dealer                  int64       `gorm:"column:dealer" json:"dealer" form:"dealer"`
	Manufacturer            int64       `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	IsSys                   int64       `gorm:"column:is_sys" json:"is_sys" form:"is_sys"`
	SysRecordTime           int64       `gorm:"column:sys_record_time" json:"sys_record_time" form:"sys_record_time"`
	RetailPrice             float64     `gorm:"column:retail_price" json:"retail_price" form:"retail_price"`
	RetailTotalPrice        float64     `gorm:"column:retail_total_price" json:"retail_total_price" form:"retail_total_price"`
	WarehouseInfoId         int64       `gorm:"column:warehouse_info_id" json:"warehouse_info_id" form:"warehouse_info_id"`
	Number                  string      `gorm:"column:number" json:"number" form:"number"`
	BatchNumber             string      `gorm:"column:batch_number" json:"batch_number" form:"batch_number"`
	PatientId               int64       `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	AdviceId                int64       `gorm:"column:advice_id" json:"advice_id" form:"advice_id"`
	SupplyCancelOutId       int64       `gorm:"column:supply_cancel_out_id" json:"supply_cancel_out_id" form:"supply_cancel_out_id"`
	SupplyWarehouseId       int64       `gorm:"column:supply_warehouse_id" json:"supply_warehouse_id" form:"supply_warehouse_id"`
	IsSource                int64       `gorm:"column:is_source" json:"is_source" form:"is_source"`
	StorehouseId            int64       `gorm:"column:storehouse_id" json:"storehouse_id" form:"storehouse_id"`
	SecondWarehouseInfoId   int64       `gorm:"column:second_warehouse_info_id" json:"second_warehouse_info_id" form:"second_warehouse_info_id"`
	AdminUserId             int64       `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
	LastPrice               float64     `gorm:"column:last_price" json:"last_price" form:"last_price"`
	StockCount              string      `gorm:"column:stock_count" json:"stock_count" form:"stock_count"`
	PharmacyId              int64       `gorm:"column:pharmacy_id" json:"pharmacy_id" form:"pharmacy_id"`
	IsCheck                 int64       `gorm:"column:is_check" json:"is_check" form:"is_check"`
	OverCount               int64       `gorm:"column:over_count" json:"over_count" form:"over_count"`
	OrderId                 int64       `gorm:"column:order_id" json:"order_id" form:"order_id"`
	ManafacturerName        string      `gorm:"column:manafacturer_name" json:"manafacturer_name" form:"manafacturer_name"`
	DepartmentName          string      `gorm:"column:department_name" json:"department_name" form:"department_name"`
	ClassType               string      `gorm:"column:class_type" json:"class_type" form:"class_type"`
	BaseDrugLib             BaseDrugLib `gorm:"ForeignKey:ID;AssociationForeignKey:DrugId"json:"drug" `
}

func (XtSelfDrugWarehouseOutInfo) TableName() string {
	return "xt_self_drug_warehouse_out_info"
}
