package models

type NewDrugFlow struct {
	ID                        int64                  `gorm:"column:id" json:"id" form:"id"`
	WarehousingId             int64                  `gorm:"column:warehousing_id" json:"warehousing_id" form:"warehousing_id"`
	DrugId                    int64                  `gorm:"column:drug_id" json:"drug_id" form:"drug_id"`
	Number                    string                 `gorm:"column:number" json:"number" form:"number"`
	BatchNumber               string                 `gorm:"column:batch_number" json:"batch_number" form:"batch_number"`
	Count                     int64                  `gorm:"column:count" json:"count" form:"count"`
	UserOrgId                 int64                  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId                 int64                  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	SystemTime                int64                  `gorm:"column:system_time" json:"system_time" form:"system_time"`
	ConsumableType            int64                  `gorm:"column:consumable_type" json:"consumable_type" form:"consumable_type"`
	IsSys                     int64                  `gorm:"column:is_sys" json:"is_sys" form:"is_sys"`
	WarehousingOrder          string                 `gorm:"column:warehousing_order" json:"warehousing_order" form:"warehousing_order"`
	WarehouseOutId            int64                  `gorm:"column:warehouse_out_id" json:"warehouse_out_id" form:"warehouse_out_id"`
	WarehouseOutOrderNumber   string                 `gorm:"column:warehouse_out_order_number" json:"warehouse_out_order_number" form:"warehouse_out_order_number"`
	IsEdit                    int64                  `gorm:"column:is_edit" json:"is_edit" form:"is_edit"`
	CancelStockId             int64                  `gorm:"column:cancel_stock_id" json:"cancel_stock_id" form:"cancel_stock_id"`
	CancelOrderNumber         string                 `gorm:"column:cancel_order_number" json:"cancel_order_number" form:"cancel_order_number"`
	Manufacturer              int64                  `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	Dealer                    int64                  `gorm:"column:dealer" json:"dealer" form:"dealer"`
	Creator                   int64                  `gorm:"column:creator" json:"creator" form:"creator"`
	UpdateCreator             int64                  `gorm:"column:update_creator" json:"update_creator" form:"update_creator"`
	Status                    int64                  `gorm:"column:status" json:"status" form:"status"`
	Ctime                     int64                  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                     int64                  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Price                     float64                `gorm:"column:price" json:"price" form:"price"`
	WarehousingDetailId       int64                  `gorm:"column:warehousing_detail_id" json:"warehousing_detail_id" form:"warehousing_detail_id"`
	WarehouseOutDetailId      int64                  `gorm:"column:warehouse_out_detail_id" json:"warehouse_out_detail_id" form:"warehouse_out_detail_id"`
	CancelOutDetailId         int64                  `gorm:"column:cancel_out_detail_id" json:"cancel_out_detail_id" form:"cancel_out_detail_id"`
	ExpireDate                int64                  `gorm:"column:expire_date" json:"expire_date" form:"expire_date"`
	ProductDate               int64                  `gorm:"column:product_date" json:"product_date" form:"product_date"`
	MaxUnit                   string                 `gorm:"column:max_unit" json:"max_unit" form:"max_unit"`
	MinUnit                   string                 `gorm:"column:min_unit" json:"min_unit" form:"min_unit"`
	StockMaxNumber            int64                  `gorm:"column:stock_max_number" json:"stock_max_number" form:"stock_max_number"`
	StockMinNumber            int64                  `gorm:"column:stock_min_number" json:"stock_min_number" form:"stock_min_number"`
	LastStockMaxNumber        int64                  `gorm:"column:last_stock_max_number" json:"last_stock_max_number" form:"last_stock_max_number"`
	LastStockMinNumber        int64                  `gorm:"column:last_stock_min_number" json:"last_stock_min_number" form:"last_stock_min_number"`
	DrugWarehouseInfo         []*DrugWarehouseInfo   `gorm:"ForeignKey:DrugId;AssociationForeignKey:DrugId" `
	BaseDrugLib               BaseDrugLib            `gorm:"ForeignKey:ID;AssociationForeignKey:DrugId" `
	AdviceId                  int64                  `gorm:"column:advice_id" json:"advice_id" form:"advice_id"`
	SupplyWarehouseId         int64                  `gorm:"column:supply_warehouse_id" json:"supply_warehouse_id" form:"supply_warehouse_id"`
	SupplyCancelOutId         int64                  `gorm:"column:supply_cancel_out_id" json:"supply_cancel_out_id" form:"supply_cancel_out_id"`
	SupplyWarehouseDetailInfo int64                  `gorm:"column:supply_warehouse_detail_info" json:"supply_warehouse_detail_info" form:"supply_warehouse_detail_info"`
	StorehouseId              int64                  `gorm:"column:storehouse_id" json:"storehouse_id" form:"storehouse_id"`
	SecondWarehouseInfoId     int64                  `gorm:"column:second_warehouse_info_id" json:"second_warehouse_info_id" form:"second_warehouse_info_id"`
	AdminUserId               int64                  `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
	LastPrice                 float64                `gorm:"column:last_price" json:"last_price" form:"last_price"`
	StockCount                string                 `gorm:"column:stock_count" json:"stock_count" form:"stock_count"`
	PharmacyId                int64                  `gorm:"column:pharmacy_id" json:"pharmacy_id" form:"pharmacy_id"`
	DrugWarehouseInfoOne      DrugWarehouseInfo      `gorm:"ForeignKey:ID;AssociationForeignKey:WarehousingDetailId"json:"xt_drug_warehouse_info" `
	IsRead                    int64                  `gorm:"column:is_read" json:"is_read" form:"is_read"`
	IsCheck                   int64                  `gorm:"column:is_check" json:"is_check" form:"is_check"`
	OverCount                 int64                  `gorm:"column:over_count" json:"over_count" form:"over_count"`
	RetailPrice               float64                `gorm:"column:retail_price" json:"retail_price" form:"retail_price"`
	XtDrugWarehouseOutInfo    XtDrugWarehouseOutInfo `gorm:"ForeignKey:ID;AssociationForeignKey:WarehouseOutDetailId"json:"xt_drug_warehouse_out_info" `
	OrderId                   int64                  `gorm:"column:order_id" json:"order_id" form:"order_id"`
	FlushOverCount            int64                  `gorm:"column:flush_over_count" json:"flush_over_count" form:"flush_over_count"`
	Remark                    string                 `gorm:"column:remark" json:"remark" form:"remark"`
	DrugCode                  string                 `gorm:"column:drug_code" json:"drug_code" form:"drug_code"`
	OperateTime               int64                  `gorm:"column:operate_time" json:"operate_time" form:"operate_time"`
	SaleDate                  string                 `gorm:"column:sale_date" json:"sale_date" form:"sale_date"`
	IsSale                    int64                  `gorm:"column:is_sale" json:"is_sale" form:"is_sale"`
	IsChange                  int64                  `gorm:"column:is_change" json:"is_change" form:"is_change"`
	Bchno                     string                 `gorm:"column:bchno" json:"bchno" form:"bchno"`
	BgBchno                   string                 `gorm:"column:bg_bchno" json:"bg_bchno" form:"bg_bchno"`
	HisDoctorAdviceInfo       HisDoctorAdviceInfo    `gorm:"ForeignKey:PatientId,AdviceDate,DrugId;AssociationForeignKey:PatientId,SystemTime,DrugId"json:"his_advice_info" `
	PCount                    float64
	SDate                     string
	PDate                     int64
	Unit                      string
}

func (NewDrugFlow) TableName() string {
	return "xt_drug_flow"
}
