package models

type DrugWarehouseInfoTenOne struct {
	ID               int64   `gorm:"column:id" json:"id" form:"id"`
	WarehousingId    int64   `gorm:"column:warehousing_id" json:"warehousing_id" form:"warehousing_id"`
	DrugId           int64   `gorm:"column:drug_id" json:"drug_id" form:"drug_id"`
	Number           string  `gorm:"column:number" json:"number" form:"number"`
	ProductDate      int64   `gorm:"column:product_date" json:"product_date" form:"product_date"`
	ExpiryDate       int64   `gorm:"column:expiry_date" json:"expiry_date" form:"expiry_date"`
	WarehousingCount int64   `gorm:"column:warehousing_count" json:"warehousing_count" form:"warehousing_count"`
	Price            float64 `gorm:"column:price" json:"price" form:"price"`
	TotalPrice       float64 `gorm:"column:total_price" json:"total_price" form:"total_price"`
	Dealer           int64   `gorm:"column:dealer" json:"dealer" form:"dealer"`
	Manufacturer     int64   `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	Remark           string  `gorm:"column:remark" json:"remark" form:"remark"`
	Ctime            int64   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime            int64   `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status           int64   `gorm:"column:status" json:"status" form:"status"`
	OrgId            int64   `gorm:"column:org_id" json:"org_id" form:"org_id"`
	IsReturn         int64   `gorm:"column:is_return" json:"is_return" form:"is_return"`
	WarehousingOrder string  `gorm:"column:warehousing_order" json:"warehousing_order" form:"warehousing_order"`
	Type             int64   `gorm:"column:type" json:"type" form:"type"`
	RetailPrice      float64 `gorm:"column:retail_price" json:"retail_price" form:"retail_price"`
	RetailTotalPrice float64 `gorm:"column:retail_total_price" json:"retail_total_price" form:"retail_total_price"`
	BatchNumber      string  `gorm:"column:batch_number" json:"batch_number" form:"batch_number"`
	MaxUnit          string  `gorm:"column:max_unit" json:"max_unit" form:"max_unit"`
	MinUnit          string  `gorm:"column:min_unit" json:"min_unit" form:"min_unit"`
	DrugCode         string  `gorm:"column:drug_code" json:"drug_code" form:"drug_code"`

	//Base                      Drug    `gorm:"ForeignKey:DrugId;AssociationForeignKey:ID" json:"drug"`
	BaseDrugLib               BaseDrugLib `gorm:"ForeignKey:DrugId;AssociationForeignKey:ID"json:"drug" `
	SupplyWarehouseId         int64       `gorm:"column:supply_warehouse_id" json:"supply_warehouse_id" form:"supply_warehouse_id"`
	SupplyWarehouseDetailInfo int64       `gorm:"column:supply_warehouse_detail_info" json:"supply_warehouse_detail_info" form:"supply_warehouse_detail_info"`
	StorehouseId              int64       `gorm:"column:storehouse_id" json:"storehouse_id" form:"storehouse_id"`
	PcDate                    int64       `gorm:"column:pc_date" json:"pc_date" form:"pc_date"`
	IsPc                      int64       `gorm:"column:is_pc" json:"is_pc" form:"is_pc"`
	IsBg                      int64       `gorm:"column:is_bg" json:"is_bg" form:"is_bg"`
	BgBchno                   string      `gorm:"column:bg_bchno" json:"bg_bchno" form:"bg_bchno"`
}

func (DrugWarehouseInfoTenOne) TableName() string {
	return "xt_drug_warehouse_info"
}
