package models

type NewContract struct {
	ContractId string `json:"contractId"`
	Signers    []struct {
		UserId       string `json:"userId"`
		SignerType   int64  `json:"signerType"`
		EnterpriseId string `json:"enterpriseId"`
		Sequence     string `json:"sequence"`
		SendMsg      string `json:"sendMsg"`
		SignFiles    []struct {
			DocId          float64 `json:"docId"`
			XySignControls []struct {
				Key       string `json:"key"`
				Type      string `json:"type"`
				PageNum   int64  `json:"pageNum"`
				PositionX int64  `json:"positionX"`
				PositionY int64  `json:"positionY"`
			} `json:"xySignControls"`
			KeywordSignControls []struct {
				Key     string `json:"key"`
				Type    string `json:"type"`
				PageNum int64  `json:"pageNum"`
				OffsetX int64  `json:"offsetX"`
				OffsetY int64  `json:"offsetY"`
			} `json:"keywordSignControls"`
		} `json:"signFiles"`
	}
}

type XySignControls struct {
	Key       string `json:"key"`
	Type      string `json:"type"`
	PageNum   int64  `json:"pageNum"`
	PositionX int64  `json:"positionX"`
	PositionY int64  `json:"positionY"`
}

type KeywordSignControls struct {
	Key     string `json:"key"`
	Type    string `json:"type"`
	PageNum int64  `json:"pageNum"`
	KeyWord string `json:"KeyWord"`
	OffsetX int64  `json:"offsetX"`
	OffsetY int64  `json:"offsetY"`
}

type SignFiles struct {
	DocId          float64 `json:"343465645"`
	XySignControls []struct {
		Key       string `json:"key"`
		Type      string `json:"type"`
		PageNum   string `json:"pageNum"`
		PositionX string `json:"positionX"`
		PositionY string `json:"positionY"`
	} `json:"xySignControls"`
	KeywordSignControls []struct {
		Key       string `json:"key"`
		Type      string `json:"type"`
		PageNum   string `json:"pageNum"`
		KeyWord   string `json:"KeyWord"`
		PositionX string `json:"positionX"`
		PositionY string `json:"positionY"`
	} `json:"keywordSignControls"`
}

type Signers struct {
	UserId       string `json:"userId"`
	SignerType   int64  `json:"signerType"`
	EnterpriseId string `json:"enterpriseId"`
	Sequence     string `json:"sequence"`
	SendMsg      string `json:"sendMsg"`
	SignFiles    []struct {
		DocId          float64 `json:"docId"`
		XySignControls []struct {
			Key       string `json:"key"`
			Type      string `json:"type"`
			PageNum   int64  `json:"pageNum"`
			PositionX int64  `json:"positionX"`
			PositionY int64  `json:"positionY"`
		} `json:"xySignControls"`
		KeywordSignControls []struct {
			Key     string `json:"key"`
			Type    string `json:"type"`
			PageNum int64  `json:"pageNum"`
			OffsetX int64  `json:"offsetX"`
			OffsetY int64  `json:"offsetY"`
		} `json:"keywordSignControls"`
	} `json:"signFiles"`
}

type XtDeviceEnterprise struct {
	ID              int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId       int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	OrgType         int64  `gorm:"column:org_type" json:"org_type" form:"org_type"`
	EnterpriseName  string `gorm:"column:enterprise_name" json:"enterprise_name" form:"enterprise_name"`
	Code            string `gorm:"column:code" json:"code" form:"code"`
	OrgCode         string `gorm:"column:org_code" json:"org_code" form:"org_code"`
	LegalPersonName string `gorm:"column:legal_person_name" json:"legal_person_name" form:"legal_person_name"`
	LegalIdCardNum  string `gorm:"column:legal_id_card_num" json:"legal_id_card_num" form:"legal_id_card_num"`
	LegalPhone      string `gorm:"column:legal_phone" json:"legal_phone" form:"legal_phone"`
	Creater         int64  `gorm:"column:creater" json:"creater" form:"creater"`
	Ctime           int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime           int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Enterpriseid    string `gorm:"column:enterprise_id" json:"enterprise_id" form:"enterprise_id"`
	Status          int64  `gorm:"column:status" json:"status" form:"status"`
}

func (XtDeviceEnterprise) TableName() string {
	return "xt_device_enterprise"
}

type XtDevicePersonEnterprise struct {
	ID           int64  `gorm:"column:id" json:"id" form:"id"`
	AdminUserId  int64  `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
	DisplayName  string `gorm:"column:display_name" json:"display_name" form:"display_name"`
	Phone        string `gorm:"column:phone" json:"phone" form:"phone"`
	IdCardNum    string `gorm:"column:id_card_num" json:"id_card_num" form:"id_card_num"`
	UserOrgId    int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status       int64  `gorm:"column:status" json:"status" form:"status"`
	Creater      int64  `gorm:"column:creater" json:"creater" form:"creater"`
	Ctime        int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime        int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	UserId       string `gorm:"column:user_id" json:"user_id" form:"user_id"`
	Personsealid string `gorm:"column:person_seal_id" json:"person_seal_id" form:"person_seal_id"`
	Sealid       string `gorm:"column:seal_id" json:"seal_id" form:"seal_id"`
	UserName     string `gorm:"column:user_name" json:"user_name" form:"user_name"`
	Sealbase64   string `gorm:"column:sealbase64" json:"sealbase64" form:"sealbase64"`
}

func (XtDevicePersonEnterprise) TableName() string {
	return "xt_device_person_enterprise"
}
