package models

type PatientListForFaceList struct {
	ID          int64 `gorm:"column:id" json:"id" form:"id"`
	UpdatedTime int64 `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
}

func (PatientListForFaceList) TableName() string {
	return "xt_patients"
}

type MSchedualPatientList struct {
	ID                 int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId          int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	UserId             int64  `gorm:"column:user_id" json:"user_id" form:"user_id"`
	PatientType        int64  `gorm:"column:patient_type" json:"patient_type" form:"patient_type"`
	DialysisNo         string `gorm:"column:dialysis_no" json:"dialysis_no" form:"dialysis_no"`
	Avatar             string `gorm:"column:avatar" json:"avatar" form:"avatar"`
	Gender             int64  `gorm:"column:gender" json:"gender" form:"gender"`
	Birthday           int64  `gorm:"column:birthday" json:"birthday" form:"birthday"`
	Age                int64  `gorm:"column:age" json:"age"`
	Name               string `gorm:"column:name" json:"name" form:"name"`
	IdCardNo           string `gorm:"column:id_card_no" json:"id_card_no" form:"id_card_no"`
	UserSysBeforeCount int64  `gorm:"column:user_sys_before_count" json:"user_sys_before_count" form:"user_sys_before_count"`
	TrobleShoot        int64  `gorm:"column:troble_shoot" json:"troble_shoot" form:"troble_shoot"`
	SchRemark          string `gorm:"column:sch_remark" json:"sch_remark" form:"sch_remark"`
	ScheduleRemark     string `gorm:"column:schedule_remark" json:"schedule_remark" form:"schedule_remark"`
	FirstLetter        string `gorm:"column:first_letter" json:"first_letter" form:"first_letter"`
	IsInfectious       int64  `gorm:"column:is_infectious" json:"is_infectious" form:"is_infectious"`
}

func (MSchedualPatientList) TableName() string {
	return "xt_patients"
}

type MDialysisOrderForList struct {
	ID           int64 `gorm:"column:id" json:"id"`
	DialysisDate int64 `gorm:"column:dialysis_date" json:"dialysis_date"`
	UserOrgId    int64 `gorm:"column:user_org_id" json:"user_org_id"`
	PatientId    int64 `gorm:"column:patient_id" json:"patient_id"`
	// PrescriptionId int64  `gorm:"column:prescription_id" json:"prescription_id"`
	Stage int64 `gorm:"column:stage" json:"stage"`
	// Remark         string `gorm:"column:remark" json:"remark"`
	BedID              int64                 `gorm:"column:bed_id" json:"bed_id"`
	StartNurse         int64                 `gorm:"column:start_nurse" json:"start_nurse"`
	Status             int64                 `gorm:"column:status" json:"status"`
	DeviceNumber       *MDeviceNumberForList `gorm:"ForeignKey:BedID" json:"device_number"`
	Creator            int64                 `gorm:"column:creator" json:"creator"`
	WashpipeNurse      int64                 `gorm:"column:washpipe_nurse" json:"washpipe_nurse" form:"washpipe_nurse"`
	NucleinDate        int64                 `gorm:"column:nuclein_date" json:"nuclein_date" form:"nuclein_date"`
	EndTime            int64                 `gorm:"column:end_time" json:"end_time" form:"end_time"`
	DialysisIrrigation string                `gorm:"column:dialysis_irrigation" json:"dialysis_irrigation" form:"dialysis_irrigation"`
	DialysisDialyszers string                `gorm:"column:dialysis_dialyszers" json:"dialysis_dialyszers" form:"dialysis_dialyszers"`
	ScheduleRemark     string                `gorm:"column:schedule_remark" json:"schedule_remark" form:"schedule_remark"`
	Url                string                `gorm:"column:url" json:"url" form:"url"`
}

func (MDialysisOrderForList) TableName() string {
	return "xt_dialysis_order"
}

type MDialysisOrderForListSix struct {
	ID                 int64  `gorm:"column:id" json:"id"`
	DialysisDate       int64  `gorm:"column:dialysis_date" json:"dialysis_date"`
	UserOrgId          int64  `gorm:"column:user_org_id" json:"user_org_id"`
	PatientId          int64  `gorm:"column:patient_id" json:"patient_id"`
	Stage              int64  `gorm:"column:stage" json:"stage"`
	BedID              int64  `gorm:"column:bed_id" json:"bed_id"`
	StartNurse         int64  `gorm:"column:start_nurse" json:"start_nurse"`
	Status             int64  `gorm:"column:status" json:"status"`
	Creator            int64  `gorm:"column:creator" json:"creator"`
	WashpipeNurse      int64  `gorm:"column:washpipe_nurse" json:"washpipe_nurse" form:"washpipe_nurse"`
	NucleinDate        int64  `gorm:"column:nuclein_date" json:"nuclein_date" form:"nuclein_date"`
	EndTime            int64  `gorm:"column:end_time" json:"end_time" form:"end_time"`
	DialysisIrrigation string `gorm:"column:dialysis_irrigation" json:"dialysis_irrigation" form:"dialysis_irrigation"`
	DialysisDialyszers string `gorm:"column:dialysis_dialyszers" json:"dialysis_dialyszers" form:"dialysis_dialyszers"`
}

func (MDialysisOrderForListSix) TableName() string {
	return "xt_dialysis_order"
}

type VMTreatmentSummaryForList struct {
	ID              int64  `gorm:"column:id" json:"id"`
	UserOrgId       int64  `gorm:"column:user_org_id" json:"user_org_id"`
	PatientId       int64  `gorm:"column:patient_id" json:"patient_id"`
	AssessmentDate  int64  `gorm:"column:assessment_date" json:"assessment_date"`
	DialysisSummary string `gorm:"column:dialysis_summary" json:"dialysis_summary" form:"dialysis_summary"`
}

func (VMTreatmentSummaryForList) TableName() string {
	return "xt_treatment_summary"
}

type VMDoctorAdviceForList struct {
	ID             int64 `gorm:"column:id" json:"id" form:"id"`
	GroupNo        int64 `gorm:"column:groupno" json:"groupno" form:"groupno"`
	UserOrgId      int64 `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId      int64 `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	AdviceDate     int64 `gorm:"column:advice_date" json:"advice_date" form:"advice_date"`
	Status         int64 `gorm:"column:status" json:"status" form:"status"`
	ExecutionState int64 `gorm:"column:execution_state" json:"execution_state" form:"execution_state"`
	RecordDate     int64 `gorm:"column:record_date" json:"record_date"`
	CheckTime      int64 `gorm:"column:check_time" json:"check_time" form:"check_time"`
	CheckState     int64 `gorm:"column:check_state" json:"check_state" form:"check_state"`
	ParentId       int64 `gorm:"column:parent_id" json:"parent_id" form:"parent_id"`
}

func (VMDoctorAdviceForList) TableName() string {
	return "xt_doctor_advice"
}

type PatientListForFace struct {
	ID          int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId   int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Name        string `gorm:"column:name" json:"name" form:"name"`
	Avatar      string `gorm:"column:avatar" json:"avatar" form:"avatar"`
	DialysisNo  string `gorm:"column:dialysis_no" json:"dialysis_no" form:"dialysis_no"`
	IdCardNo    string `gorm:"column:id_card_no" json:"id_card_no" form:"id_card_no"`
	Birthday    int64  `gorm:"column:birthday" json:"birthday" form:"birthday"`
	Phone       string `gorm:"column:phone" json:"phone" form:"phone"`
	Age         int64  `gorm:"column:age" json:"age"`
	CreatedTime int64  `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime int64  `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
}

func (PatientListForFace) TableName() string {
	return "xt_patients"
}

type Patients struct {
	ID                           int64                `gorm:"column:id" json:"id" form:"id"`
	UserOrgId                    int64                `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	UserId                       int64                `gorm:"column:user_id" json:"user_id" form:"user_id"`
	Avatar                       string               `gorm:"column:avatar" json:"avatar" form:"avatar"`
	PatientType                  int64                `gorm:"column:patient_type" json:"patient_type" form:"patient_type"`
	DialysisNo                   string               `gorm:"column:dialysis_no" json:"dialysis_no" form:"dialysis_no"`
	AdmissionNumber              string               `gorm:"column:admission_number" json:"admission_number" form:"admission_number"`
	Source                       int64                `gorm:"column:source" json:"source" form:"source"`
	Lapseto                      int64                `gorm:"column:lapseto" json:"lapseto" form:"lapseto"`
	PartitionId                  int64                `gorm:"column:partition_id" json:"partition_id" form:"partition_id"`
	BedId                        int64                `gorm:"column:bed_id" json:"bed_id" form:"bed_id"`
	Name                         string               `gorm:"column:name" json:"name" form:"name"`
	Alias                        string               `gorm:"column:alias" json:"alias" form:"alias"`
	Gender                       int64                `gorm:"column:gender" json:"gender" form:"gender"`
	Nation                       string               `gorm:"column:nation" json:"nation" form:"nation"`
	NativePlace                  string               `gorm:"column:native_place" json:"native_place" form:"native_place"`
	MaritalStatus                int64                `gorm:"column:marital_status" json:"marital_status" form:"marital_status"`
	IdCardNo                     string               `gorm:"column:id_card_no" json:"id_card_no" form:"id_card_no"`
	Birthday                     int64                `gorm:"column:birthday" json:"birthday" form:"birthday"`
	ReimbursementWayId           int64                `gorm:"column:reimbursement_way_id" json:"reimbursement_way_id" form:"reimbursement_way_id"`
	HealthCareType               int64                `gorm:"column:health_care_type" json:"health_care_type" form:"health_care_type"`
	HealthCareNo                 string               `gorm:"column:health_care_no" json:"health_care_no" form:"health_care_no"`
	HealthCareDueDate            int64                `gorm:"column:health_care_due_date" json:"health_care_due_date" form:"health_care_due_date"`
	Height                       int64                `gorm:"column:height" json:"height" form:"height"`
	BloodType                    int64                `gorm:"column:blood_type" json:"blood_type" form:"blood_type"`
	Rh                           int64                `gorm:"column:rh" json:"rh" form:"rh"`
	HealthCareDueAlertDate       int64                `gorm:"column:health_care_due_alert_date" json:"health_care_due_alert_date" form:"health_care_due_alert_date"`
	EducationLevel               int64                `gorm:"column:education_level" json:"education_level" form:"education_level"`
	Profession                   int64                `gorm:"column:profession" json:"profession" form:"profession"`
	Phone                        string               `gorm:"column:phone" json:"phone" form:"phone"`
	HomeTelephone                string               `gorm:"column:home_telephone" json:"home_telephone" form:"home_telephone"`
	RelativePhone                string               `gorm:"column:relative_phone" json:"relative_phone" form:"relative_phone"`
	RelativeRelations            string               `gorm:"column:relative_relations" json:"relative_relations" form:"relative_relations"`
	HomeAddress                  string               `gorm:"column:home_address" json:"home_address" form:"home_address"`
	WorkUnit                     string               `gorm:"column:work_unit" json:"work_unit" form:"work_unit"`
	UnitAddress                  string               `gorm:"column:unit_address" json:"unit_address" form:"unit_address"`
	Children                     int64                `gorm:"column:children" json:"children" form:"children"`
	ReceivingDate                int64                `gorm:"column:receiving_date" json:"receiving_date" form:"receiving_date"`
	IsHospitalFirstDialysis      int64                `gorm:"column:is_hospital_first_dialysis" json:"is_hospital_first_dialysis" form:"is_hospital_first_dialysis"`
	FirstDialysisDate            int64                `gorm:"column:first_dialysis_date" json:"first_dialysis_date" form:"first_dialysis_date"`
	FirstDialysisHospital        string               `gorm:"column:first_dialysis_hospital" json:"first_dialysis_hospital" form:"first_dialysis_hospital"`
	PredialysisCondition         string               `gorm:"column:predialysis_condition" json:"predialysis_condition" form:"predialysis_condition"`
	PreHospitalDialysisFrequency string               `gorm:"column:pre_hospital_dialysis_frequency" json:"pre_hospital_dialysis_frequency" form:"pre_hospital_dialysis_frequency"`
	PreHospitalDialysisTimes     int64                `gorm:"column:pre_hospital_dialysis_times" json:"pre_hospital_dialysis_times" form:"pre_hospital_dialysis_times"`
	HospitalFirstDialysisDate    int64                `gorm:"column:hospital_first_dialysis_date" json:"hospital_first_dialysis_date" form:"hospital_first_dialysis_date"`
	InductionPeriod              int64                `gorm:"column:induction_period" json:"induction_period" form:"induction_period"`
	InitialDialysis              int64                `gorm:"column:initial_dialysis" json:"initial_dialysis" form:"initial_dialysis"`
	TotalDialysis                int64                `gorm:"column:total_dialysis" json:"total_dialysis" form:"total_dialysis"`
	AttendingDoctorId            int64                `gorm:"column:attending_doctor_id" json:"attending_doctor_id" form:"attending_doctor_id"`
	HeadNurseId                  int64                `gorm:"column:head_nurse_id" json:"head_nurse_id" form:"head_nurse_id"`
	Evaluate                     string               `gorm:"column:evaluate" json:"evaluate" form:"evaluate"`
	Diagnose                     string               `gorm:"column:diagnose" json:"diagnose" form:"diagnose"`
	Remark                       string               `gorm:"column:remark" json:"remark" form:"remark"`
	RegistrarsId                 int64                `gorm:"column:registrars_id" json:"registrars_id" form:"registrars_id"`
	Registrars                   string               `gorm:"column:registrars" json:"registrars" form:"registrars"`
	QrCode                       string               `gorm:"column:qr_code" json:"qr_code" form:"qr_code"`
	BindingState                 int64                `gorm:"column:binding_state" json:"binding_state" form:"binding_state"`
	PatientComplains             string               `gorm:"column:patient_complains" json:"patient_complains"` // 主诉
	PresentHistory               string               `gorm:"column:present_history" json:"present_history"`     // 现病史
	PastHistory                  string               `gorm:"column:past_history" json:"past_history"`           // 既往史
	Temperature                  float64              `gorm:"column:temperature" json:"temperature"`             // 体格检查-体温
	Pulse                        int64                `gorm:"column:pulse" json:"pulse"`                         // 体格检查-脉搏
	Respiratory                  int64                `gorm:"column:respiratory" json:"respiratory"`             // 体格检查-呼吸频率
	SBP                          int64                `gorm:"column:sbp" json:"sbp"`                             // 体格检查-收缩压
	DBP                          int64                `gorm:"column:dbp" json:"dbp"`                             // 体格检查-舒张压
	Status                       int64                `gorm:"column:status" json:"status" form:"status"`
	CreatedTime                  int64                `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime                  int64                `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	DialysisSolutions            []DialysisSolution   `json:"solutions" gorm:"foreignkey:PatientId"`
	Age                          int64                `gorm:"column:age" json:"age"`
	Schedules                    []Schedule           `json:"schedules" gorm:"foreignkey:PatientId"`
	Contagions                   []InfectiousDiseases `json:"contagions" gorm:"foreignkey:PatientId"`
	Diseases                     []ChronicDiseases    `json:"diseases" gorm:"foreignkey:PatientId"`

	InfectiousNextRecordTime int64   `gorm:"column:infectious_next_record_time" json:"infectious_next_record_time"`
	IsInfectious             int64   `gorm:"column:is_infectious" json:"is_infectious"`
	RemindCycle              int64   `gorm:"column:remind_cycle" json:"remind_cycle"`
	ResponseResult           string  `gorm:"column:response_result" json:"response_result"`
	IsOpenRemind             int64   `gorm:"column:is_open_remind" json:"is_open_remind"`
	DialysisAge              int64   `gorm:"column:dialysis_age" json:"dialysis_age" form:"dialysis_age"`
	ExpenseKind              int64   `gorm:"column:expense_kind" json:"expense_kind" form:"expense_kind"`
	TellPhone                string  `gorm:"column:tell_phone" json:"tell_phone" form:"tell_phone"`
	FirstTreatmentDate       int64   `gorm:"column:first_treatment_date" json:"first_treatment_date" form:"first_treatment_date"`
	ContactName              string  `gorm:"column:contact_name" json:"contact_name" form:"contact_name"`
	UserSysBeforeCount       int64   `gorm:"column:user_sys_before_count" json:"user_sys_before_count" form:"user_sys_before_count"`
	IsExcelExport            int64   `gorm:"column:is_excel_export" json:"is_excel_export" form:"is_excel_export"`
	SchRemark                string  `gorm:"column:sch_remark" json:"sch_remark" form:"sch_remark"`
	OutReason                string  `gorm:"column:out_reason" json:"out_reason" form:"out_reason"`
	DeathTime                int64   `gorm:"column:death_time" json:"death_time" form:"death_time"`
	TrobleShoot              int64   `gorm:"column:troble_shoot" json:"troble_shoot" form:"troble_shoot"`
	ContagionIds             []int64 `gorm:"-"`
	DryWeight                float64 `gorm:"-"`
	ZbPatientId              string  `gorm:"column:zb_patient_id" json:"zb_patient_id" form:"zb_patient_id"`
	TreatmentPlan            string  `gorm:"column:treatment_plan" json:"treatment_plan" form:"treatment_plan"`
	Doctor                   int64   `gorm:"column:doctor" json:"doctor" form:"doctor"`
	RecordNumber             string  `gorm:"column:record_number" json:"record_number" form:"record_number"`
	PatientSource            int64   `gorm:"column:patient_source" json:"patient_source" form:"patient_source"`
	PatientStartTime         int64   `gorm:"column:patient_start_time" json:"patient_start_time" form:"patient_start_time"`
	PatientEndTime           int64   `gorm:"column:patient_end_time" json:"patient_end_time" form:"patient_end_time"`
	InfectiousRemark         string  `gorm:"column:infectious_remark" json:"infectious_remark" form:"infectious_remark"`
	AllergicHistory          string  `gorm:"column:allergic_history" json:"allergic_history" form:"allergic_history"`
	PatientAddress           string  `gorm:"column:patient_address" json:"patient_address" form:"patient_address"`
	FirstLetter              string  `gorm:"column:first_letter" json:"first_letter" form:"first_letter"`
	PrintDate                int64   `gorm:"column:print_date" json:"print_date" form:"print_date"`
	FamalityRecord           string  `gorm:"column:famality_record" json:"famality_record" form:"famality_record"`
	InsuplcAdmdvs            string  `gorm:"column:insuplc_admdvs" json:"insuplc_admdvs" form:"insuplc_admdvs"`
}

func (Patients) TableName() string {
	return "xt_patients"
}

type ChronicDiseases struct {
	ID          int64 `gorm:"column:id" json:"id" form:"id"`
	PatientId   int64 `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	DiseaseId   int64 `gorm:"column:disease_id" json:"disease_id" form:"disease_id"`
	Status      int64 `gorm:"column:status" json:"status" form:"status"`
	CreatedTime int64 `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime int64 `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
}

func (ChronicDiseases) TableName() string {
	return "xt_patients_chronic_diseases"
}

type InfectiousDiseases struct {
	ID          int64 `gorm:"column:id" json:"id" form:"id"`
	PatientId   int64 `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	DiseaseId   int64 `gorm:"column:disease_id" json:"disease_id" form:"disease_id"`
	Status      int64 `gorm:"column:status" json:"status" form:"status"`
	CreatedTime int64 `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime int64 `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
}

func (InfectiousDiseases) TableName() string {
	return "xt_patients_infectious_diseases"
}

type DialysisPrescription struct {
	ID                        int64   `gorm:"column:id" json:"id"`
	UserOrgId                 int64   `gorm:"column:user_org_id" json:"user_org_id"`
	PatientId                 int64   `gorm:"column:patient_id" json:"patient_id"`
	Dialyzer                  int64   `gorm:"column:dialyzer" json:"dialyzer"`
	MachineType               string  `gorm:"column:machine_type" json:"machine_type"`
	DewaterAmount             float64 `gorm:"column:dewater_amount" json:"dewater_amount"`
	PrescriptionDewatering    float64 `gorm:"column:prescription_dewatering" json:"prescription_dewatering"`
	Anticoagulant             int64   `gorm:"column:anticoagulant" json:"anticoagulant"`
	AnticoagulantShouji       float64 `gorm:"column:anticoagulant_shouji" json:"anticoagulant_shouji"`
	AnticoagulantWeichi       float64 `gorm:"column:anticoagulant_weichi" json:"anticoagulant_weichi"`
	AnticoagulantZongliang    float64 `gorm:"column:anticoagulant_zongliang" json:"anticoagulant_zongliang"`
	AnticoagulantGaimingcheng string  `gorm:"column:anticoagulant_gaimingcheng" json:"anticoagulant_gaimingcheng"`
	AnticoagulantGaijiliang   string  `gorm:"column:anticoagulant_gaijiliang" json:"anticoagulant_gaijiliang"`
	ModeId                    int64   `gorm:"column:mode_id" json:"mode_id"`
	DialysisDuration          float64 `gorm:"column:dialysis_duration" json:"dialysis_duration"`
	ReplacementTotal          float64 `gorm:"column:replacement_total" json:"replacement_total"`
	ReplacementWay            int64   `gorm:"column:replacement_way" json:"replacement_way"`
	HemodialysisMachine       int64   `gorm:"column:hemodialysis_machine" json:"hemodialysis_machine"`
	BloodFilter               int64   `gorm:"column:blood_filter" json:"blood_filter"`
	PerfusionApparatus        int64   `gorm:"column:perfusion_apparatus" json:"perfusion_apparatus"`
	//DryWeight                 float64 `gorm:"column:dry_weight" json:"dry_weight"`
	VascularAccessMode         int64         `gorm:"column:vascular_access_mode" json:"vascular_access_mode"`
	VascularAccess             int64         `gorm:"column:vascular_access" json:"vascular_access"`
	BloodFlowVolume            float64       `gorm:"column:blood_flow_volume" json:"blood_flow_volume"`
	DialysateFlow              float64       `gorm:"column:dialysate_flow" json:"dialysate_flow"`
	DisplaceLiqui              float64       `gorm:"column:displace_liqui" json:"displace_liqui"`
	Kalium                     float64       `gorm:"column:kalium" json:"kalium"`
	Sodium                     float64       `gorm:"column:sodium" json:"sodium"`
	Calcium                    float64       `gorm:"column:calcium" json:"calcium"`
	Bicarbonate                float64       `gorm:"column:bicarbonate" json:"bicarbonate"`
	Glucose                    float64       `gorm:"column:glucose" json:"glucose"`
	DialysateTemperature       float64       `gorm:"column:dialysate_temperature" json:"dialysate_temperature"`
	Conductivity               float64       `gorm:"column:conductivity" json:"conductivity"`
	PrescriptionDoctor         int64         `gorm:"column:prescription_doctor" json:"prescription_doctor"`
	Remark                     string        `gorm:"column:remark" json:"remark"`
	Status                     int64         `gorm:"column:status" json:"status"`
	CreatedTime                int64         `gorm:"column:created_time" json:"created_time"`
	UpdatedTime                int64         `gorm:"column:updated_time" json:"updated_time"`
	RecordDate                 int64         `gorm:"column:record_date" json:"record_date"`
	RecordId                   int64         `gorm:"column:record_id" json:"record_id"`
	Creater                    int64         `gorm:"column:creater" json:"creater"`
	Modifier                   int64         `gorm:"column:modifier" json:"modifier"`
	DialysisDurationHour       int64         `gorm:"column:dialysis_duration_hour" json:"dialysis_duration_hour"`
	DialysisDurationMinute     int64         `gorm:"column:dialysis_duration_minute" json:"dialysis_duration_minute"`
	DialysateFormulation       int64         `gorm:"column:dialysate_formulation" json:"dialysate_formulation"`
	TargetUltrafiltration      float64       `gorm:"column:target_ultrafiltration" json:"target_ultrafiltration"`
	DialyzerPerfusionApparatus string        `gorm:"column:dialyzer_perfusion_apparatus" json:"dialyzer_perfusion_apparatus"`
	BodyFluid                  int64         `gorm:"column:body_fluid" json:"body_fluid"`
	SpecialMedicine            int64         `gorm:"column:special_medicine" json:"special_medicine"`
	SpecialMedicineOther       string        `gorm:"column:special_medicine_other" json:"special_medicine_other"`
	DisplaceLiquiPart          int64         `gorm:"column:displace_liqui_part" json:"displace_liqui_part"`
	DisplaceLiquiValue         float64       `gorm:"column:displace_liqui_value" json:"displace_liqui_value"`
	BloodAccess                int64         `gorm:"column:blood_access" json:"blood_access"`
	Ultrafiltration            float64       `gorm:"column:ultrafiltration" json:"ultrafiltration"`
	BodyFluidOther             string        `gorm:"column:body_fluid_other" json:"body_fluid_other"`
	Niprocart                  int64         `gorm:"column:niprocart" json:"niprocart"`
	Jms                        int64         `gorm:"column:jms" json:"jms"`
	FistulaNeedleSet           int64         `gorm:"column:fistula_needle_set" json:"fistula_needle_set"`
	FistulaNeedleSet16         int64         `gorm:"column:fistula_needle_set_16" json:"fistula_needle_set_16"`
	Hemoperfusion              int64         `gorm:"column:hemoperfusion" json:"hemoperfusion"`
	DialyserSterilised         int64         `gorm:"column:dialyser_sterilised" json:"dialyser_sterilised"`
	Filtryzer                  int64         `gorm:"column:filtryzer" json:"filtryzer"`
	TargetKtv                  float64       `gorm:"column:target_ktv" json:"target_ktv"`
	Dialyzers                  int64         `gorm:"column:dialyzers" json:"dialyzers"`
	Injector                   int64         `gorm:"column:injector" json:"injector"`
	Bloodlines                 int64         `gorm:"column:bloodlines" json:"bloodlines"`
	TubingHemodialysis         int64         `gorm:"column:tubing_hemodialysis" json:"tubing_hemodialysis"`
	Package                    int64         `gorm:"column:package" json:"package"`
	ALiquid                    int64         `gorm:"column:a_liquid" json:"a_liquid"`
	QCPatients                 QCPatients    `json:"patient" gorm:"foreignkey:ID;AssociationForeignKey:PatientID;"`
	UserAdminRole              UserAdminRole `json:"role" gorm:"foreignkey:AdminUserId;AssociationForeignKey:Creater;"`
	PreImpulse                 float64       `gorm:"column:pre_impulse" json:"pre_impulse" form:"pre_impulse"`
	AnticoagulantStopTimeMin   int64         `gorm:"column:anticoagulant_stop_time_min" json:"anticoagulant_stop_time_min" form:"anticoagulant_stop_time_min"`
	AnticoagulantStopTimeHour  int64         `gorm:"column:anticoagulant_stop_time_hour" json:"anticoagulant_stop_time_hour" form:"anticoagulant_stop_time_hour"`
	Blood                      string        `gorm:"column:blood" json:"blood"`
	DialysisDialyszers         string        `gorm:"column:dialysis_dialyszers" json:"dialysis_dialyszers" form:"dialysis_dialyszers"`
	DialysisIrrigation         string        `gorm:"column:dialysis_irrigation" json:"dialysis_irrigation" form:"dialysis_irrigation"`
	AntioxidantCommodityName   string        `gorm:"column:antioxidant_commodity_name" json:"antioxidant_commodity_name" form:"antioxidant_commodity_name"`
	DisplaceSpeed              string        `gorm:"column:displace_speed" json:"displace_speed" form:"displace_speed"`
	Illness                    int64         `gorm:"column:illness" json:"illness" form:"illness"`
	Amylaceum                  string        `gorm:"column:amylaceum" json:"amylaceum" form:"amylaceum"`
	SingleTime                 string        `gorm:"column:single_time" json:"single_time" form:"single_time"`
	SingleWater                string        `gorm:"column:single_water" json:"single_water" form:"single_water"`
	ReplacementFlow            string        `gorm:"column:replacement_flow" json:"replacement_flow" form:"replacement_flow"`
	PlasmaSeparator            string        `gorm:"column:plasma_separator" json:"plasma_separator" form:"plasma_separator"`
	BilirubinAdsorptionColumn  string        `gorm:"column:bilirubin_adsorption_column" json:"bilirubin_adsorption_column" form:"bilirubin_adsorption_column"`
	OxygenUptake               int64         `gorm:"column:oxygen_uptake" json:"oxygen_uptake" form:"oxygen_uptake"`
	OxygenFlow                 string        `gorm:"column:oxygen_flow" json:"oxygen_flow" form:"oxygen_flow"`
	OxygenTime                 string        `gorm:"column:oxygen_time" json:"oxygen_time" form:"oxygen_time"`
	HemodialysisPipelines      string        `gorm:"column:hemodialysis_pipelines" json:"hemodialysis_pipelines" form:"hemodialysis_pipelines"`
	HemodialysisPipelinesCount float64       `gorm:"column:hemodialysis_pipelines_count" json:"hemodialysis_pipelines_count" form:"hemodialysis_pipelines_count"`
	PunctureNeedle             string        `gorm:"column:puncture_needle" json:"puncture_needle" form:"puncture_needle"`
	PunctureNeedleCount        float64       `gorm:"column:puncture_needle_count" json:"puncture_needle_count" form:"puncture_needle_count"`
	Epo                        string        `gorm:"column:epo" json:"epo" form:"epo"`
	EpoCount                   float64       `gorm:"column:epo_count" json:"epo_count" form:"epo_count"`
	MaxUltrafiltrationRate     float64       `gorm:"column:max_ultrafiltration_rate" json:"max_ultrafiltration_rate" form:"max_ultrafiltration_rate"`
	AdminUserId                int64         `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
	IsWater                    int64         `gorm:"column:is_water" json:"is_water" form:"is_water"`
	DrhyWater                  string        `gorm:"column:drhy_water" json:"drhy_water" form:"drhy_water"`
	DryWaterHour               string        `gorm:"column:dry_water_hour" json:"dry_water_hour" form:"dry_water_hour"`
	WaterMachine               string        `gorm:"column:water_machine" json:"water_machine" form:"water_machine"`
	AddAmount                  float64       `gorm:"column:add_amount" json:"add_amount" form:"add_amount"`
	ReduceAmount               float64       `gorm:"column:reduce_amount" json:"reduce_amount" form:"reduce_amount"`
	DialysisRemark             string        `gorm:"column:dialysis_remark" json:"dialysis_remark" form:"dialysis_remark"`
	PrescribingNumber          float64       `gorm:"column:prescribing_number" json:"prescribing_number" form:"prescribing_number"`
	TreatmentRemark            string        `gorm:"column:treatment_remark" json:"treatment_remark" form:"treatment_remark"`
	PrescriptionSodium         string        `gorm:"column:prescription_sodium" json:"prescription_sodium" form:"prescription_sodium"`
	StartSodium                string        `gorm:"column:start_sodium" json:"start_sodium" form:"start_sodium"`
	SodiumCurve                string        `gorm:"column:sodium_curve" json:"sodium_curve" form:"sodium_curve"`
	DialysisFluidFlow          string        `gorm:"column:dialysis_fluid_flow" json:"dialysis_fluid_flow" form:"dialysis_fluid_flow"`
	SodiumBicarbonateFlow      string        `gorm:"column:sodium_bicarbonate_flow" json:"sodium_bicarbonate_flow" form:"sodium_bicarbonate_flow"`
	PrescriptionWater          float64       `gorm:"column:prescription_water" json:"prescription_water" form:"prescription_water"`
	DialysisStrainer           string        `gorm:"column:dialysis_strainer" json:"dialysis_strainer" form:"dialysis_strainer"`
	Chaptalization             string        `gorm:"column:chaptalization" json:"chaptalization" form:"chaptalization"`
	WarshCount                 string        `gorm:"column:warsh_count" json:"warsh_count" form:"warsh_count"`
	WashingTime                string        `gorm:"column:washing_time" json:"washing_time" form:"washing_time"`
	BloodAccessPartId          string        `gorm:"column:blood_access_part_id" json:"blood_access_part_id" form:"blood_access_part_id"`
	AnticoagulantWeichiHour    string        `gorm:"column:anticoagulant_weichi_hour" json:"anticoagulant_weichi_hour" form:"anticoagulant_weichi_hour"`
	Dialyzate                  string        `gorm:"column:dialyzate" json:"dialyzate" form:"dialyzate"`
	DialysisDialyszersId       int64         `gorm:"column:dialysis_dialyszers_id" json:"dialysis_dialyszers_id" form:"dialysis_dialyszers_id"`
	DialysisStrainerId         int64         `gorm:"column:dialysis_strainer_id" json:"dialysis_strainer_id" form:"dialysis_strainer_id"`
	DialysisIrrigationId       int64         `gorm:"column:dialysis_irrigation_id" json:"dialysis_irrigation_id" form:"dialysis_irrigation_id"`
}

func (DialysisPrescription) TableName() string {
	return "xt_dialysis_prescription"
}

type DialysisPrescriptionList struct {
	ID                         int64   `gorm:"column:id" json:"id" form:"id"`
	UserOrgId                  int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId                  int64   `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Dialyzer                   int64   `gorm:"column:dialyzer" json:"dialyzer" form:"dialyzer"`
	MachineType                string  `gorm:"column:machine_type" json:"machine_type" form:"machine_type"`
	DewaterAmount              float64 `gorm:"column:dewater_amount" json:"dewater_amount" form:"dewater_amount"`
	DialyzerPerfusionApparatus string  `gorm:"column:dialyzer_perfusion_apparatus" json:"dialyzer_perfusion_apparatus" form:"dialyzer_perfusion_apparatus"`
	PrescriptionDewatering     float64 `gorm:"column:prescription_dewatering" json:"prescription_dewatering" form:"prescription_dewatering"`
	Anticoagulant              int64   `gorm:"column:anticoagulant" json:"anticoagulant" form:"anticoagulant"`
	AnticoagulantShouji        float64 `gorm:"column:anticoagulant_shouji" json:"anticoagulant_shouji" form:"anticoagulant_shouji"`
	AnticoagulantStopTimeHour  int64   `gorm:"column:anticoagulant_stop_time_hour" json:"anticoagulant_stop_time_hour" form:"anticoagulant_stop_time_hour"`
	AnticoagulantWeichi        float64 `gorm:"column:anticoagulant_weichi" json:"anticoagulant_weichi" form:"anticoagulant_weichi"`
	AnticoagulantZongliang     float64 `gorm:"column:anticoagulant_zongliang" json:"anticoagulant_zongliang" form:"anticoagulant_zongliang"`
	AnticoagulantGaimingcheng  string  `gorm:"column:anticoagulant_gaimingcheng" json:"anticoagulant_gaimingcheng" form:"anticoagulant_gaimingcheng"`
	ModeId                     int64   `gorm:"column:mode_id" json:"mode_id" form:"mode_id"`
	AnticoagulantGaijiliang    string  `gorm:"column:anticoagulant_gaijiliang" json:"anticoagulant_gaijiliang" form:"anticoagulant_gaijiliang"`
	DialysisDurationHour       int64   `gorm:"column:dialysis_duration_hour" json:"dialysis_duration_hour" form:"dialysis_duration_hour"`
	DialysisDurationMinute     int64   `gorm:"column:dialysis_duration_minute" json:"dialysis_duration_minute" form:"dialysis_duration_minute"`
	DialysisDuration           float64 `gorm:"column:dialysis_duration" json:"dialysis_duration" form:"dialysis_duration"`
	ReplacementTotal           float64 `gorm:"column:replacement_total" json:"replacement_total" form:"replacement_total"`
	ReplacementWay             int64   `gorm:"column:replacement_way" json:"replacement_way" form:"replacement_way"`
	HemodialysisMachine        int64   `gorm:"column:hemodialysis_machine" json:"hemodialysis_machine" form:"hemodialysis_machine"`
	BloodFilter                int64   `gorm:"column:blood_filter" json:"blood_filter" form:"blood_filter"`
	PerfusionApparatus         int64   `gorm:"column:perfusion_apparatus" json:"perfusion_apparatus" form:"perfusion_apparatus"`
	DryWeight                  float64 `gorm:"column:dry_weight" json:"dry_weight" form:"dry_weight"`
	VascularAccessMode         int64   `gorm:"column:vascular_access_mode" json:"vascular_access_mode" form:"vascular_access_mode"`
	VascularAccess             int64   `gorm:"column:vascular_access" json:"vascular_access" form:"vascular_access"`
	BloodFlowVolume            float64 `gorm:"column:blood_flow_volume" json:"blood_flow_volume" form:"blood_flow_volume"`
	DialysateFlow              float64 `gorm:"column:dialysate_flow" json:"dialysate_flow" form:"dialysate_flow"`
	DisplaceLiqui              float64 `gorm:"column:displace_liqui" json:"displace_liqui" form:"displace_liqui"`
	Kalium                     float64 `gorm:"column:kalium" json:"kalium" form:"kalium"`
	Sodium                     float64 `gorm:"column:sodium" json:"sodium" form:"sodium"`
	Calcium                    float64 `gorm:"column:calcium" json:"calcium" form:"calcium"`
	Bicarbonate                float64 `gorm:"column:bicarbonate" json:"bicarbonate" form:"bicarbonate"`
	Glucose                    float64 `gorm:"column:glucose" json:"glucose" form:"glucose"`
	DialysateTemperature       float64 `gorm:"column:dialysate_temperature" json:"dialysate_temperature" form:"dialysate_temperature"`
	Conductivity               float64 `gorm:"column:conductivity" json:"conductivity" form:"conductivity"`
	PrescriptionDoctor         int64   `gorm:"column:prescription_doctor" json:"prescription_doctor" form:"prescription_doctor"`
	Creater                    int64   `gorm:"column:creater" json:"creater" form:"creater"`
	Modifier                   int64   `gorm:"column:modifier" json:"modifier" form:"modifier"`
	Remark                     string  `gorm:"column:remark" json:"remark" form:"remark"`
	Status                     int64   `gorm:"column:status" json:"status" form:"status"`
	CreatedTime                int64   `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime                int64   `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	RecordDate                 int64   `gorm:"column:record_date" json:"record_date" form:"record_date"`
	RecordId                   int64   `gorm:"column:record_id" json:"record_id" form:"record_id"`
	TargetUltrafiltration      float64 `gorm:"column:target_ultrafiltration" json:"target_ultrafiltration" form:"target_ultrafiltration"`
	DialysateFormulation       int64   `gorm:"column:dialysate_formulation" json:"dialysate_formulation" form:"dialysate_formulation"`
	BodyFluid                  int64   `gorm:"column:body_fluid" json:"body_fluid" form:"body_fluid"`
	SpecialMedicine            int64   `gorm:"column:special_medicine" json:"special_medicine" form:"special_medicine"`
	SpecialMedicineOther       string  `gorm:"column:special_medicine_other" json:"special_medicine_other" form:"special_medicine_other"`
	DisplaceLiquiPart          int64   `gorm:"column:displace_liqui_part" json:"displace_liqui_part" form:"displace_liqui_part"`
	BloodAccess                int64   `gorm:"column:blood_access" json:"blood_access" form:"blood_access"`
	DisplaceLiquiValue         float64 `gorm:"column:displace_liqui_value" json:"displace_liqui_value" form:"displace_liqui_value"`
	Ultrafiltration            float64 `gorm:"column:ultrafiltration" json:"ultrafiltration" form:"ultrafiltration"`
	BodyFluidOther             string  `gorm:"column:body_fluid_other" json:"body_fluid_other" form:"body_fluid_other"`
	Niprocart                  int64   `gorm:"column:niprocart" json:"niprocart" form:"niprocart"`
	Jms                        int64   `gorm:"column:jms" json:"jms" form:"jms"`
	FistulaNeedleSet           int64   `gorm:"column:fistula_needle_set" json:"fistula_needle_set" form:"fistula_needle_set"`
	FistulaNeedleSet16         int64   `gorm:"column:fistula_needle_set_16" json:"fistula_needle_set_16" form:"fistula_needle_set_16"`
	Hemoperfusion              int64   `gorm:"column:hemoperfusion" json:"hemoperfusion" form:"hemoperfusion"`
	DialyserSterilised         int64   `gorm:"column:dialyser_sterilised" json:"dialyser_sterilised" form:"dialyser_sterilised"`
	Filtryzer                  int64   `gorm:"column:filtryzer" json:"filtryzer" form:"filtryzer"`
	TargetKtv                  float64 `gorm:"column:target_ktv" json:"target_ktv" form:"target_ktv"`
	Dialyzers                  int64   `gorm:"column:dialyzers" json:"dialyzers" form:"dialyzers"`
	Injector                   int64   `gorm:"column:injector" json:"injector" form:"injector"`
	Bloodlines                 int64   `gorm:"column:bloodlines" json:"bloodlines" form:"bloodlines"`
	TubingHemodialysis         int64   `gorm:"column:tubing_hemodialysis" json:"tubing_hemodialysis" form:"tubing_hemodialysis"`
	Package                    int64   `gorm:"column:package" json:"package" form:"package"`
	ALiquid                    int64   `gorm:"column:a_liquid" json:"a_liquid" form:"a_liquid"`
	PreImpulse                 float64 `gorm:"column:pre_impulse" json:"pre_impulse" form:"pre_impulse"`
	AnticoagulantStopTimeMin   int64   `gorm:"column:anticoagulant_stop_time_min" json:"anticoagulant_stop_time_min" form:"anticoagulant_stop_time_min"`
	HeparinSodium              string  `gorm:"column:heparin_sodium" json:"heparin_sodium" form:"heparin_sodium"`
	Nucleoprotamine            string  `gorm:"column:nucleoprotamine" json:"nucleoprotamine" form:"nucleoprotamine"`
	PushTheProtamine           string  `gorm:"column:push_the_protamine" json:"push_the_protamine" form:"push_the_protamine"`
	NoHeparinRemarks           string  `gorm:"column:no_heparin_remarks" json:"no_heparin_remarks" form:"no_heparin_remarks"`
	Blood                      string  `gorm:"column:blood" json:"blood" form:"blood"`
	DialysisDialyszers         string  `gorm:"column:dialysis_dialyszers" json:"dialysis_dialyszers" form:"dialysis_dialyszers"`
	DialysisIrrigation         string  `gorm:"column:dialysis_irrigation" json:"dialysis_irrigation" form:"dialysis_irrigation"`
	AntioxidantCommodityName   string  `gorm:"column:antioxidant_commodity_name" json:"antioxidant_commodity_name" form:"antioxidant_commodity_name"`
	DisplaceSpeed              string  `gorm:"column:displace_speed" json:"displace_speed" form:"displace_speed"`
	Illness                    int64   `gorm:"column:illness" json:"illness" form:"illness"`
	Amylaceum                  string  `gorm:"column:amylaceum" json:"amylaceum" form:"amylaceum"`
	SingleTime                 string  `gorm:"column:single_time" json:"single_time" form:"single_time"`
	SingleWater                string  `gorm:"column:single_water" json:"single_water" form:"single_water"`
	ReplacementFlow            string  `gorm:"column:replacement_flow" json:"replacement_flow" form:"replacement_flow"`
	PlasmaSeparator            string  `gorm:"column:plasma_separator" json:"plasma_separator" form:"plasma_separator"`
	BilirubinAdsorptionColumn  string  `gorm:"column:bilirubin_adsorption_column" json:"bilirubin_adsorption_column" form:"bilirubin_adsorption_column"`
	OxygenUptake               int64   `gorm:"column:oxygen_uptake" json:"oxygen_uptake" form:"oxygen_uptake"`
	OxygenFlow                 string  `gorm:"column:oxygen_flow" json:"oxygen_flow" form:"oxygen_flow"`
	OxygenTime                 string  `gorm:"column:oxygen_time" json:"oxygen_time" form:"oxygen_time"`
	HemodialysisPipelines      string  `gorm:"column:hemodialysis_pipelines" json:"hemodialysis_pipelines" form:"hemodialysis_pipelines"`
	HemodialysisPipelinesCount float64 `gorm:"column:hemodialysis_pipelines_count" json:"hemodialysis_pipelines_count" form:"hemodialysis_pipelines_count"`
	PunctureNeedle             string  `gorm:"column:puncture_needle" json:"puncture_needle" form:"puncture_needle"`
	PunctureNeedleCount        float64 `gorm:"column:puncture_needle_count" json:"puncture_needle_count" form:"puncture_needle_count"`
	Epo                        string  `gorm:"column:epo" json:"epo" form:"epo"`
	EpoCount                   float64 `gorm:"column:epo_count" json:"epo_count" form:"epo_count"`
	MaxUltrafiltrationRate     string  `gorm:"column:max_ultrafiltration_rate" json:"max_ultrafiltration_rate" form:"max_ultrafiltration_rate"`
	WaterMachine               string  `gorm:"column:water_machine" json:"water_machine" form:"water_machine"`
	DialysisStrainer           string  `gorm:"column:dialysis_strainer" json:"dialysis_strainer" form:"dialysis_strainer"`
	PrescriptionWater          float64 `gorm:"column:prescription_water" json:"prescription_water" form:"prescription_water"`
}

func (DialysisPrescriptionList) TableName() string {
	return "xt_dialysis_prescription"
}

type DialysisPrescriptionListSix struct {
	ID                         int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId                  int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId                  int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	DialysisDialyszers         string `gorm:"column:dialysis_dialyszers" json:"dialysis_dialyszers" form:"dialysis_dialyszers"`
	DialysisIrrigation         string `gorm:"column:dialysis_irrigation" json:"dialysis_irrigation" form:"dialysis_irrigation"`
	DialysisStrainer           string `gorm:"column:dialysis_strainer" json:"dialysis_strainer" form:"dialysis_strainer"`
	DialyzerPerfusionApparatus string `gorm:"column:dialyzer_perfusion_apparatus" json:"dialyzer_perfusion_apparatus" form:"dialyzer_perfusion_apparatus"`
	ModeId                     int64  `gorm:"column:mode_id" json:"mode_id" form:"mode_id"`
	SolutionStatus             int64  `gorm:"column:solution_status" json:"solution_status" form:"solution_status"`
}

func (DialysisPrescriptionListSix) TableName() string {
	return "xt_dialysis_solution"
}

type DialysisAssesmentBefor struct {
	ID                     int64 `gorm:"column:id" json:"id"`
	UserOrgId              int64 `gorm:"column:user_org_id" json:"user_org_id"`
	PatientId              int64 `gorm:"column:patient_id" json:"patient_id"`
	AssessmentDate         int64 `gorm:"column:assessment_date" json:"assessment_date" form:"assessment_date"`
	BloodAccessPartOperaId int64 `gorm:"column:blood_access_part_opera_id" json:"blood_access_part_opera_id" form:"blood_access_part_opera_id"`
	CreatedTime            int64 `gorm:"column:created_time" json:"created_time" form:"created_time"`
}

func (DialysisAssesmentBefor) TableName() string {
	return "xt_assessment_before_dislysis"
}

type DialysisSolution struct {
	ID                         int64   `gorm:"column:id" json:"id" form:"id"`
	Name                       string  `gorm:"column:name" json:"name" form:"name"`
	SubName                    string  `gorm:"column:sub_name" json:"sub_name" form:"sub_name"`
	UserOrgId                  int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId                  int64   `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	ParentId                   int64   `gorm:"column:parent_id" json:"parent_id" form:"parent_id"`
	Type                       int64   `gorm:"column:type" json:"type" form:"type"`
	Period                     string  `gorm:"column:period" json:"period" form:"period"`
	Times                      string  `gorm:"column:times" json:"times" form:"times"`
	Anticoagulant              int64   `gorm:"column:anticoagulant" json:"anticoagulant" form:"anticoagulant"`
	AnticoagulantShouji        float64 `gorm:"column:anticoagulant_shouji" json:"anticoagulant_shouji" form:"anticoagulant_shouji"`
	AnticoagulantWeichi        float64 `gorm:"column:anticoagulant_weichi" json:"anticoagulant_weichi" form:"anticoagulant_weichi"`
	AnticoagulantZongliang     float64 `gorm:"column:anticoagulant_zongliang" json:"anticoagulant_zongliang" form:"anticoagulant_zongliang"`
	AnticoagulantGaimingcheng  string  `gorm:"column:anticoagulant_gaimingcheng" json:"anticoagulant_gaimingcheng" form:"anticoagulant_gaimingcheng"`
	AnticoagulantGaijiliang    string  `gorm:"column:anticoagulant_gaijiliang" json:"anticoagulant_gaijiliang" form:"anticoagulant_gaijiliang"`
	ModeName                   string  `gorm:"column:mode_name" json:"mode_name" form:"mode_name"`
	ModeId                     int64   `gorm:"column:mode_id" json:"mode_id" form:"mode_id"`
	DialysisDuration           float64 `gorm:"column:dialysis_duration" json:"dialysis_duration" form:"dialysis_duration"`
	ReplacementWay             int64   `gorm:"column:replacement_way" json:"replacement_way" form:"replacement_way"`
	HemodialysisMachine        int64   `gorm:"column:hemodialysis_machine" json:"hemodialysis_machine" form:"hemodialysis_machine"`
	BloodFilter                int64   `gorm:"column:blood_filter" json:"blood_filter" form:"blood_filter"`
	PerfusionApparatus         int64   `gorm:"column:perfusion_apparatus" json:"perfusion_apparatus" form:"perfusion_apparatus"`
	BloodFlowVolume            float64 `gorm:"column:blood_flow_volume" json:"blood_flow_volume" form:"blood_flow_volume"`
	Dewater                    float64 `gorm:"column:dewater" json:"dewater" form:"dewater"`
	DisplaceLiqui              float64 `gorm:"column:displace_liqui" json:"displace_liqui" form:"displace_liqui"`
	Glucose                    float64 `gorm:"column:glucose" json:"glucose" form:"glucose"`
	DialysateFlow              float64 `gorm:"column:dialysate_flow" json:"dialysate_flow" form:"dialysate_flow"`
	Kalium                     float64 `gorm:"column:kalium" json:"kalium" form:"kalium"`
	Sodium                     float64 `gorm:"column:sodium" json:"sodium" form:"sodium"`
	Calcium                    float64 `gorm:"column:calcium" json:"calcium" form:"calcium"`
	Bicarbonate                float64 `gorm:"column:bicarbonate" json:"bicarbonate" form:"bicarbonate"`
	Doctor                     int64   `gorm:"column:doctor" json:"doctor" form:"doctor"`
	FirstDialysis              int64   `gorm:"column:first_dialysis" json:"first_dialysis" form:"first_dialysis"`
	Remark                     string  `gorm:"column:remark" json:"remark" form:"remark"`
	InitiateMode               int64   `gorm:"column:initiate_mode" json:"initiate_mode" form:"initiate_mode"`
	AffirmState                int64   `gorm:"column:affirm_state" json:"affirm_state" form:"affirm_state"`
	UseState                   int64   `gorm:"column:use_state" json:"use_state" form:"use_state"`
	Status                     int64   `gorm:"column:status" json:"status" form:"status"`
	RegistrarsId               int64   `gorm:"column:registrars_id" json:"registrars_id" form:"registrars_id"`
	CreatedTime                int64   `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime                int64   `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	SolutionType               int64   `gorm:"column:solution_type" json:"solution_type" form:"solution_type"`
	DialysateTemperature       float64 `gorm:"column:dialysate_temperature" json:"dialysate_temperature" form:"dialysate_temperature"`
	Conductivity               float64 `gorm:"column:conductivity" json:"conductivity" form:"conductivity"`
	BodyFluid                  int64   `gorm:"column:body_fluid" json:"body_fluid"`
	SpecialMedicine            int64   `gorm:"column:special_medicine" json:"special_medicine"`
	SpecialMedicineOther       string  `gorm:"column:special_medicine_other" json:"special_medicine_other"`
	DisplaceLiquiPart          int64   `gorm:"column:displace_liqui_part" json:"displace_liqui_part"`
	DisplaceLiquiValue         float64 `gorm:"column:displace_liqui_value" json:"displace_liqui_value"`
	BloodAccess                int64   `gorm:"column:blood_access" json:"blood_access"`
	Ultrafiltration            float64 `gorm:"column:ultrafiltration" json:"ultrafiltration"`
	DialysisDurationHour       int64   `gorm:"column:dialysis_duration_hour" json:"dialysis_duration_hour" form:"dialysis_duration_hour"`
	DialysisDurationMinute     int64   `gorm:"column:dialysis_duration_minute" json:"dialysis_duration_minute" form:"dialysis_duration_minute"`
	TargetUltrafiltration      float64 `gorm:"column:target_ultrafiltration" json:"target_ultrafiltration" form:"target_ultrafiltration"`
	DialysateFormulation       int64   `gorm:"column:dialysate_formulation" json:"dialysate_formulation" form:"dialysate_formulation"`
	Dialyzer                   int64   `gorm:"column:dialyzer" json:"dialyzer" form:"dialysate_formulation"`
	ReplacementTotal           float64 `gorm:"column:replacement_total" json:"replacement_total"`
	DialyzerPerfusionApparatus string  `gorm:"column:dialyzer_perfusion_apparatus" json:"dialyzer_perfusion_apparatus"`
	BodyFluidOther             string  `gorm:"column:body_fluid_other" json:"body_fluid_other"`
	TargetKtv                  float64 `gorm:"column:target_ktv" json:"target_ktv"`
	DialysisDialyszers         string  `gorm:"column:dialysis_dialyszers" json:"dialysis_dialyszers" form:"dialysis_dialyszers"`
	DialysisIrrigation         string  `gorm:"column:dialysis_irrigation" json:"dialysis_irrigation" form:"dialysis_irrigation"`
	AntioxidantCommodityName   string  `gorm:"column:antioxidant_commodity_name" json:"antioxidant_commodity_name" form:"antioxidant_commodity_name"`
	DisplaceSpeed              string  `gorm:"column:displace_speed" json:"displace_speed" form:"displace_speed"`
	Illness                    int64   `gorm:"column:illness" json:"illness" form:"illness"`
	Amylaceum                  string  `gorm:"column:amylaceum" json:"amylaceum" form:"amylaceum"`
	PlasmaSeparator            string  `gorm:"column:plasma_separator" json:"plasma_separator" form:"plasma_separator"`
	BilirubinAdsorptionColumn  string  `gorm:"column:bilirubin_adsorption_column" json:"bilirubin_adsorption_column" form:"bilirubin_adsorption_column"`
	OxygenUptake               int64   `gorm:"column:oxygen_uptake" json:"oxygen_uptake" form:"oxygen_uptake"`
	OxygenFlow                 string  `gorm:"column:oxygen_flow" json:"oxygen_flow" form:"oxygen_flow"`
	OxygenTime                 string  `gorm:"column:oxygen_time" json:"oxygen_time" form:"oxygen_time"`
	HemodialysisPipelines      string  `gorm:"column:hemodialysis_pipelines" json:"hemodialysis_pipelines" form:"hemodialysis_pipelines"`
	HemodialysisPipelinesCount float64 `gorm:"column:hemodialysis_pipelines_count" json:"hemodialysis_pipelines_count" form:"hemodialysis_pipelines_count"`
	PunctureNeedle             string  `gorm:"column:puncture_needle" json:"puncture_needle" form:"puncture_needle"`
	PunctureNeedleCount        float64 `gorm:"column:puncture_needle_count" json:"puncture_needle_count" form:"puncture_needle_count"`
	Epo                        string  `gorm:"column:epo" json:"epo" form:"epo"`
	EpoCount                   float64 `gorm:"column:epo_count" json:"epo_count" form:"epo_count"`
	MaxUltrafiltrationRate     float64 `gorm:"column:max_ultrafiltration_rate" json:"max_ultrafiltration_rate" form:"max_ultrafiltration_rate"`
	PreImpulse                 float64 `gorm:"column:pre_impulse" json:"pre_impulse" form:"pre_impulse"`
	SolutionStatus             int64   `gorm:"column:solution_status" json:"solution_status" form:"solution_status"`
	DialysisRemark             string  `gorm:"column:dialysis_remark" json:"dialysis_remark" form:"dialysis_remark"`
	PrescribingNumber          float64 `gorm:"column:prescribing_number" json:"prescribing_number" form:"prescribing_number"`
	TreatmentRemark            string  `gorm:"column:treatment_remark" json:"treatment_remark" form:"treatment_remark"`
	PrescriptionSodium         string  `gorm:"column:prescription_sodium" json:"prescription_sodium" form:"prescription_sodium"`
	StartSodium                string  `gorm:"column:start_sodium" json:"start_sodium" form:"start_sodium"`
	SodiumCurve                string  `gorm:"column:sodium_curve" json:"sodium_curve" form:"sodium_curve"`
	DialysisFluidFlow          string  `gorm:"column:dialysis_fluid_flow" json:"dialysis_fluid_flow" form:"dialysis_fluid_flow"`
	SodiumBicarbonateFlow      string  `gorm:"column:sodium_bicarbonate_flow" json:"sodium_bicarbonate_flow" form:"sodium_bicarbonate_flow"`
	PrescriptionWater          float64 `gorm:"column:prescription_water" json:"prescription_water" form:"prescription_water"`
	DialysisStrainer           string  `gorm:"column:dialysis_strainer" json:"dialysis_strainer" form:"dialysis_strainer"`
	Chaptalization             string  `gorm:"column:chaptalization" json:"chaptalization" form:"chaptalization"`
	WarshCount                 string  `gorm:"column:warsh_count" json:"warsh_count" form:"warsh_count"`
	WashingTime                string  `gorm:"column:washing_time" json:"washing_time" form:"washing_time"`
	BloodAccessPartId          string  `gorm:"column:blood_access_part_id" json:"blood_access_part_id" form:"blood_access_part_id"`
	AnticoagulantWeichiHour    string  `gorm:"column:anticoagulant_weichi_hour" json:"anticoagulant_weichi_hour" form:"anticoagulant_weichi_hour"`
	Dialyzate                  string  `gorm:"column:dialyzate" json:"dialyzate" form:"dialyzate"`
	DialysisDialyszersId       int64   `gorm:"column:dialysis_dialyszers_id" json:"dialysis_dialyszers_id" form:"dialysis_dialyszers_id"`
	DialysisStrainerId         int64   `gorm:"column:dialysis_strainer_id" json:"dialysis_strainer_id" form:"dialysis_strainer_id"`
	DialysisIrrigationId       int64   `gorm:"column:dialysis_irrigation_id" json:"dialysis_irrigation_id" form:"dialysis_irrigation_id"`
}

func (DialysisSolution) TableName() string {
	return "xt_dialysis_solution"
}

type UserAdminRole struct {
	ID              int64           `gorm:"column:id" json:"id"`
	AdminUserId     int64           `gorm:"column:admin_user_id" json:"admin_user_id"`
	OrgId           int64           `gorm:"column:org_id" json:"org_id"`
	AppId           int64           `gorm:"column:app_id" json:"app_id"`
	RoleId          int64           `gorm:"column:role_id" json:"role_id"`
	UserName        string          `gorm:"column:user_name" json:"user_name"`
	Avatar          string          `gorm:"column:avatar" json:"avatar"`
	UserType        int64           `gorm:"column:user_type" json:"user_type"`
	UserTitle       int64           `gorm:"column:user_title" json:"user_title"`
	Intro           string          `gorm:"column:intro" json:"intro"`
	Status          int64           `gorm:"column:status" json:"status"`
	Ctime           int64           `gorm:"column:ctime" json:"ctime"`
	Mtime           int64           `gorm:"column:mtime" json:"mtime"`
	DoctorNumber    string          `gorm:"column:doctor_number" json:"doctor_number"`
	Department      string          `gorm:"column:department" json:"department"`
	DepartmentId    int64           `gorm:"column:department_id" json:"department_id"`
	XtHisDepartment XtHisDepartment `json:"department" gorm:"foreignkey:DepartmentId;AssociationForeignKey:ID;"`
}

func (UserAdminRole) TableName() string {
	return "sgj_user_admin_role"
}

type PatientDialysisRecord struct {
	DialysisOrder

	ScheduleType  int64  `gorm:"-" json:"schedule_type" form:"schedule_type"`
	PartitionId   int64  `gorm:"-" json:"partition_id" form:"partition_id"`
	PartitionName string `gorm:"-" json:"partition_name" form:"partition_name"`
	DeviceNumber  string `gorm:"-" json:"device_number" form:"device_number"`

	// DialysisPrescription    DialysisPrescription    `json:"prescription" gorm:"foreignkey:RecordId"`
	// PredialysisEvaluation   PredialysisEvaluation   `json:"predialysis_evaluation" gorm:"foreignkey:DialysisOrderId"`
	// AssessmentAfterDislysis AssessmentAfterDislysis `json:"assessment_after_dislysis" gorm:"foreignkey:DialysisOrderId"`
	// TreatmentSummary        TreatmentSummary        `json:"treatment_summary" gorm:"foreignkey:DialysisOrderId"`

	DialysisPrescription    DialysisPrescription    `json:"prescription" gorm:"foreignkey:RecordDate;AssociationForeignKey:DialysisDate;"`
	PredialysisEvaluation   PredialysisEvaluation   `json:"predialysis_evaluation" gorm:"foreignkey:AssessmentDate;AssociationForeignKey:DialysisDate;"`
	AssessmentAfterDislysis AssessmentAfterDislysis `json:"assessment_after_dislysis" gorm:"foreignkey:AssessmentDate;AssociationForeignKey:DialysisDate;"`
	TreatmentSummary        TreatmentSummary        `json:"treatment_summary" gorm:"foreignkey:AssessmentDate;AssociationForeignKey:DialysisDate;"`
	Device                  DeviceNumber            `json:"device" gorm:"foreignkey:ID;AssociationForeignKey:BedID;"`
	MonitoringRecord        []MonitoringRecord      `json:"monitoring_record" gorm:"foreignkey:MonitoringDate;AssociationForeignKey:DialysisDate;"`
	DoctorAdvice            []DoctorAdvice          `json:"doctor_advice" gorm:"foreignkey:AdviceDate;AssociationForeignKey:DialysisDate;"`
}

type DialysisPrescriptionAddtional struct {
	DialysisPrescription

	Device Device `json:"device" gorm:"foreignkey:dialyzer"`
}

type PatientDiseaseCourse struct {
	ID         int64  `gorm:"column:id" json:"id" form:"id"`
	OrgID      int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	PatientID  int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Recorder   int64  `gorm:"column:recorder" json:"recorder" form:"recorder"`
	RecordTime int64  `gorm:"column:record_time" json:"record_time" form:"record_time"`
	Content    string `gorm:"column:content" json:"content" form:"content"`
	Status     int64  `gorm:"column:status" json:"-" form:"-"`
	CreateTime int64  `gorm:"column:ctime" json:"-" form:"-"`
	ModifyTime int64  `gorm:"column:mtime" json:"-" form:"-"`
	Title      string `gorm:"column:title" json:"title"`
}

func (PatientDiseaseCourse) TableName() string {
	return "xt_patient_course_of_disease"
}

type PatientRescueRecord struct {
	ID         int64  `gorm:"column:id" json:"id" form:"id"`
	OrgID      int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	PatientID  int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Recorder   int64  `gorm:"column:recorder" json:"recorder" form:"recorder"`
	RecordTime int64  `gorm:"column:record_time" json:"record_time" form:"record_time"`
	Content    string `gorm:"column:content" json:"content" form:"content"`
	Status     int64  `gorm:"column:status" json:"-" form:"-"`
	CreateTime int64  `gorm:"column:ctime" json:"-" form:"-"`
	ModifyTime int64  `gorm:"column:mtime" json:"-" form:"-"`
}

func (PatientRescueRecord) TableName() string {
	return "xt_patient_rescue_record"
}

type PatientLapseto struct {
	ID          int64 `gorm:"column:id" json:"id" form:"id"`
	PatientId   int64 `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	LapsetoType int64 `gorm:"column:lapseto_type" json:"lapseto_type" form:"lapseto_type"`
	LapsetoTime int64 `gorm:"column:lapseto_time" json:"lapseto_time" form:"lapseto_time"`
	Status      int64 `gorm:"column:status" json:"status" form:"status"`
	CreatedTime int64 `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime int64 `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
}

func (PatientLapseto) TableName() string {
	return "xt_patient_lapseto"
}

type FormItem struct {
	ID          int64  `json:"id"`
	ProjectId   int64  `json:"project_id"`
	ProjectName string `json:"project_name"`
	ItemId      int64  `json:"item_id"`
	Item        string `json:"item"`
	ItemName    string `json:"item_name"`
	RangeType   int64  `json:"range_type"`
	Value       string `json:"value"`
}

type SgjUserIllness struct {
	ID          int64  `gorm:"column:id" json:"id" form:"id"`
	IllnessName string `gorm:"column:illness_name" json:"illness_name" form:"illness_name"`
	Status      int64  `gorm:"column:status" json:"status" form:"status"`
	CreatedTime int64  `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime int64  `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
}

func (SgjUserIllness) TableName() string {
	return "sgj_user_illness"
}

type XtPatientsNew struct {
	ID                           int64   `gorm:"column:id" json:"id" form:"id"`
	UserOrgId                    int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	UserId                       int64   `gorm:"column:user_id" json:"user_id" form:"user_id"`
	Avatar                       string  `gorm:"column:avatar" json:"avatar" form:"avatar"`
	PatientType                  int64   `gorm:"column:patient_type" json:"patient_type" form:"patient_type"`
	DialysisNo                   string  `gorm:"column:dialysis_no" json:"dialysis_no" form:"dialysis_no"`
	AdmissionNumber              string  `gorm:"column:admission_number" json:"admission_number" form:"admission_number"`
	Source                       int64   `gorm:"column:source" json:"source" form:"source"`
	Lapseto                      int64   `gorm:"column:lapseto" json:"lapseto" form:"lapseto"`
	PartitionId                  int64   `gorm:"column:partition_id" json:"partition_id" form:"partition_id"`
	BedId                        int64   `gorm:"column:bed_id" json:"bed_id" form:"bed_id"`
	Name                         string  `gorm:"column:name" json:"name" form:"name"`
	Alias                        string  `gorm:"column:alias" json:"alias" form:"alias"`
	Gender                       int64   `gorm:"column:gender" json:"gender" form:"gender"`
	MaritalStatus                int64   `gorm:"column:marital_status" json:"marital_status" form:"marital_status"`
	IdCardNo                     string  `gorm:"column:id_card_no" json:"id_card_no" form:"id_card_no"`
	Birthday                     int64   `gorm:"column:birthday" json:"birthday" form:"birthday"`
	ReimbursementWayId           int64   `gorm:"column:reimbursement_way_id" json:"reimbursement_way_id" form:"reimbursement_way_id"`
	HealthCareType               int64   `gorm:"column:health_care_type" json:"health_care_type" form:"health_care_type"`
	HealthCareNo                 string  `gorm:"column:health_care_no" json:"health_care_no" form:"health_care_no"`
	HealthCareDueDate            int64   `gorm:"column:health_care_due_date" json:"health_care_due_date" form:"health_care_due_date"`
	Height                       int64   `gorm:"column:height" json:"height" form:"height"`
	BloodType                    int64   `gorm:"column:blood_type" json:"blood_type" form:"blood_type"`
	Rh                           int64   `gorm:"column:rh" json:"rh" form:"rh"`
	HealthCareDueAlertDate       int64   `gorm:"column:health_care_due_alert_date" json:"health_care_due_alert_date" form:"health_care_due_alert_date"`
	EducationLevel               int64   `gorm:"column:education_level" json:"education_level" form:"education_level"`
	Profession                   int64   `gorm:"column:profession" json:"profession" form:"profession"`
	Phone                        string  `gorm:"column:phone" json:"phone" form:"phone"`
	HomeTelephone                string  `gorm:"column:home_telephone" json:"home_telephone" form:"home_telephone"`
	RelativePhone                string  `gorm:"column:relative_phone" json:"relative_phone" form:"relative_phone"`
	RelativeRelations            string  `gorm:"column:relative_relations" json:"relative_relations" form:"relative_relations"`
	HomeAddress                  string  `gorm:"column:home_address" json:"home_address" form:"home_address"`
	WorkUnit                     string  `gorm:"column:work_unit" json:"work_unit" form:"work_unit"`
	UnitAddress                  string  `gorm:"column:unit_address" json:"unit_address" form:"unit_address"`
	Children                     int64   `gorm:"column:children" json:"children" form:"children"`
	ReceivingDate                int64   `gorm:"column:receiving_date" json:"receiving_date" form:"receiving_date"`
	IsHospitalFirstDialysis      int64   `gorm:"column:is_hospital_first_dialysis" json:"is_hospital_first_dialysis" form:"is_hospital_first_dialysis"`
	FirstDialysisDate            int64   `gorm:"column:first_dialysis_date" json:"first_dialysis_date" form:"first_dialysis_date"`
	FirstDialysisHospital        string  `gorm:"column:first_dialysis_hospital" json:"first_dialysis_hospital" form:"first_dialysis_hospital"`
	PredialysisCondition         string  `gorm:"column:predialysis_condition" json:"predialysis_condition" form:"predialysis_condition"`
	PreHospitalDialysisFrequency string  `gorm:"column:pre_hospital_dialysis_frequency" json:"pre_hospital_dialysis_frequency" form:"pre_hospital_dialysis_frequency"`
	PreHospitalDialysisTimes     int64   `gorm:"column:pre_hospital_dialysis_times" json:"pre_hospital_dialysis_times" form:"pre_hospital_dialysis_times"`
	HospitalFirstDialysisDate    int64   `gorm:"column:hospital_first_dialysis_date" json:"hospital_first_dialysis_date" form:"hospital_first_dialysis_date"`
	InductionPeriod              int64   `gorm:"column:induction_period" json:"induction_period" form:"induction_period"`
	InitialDialysis              int64   `gorm:"column:initial_dialysis" json:"initial_dialysis" form:"initial_dialysis"`
	TotalDialysis                int64   `gorm:"column:total_dialysis" json:"total_dialysis" form:"total_dialysis"`
	AttendingDoctorId            int64   `gorm:"column:attending_doctor_id" json:"attending_doctor_id" form:"attending_doctor_id"`
	HeadNurseId                  int64   `gorm:"column:head_nurse_id" json:"head_nurse_id" form:"head_nurse_id"`
	Evaluate                     string  `gorm:"column:evaluate" json:"evaluate" form:"evaluate"`
	Diagnose                     string  `gorm:"column:diagnose" json:"diagnose" form:"diagnose"`
	Remark                       string  `gorm:"column:remark" json:"remark" form:"remark"`
	RegistrarsId                 int64   `gorm:"column:registrars_id" json:"registrars_id" form:"registrars_id"`
	Registrars                   string  `gorm:"column:registrars" json:"registrars" form:"registrars"`
	QrCode                       string  `gorm:"column:qr_code" json:"qr_code" form:"qr_code"`
	BindingState                 int64   `gorm:"column:binding_state" json:"binding_state" form:"binding_state"`
	PatientComplains             string  `gorm:"column:patient_complains" json:"patient_complains" form:"patient_complains"`
	PresentHistory               string  `gorm:"column:present_history" json:"present_history" form:"present_history"`
	PastHistory                  string  `gorm:"column:past_history" json:"past_history" form:"past_history"`
	Temperature                  float64 `gorm:"column:temperature" json:"temperature" form:"temperature"`
	Pulse                        int64   `gorm:"column:pulse" json:"pulse" form:"pulse"`
	Respiratory                  int64   `gorm:"column:respiratory" json:"respiratory" form:"respiratory"`
	Sbp                          int64   `gorm:"column:sbp" json:"sbp" form:"sbp"`
	Dbp                          int64   `gorm:"column:dbp" json:"dbp" form:"dbp"`
	Status                       int64   `gorm:"column:status" json:"status" form:"status"`
	CreatedTime                  int64   `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime                  int64   `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	Nation                       string  `gorm:"column:nation" json:"nation" form:"nation"`
	NativePlace                  string  `gorm:"column:native_place" json:"native_place" form:"native_place"`
	Age                          int64   `gorm:"column:age" json:"age" form:"age"`
	InfectiousNextRecordTime     int64   `gorm:"column:infectious_next_record_time" json:"infectious_next_record_time" form:"infectious_next_record_time"`
	IsInfectious                 int64   `gorm:"column:is_infectious" json:"is_infectious" form:"is_infectious"`
	RemindCycle                  int64   `gorm:"column:remind_cycle" json:"remind_cycle" form:"remind_cycle"`
	ResponseResult               string  `gorm:"column:response_result" json:"response_result" form:"response_result"`
	IsOpenRemind                 int64   `gorm:"column:is_open_remind" json:"is_open_remind" form:"is_open_remind"`
	FirstTreatmentDate           int64   `gorm:"column:first_treatment_date" json:"first_treatment_date" form:"first_treatment_date"`
	DialysisAge                  int64   `gorm:"column:dialysis_age" json:"dialysis_age" form:"dialysis_age"`
	ExpenseKind                  int64   `gorm:"column:expense_kind" json:"expense_kind" form:"expense_kind"`
	TellPhone                    string  `gorm:"column:tell_phone" json:"tell_phone" form:"tell_phone"`
	ContactName                  string  `gorm:"column:contact_name" json:"contact_name" form:"contact_name"`
	BloodPatients                int64   `gorm:"column:blood_patients" json:"blood_patients" form:"blood_patients"`
	SlowPatients                 int64   `gorm:"column:slow_patients" json:"slow_patients" form:"slow_patients"`
	MemberPatients               int64   `gorm:"column:member_patients" json:"member_patients" form:"member_patients"`
	EcommerPatients              string  `gorm:"column:ecommer_patients" json:"ecommer_patients" form:"ecommer_patients"`
	BloodId                      int64   `gorm:"column:blood_id" json:"blood_id" form:"blood_id"`
	SlowId                       int64   `gorm:"column:slow_id" json:"slow_id" form:"slow_id"`
	MemberId                     int64   `gorm:"column:member_id" json:"member_id" form:"member_id"`
	MemberFistdate               int64   `gorm:"column:member_fistdate" json:"member_fistdate" form:"member_fistdate"`
	MemberPatienttype            int64   `gorm:"column:member_patienttype" json:"member_patienttype" form:"member_patienttype"`
	MemberTreatement             int64   `gorm:"column:member_treatement" json:"member_treatement" form:"member_treatement"`
	EquitmentId                  string  `gorm:"column:equitment_id" json:"equitment_id" form:"equitment_id"`
	UserSysBeforeCount           int64   `gorm:"column:user_sys_before_count" json:"user_sys_before_count" form:"user_sys_before_count"`
	IsExcelExport                int64   `gorm:"column:is_excel_export" json:"is_excel_export" form:"is_excel_export"`
	SchRemark                    string  `gorm:"column:sch_remark" json:"sch_remark" form:"sch_remark"`
	OutReason                    string  `gorm:"column:out_reason" json:"out_reason" form:"out_reason"`
	DeathTime                    int64   `gorm:"column:death_time" json:"death_time" form:"death_time"`
	TrobleShoot                  int64   `gorm:"column:troble_shoot" json:"troble_shoot" form:"troble_shoot"`
	TreatmentPlan                string  `gorm:"column:treatment_plan" json:"treatment_plan" form:"treatment_plan"`
	Doctor                       int64   `gorm:"column:doctor" json:"doctor" form:"doctor"`
	ScheduleRemark               string  `gorm:"column:schedule_remark" json:"schedule_remark" form:"schedule_remark"`
	RecordNumber                 string  `gorm:"column:record_number" json:"record_number" form:"record_number"`
	PatientSource                int64   `gorm:"column:patient_source" json:"patient_source" form:"patient_source"`
	PatientStartTime             int64   `gorm:"column:patient_start_time" json:"patient_start_time" form:"patient_start_time"`
	PatientEndTime               int64   `gorm:"column:patient_end_time" json:"patient_end_time" form:"patient_end_time"`
	InfectiousRemark             string  `gorm:"column:infectious_remark" json:"infectious_remark" form:"infectious_remark"`
	AllergicHistory              string  `gorm:"column:allergic_history" json:"allergic_history" form:"allergic_history"`
	PatientAddress               string  `gorm:"column:patient_address" json:"patient_address" form:"patient_address"`
	FirstLetter                  string  `gorm:"column:first_letter" json:"first_letter" form:"first_letter"`
	PrintDate                    int64   `gorm:"column:print_date" json:"print_date" form:"print_date"`
	FamalityRecord               string  `gorm:"column:famality_record" json:"famality_record" form:"famality_record"`
}

func (XtPatientsNew) TableName() string {
	return "xt_patients_new"
}

type PatientsNew struct {
	ID   int64  `gorm:"column:id" json:"id" form:"id"`
	Name string `gorm:"column:name" json:"name" form:"name"`
}

type CdmPatients struct {
	ID                 int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId          int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	UserId             int64  `gorm:"column:user_id" json:"user_id" form:"user_id"`
	Avatar             string `gorm:"column:avatar" json:"avatar" form:"avatar"`
	PatientType        int64  `gorm:"column:patient_type" json:"patient_type" form:"patient_type"`
	Source             int64  `gorm:"column:source" json:"source" form:"source"`
	Name               string `gorm:"column:name" json:"name" form:"name"`
	Alias              string `gorm:"column:alias" json:"alias" form:"alias"`
	Gender             int64  `gorm:"column:gender" json:"gender" form:"gender"`
	MaritalStatus      int64  `gorm:"column:marital_status" json:"marital_status" form:"marital_status"`
	IdCardNo           string `gorm:"column:id_card_no" json:"id_card_no" form:"id_card_no"`
	Birthday           int64  `gorm:"column:birthday" json:"birthday" form:"birthday"`
	HealthCareType     int64  `gorm:"column:health_care_type" json:"health_care_type" form:"health_care_type"`
	HealthCareNo       string `gorm:"column:health_care_no" json:"health_care_no" form:"health_care_no"`
	Height             int64  `gorm:"column:height" json:"height" form:"height"`
	BloodType          int64  `gorm:"column:blood_type" json:"blood_type" form:"blood_type"`
	Rh                 int64  `gorm:"column:rh" json:"rh" form:"rh"`
	EducationLevel     int64  `gorm:"column:education_level" json:"education_level" form:"education_level"`
	Profession         int64  `gorm:"column:profession" json:"profession" form:"profession"`
	Phone              string `gorm:"column:phone" json:"phone" form:"phone"`
	HomeTelephone      string `gorm:"column:home_telephone" json:"home_telephone" form:"home_telephone"`
	RelativePhone      string `gorm:"column:relative_phone" json:"relative_phone" form:"relative_phone"`
	RelativeRelations  string `gorm:"column:relative_relations" json:"relative_relations" form:"relative_relations"`
	HomeAddress        string `gorm:"column:home_address" json:"home_address" form:"home_address"`
	WorkUnit           string `gorm:"column:work_unit" json:"work_unit" form:"work_unit"`
	UnitAddress        string `gorm:"column:unit_address" json:"unit_address" form:"unit_address"`
	Children           int64  `gorm:"column:children" json:"children" form:"children"`
	AttendingDoctorId  int64  `gorm:"column:attending_doctor_id" json:"attending_doctor_id" form:"attending_doctor_id"`
	HeadNurseId        int64  `gorm:"column:head_nurse_id" json:"head_nurse_id" form:"head_nurse_id"`
	Diagnose           string `gorm:"column:diagnose" json:"diagnose" form:"diagnose"`
	Remark             string `gorm:"column:remark" json:"remark" form:"remark"`
	RegistrarsId       int64  `gorm:"column:registrars_id" json:"registrars_id" form:"registrars_id"`
	Registrars         string `gorm:"column:registrars" json:"registrars" form:"registrars"`
	QrCode             string `gorm:"column:qr_code" json:"qr_code" form:"qr_code"`
	BindingState       int64  `gorm:"column:binding_state" json:"binding_state" form:"binding_state"`
	Status             int64  `gorm:"column:status" json:"status" form:"status"`
	CreatedTime        int64  `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime        int64  `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	UserSysBeforeCount int64  `gorm:"column:user_sys_before_count" json:"user_sys_before_count" form:"user_sys_before_count"`
	SchRemark          string `gorm:"column:sch_remark" json:"sch_remark" form:"sch_remark"`
}

func (CdmPatients) TableName() string {
	return "xt_patients"
}

type CdmPatientsInfectiousDiseases struct {
	ID          int64 `gorm:"column:id" json:"id" form:"id"`
	PatientId   int64 `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	DiseaseId   int64 `gorm:"column:disease_id" json:"disease_id" form:"disease_id"`
	Status      int64 `gorm:"column:status" json:"status" form:"status"`
	CreatedTime int64 `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime int64 `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	UserOrgId   int64 `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
}

func (CdmPatientsInfectiousDiseases) TableName() string {

	return "xt_patients_infectious_diseases"
}

type CdmPatientsChronicDiseases struct {
	ID          int64 `gorm:"column:id" json:"id" form:"id"`
	PatientId   int64 `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	DiseaseId   int64 `gorm:"column:disease_id" json:"disease_id" form:"disease_id"`
	Status      int64 `gorm:"column:status" json:"status" form:"status"`
	CreatedTime int64 `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime int64 `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	UserOrgId   int64 `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
}

func (CdmPatientsChronicDiseases) TableName() string {

	return "xt_patients_chronic_diseases"
}

type SgjUserCustomer struct {
	ID              int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId       int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	UserId          int64  `gorm:"column:user_id" json:"user_id" form:"user_id"`
	Mobile          string `gorm:"column:mobile" json:"mobile" form:"mobile"`
	Name            string `gorm:"column:name" json:"name" form:"name"`
	Gender          int64  `gorm:"column:gender" json:"gender" form:"gender"`
	ProvinceId      int64  `gorm:"column:province_id" json:"province_id" form:"province_id"`
	CityId          int64  `gorm:"column:city_id" json:"city_id" form:"city_id"`
	Address         string `gorm:"column:address" json:"address" form:"address"`
	Birthday        int64  `gorm:"column:birthday" json:"birthday" form:"birthday"`
	TreatType       int64  `gorm:"column:treat_type" json:"treat_type" form:"treat_type"`
	Relationship    int64  `gorm:"column:relationship" json:"relationship" form:"relationship"`
	IllnessId       int64  `gorm:"column:illness_id" json:"illness_id" form:"illness_id"`
	WechatOpenid    string `gorm:"column:wechat_openid" json:"wechat_openid" form:"wechat_openid"`
	Membership      int64  `gorm:"column:membership" json:"membership" form:"membership"`
	Sources         int64  `gorm:"column:sources" json:"sources" form:"sources"`
	Status          int64  `gorm:"column:status" json:"status" form:"status"`
	CreatedTime     int64  `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime     int64  `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	Avatar          string `gorm:"column:avatar" json:"avatar" form:"avatar"`
	WechatUnionid   string `gorm:"column:wechat_unionid" json:"wechat_unionid" form:"wechat_unionid"`
	Remark          string `gorm:"column:remark" json:"remark" form:"remark"`
	MedicalDiagnose string `gorm:"column:medical_diagnose" json:"medical_diagnose" form:"medical_diagnose"`
	YzUid           int64  `gorm:"column:yz_uid" json:"yz_uid" form:"yz_uid"`
	Tttime          int64  `gorm:"column:tttime" json:"tttime" form:"tttime"`
	IllDate         int64  `gorm:"column:ill_date" json:"ill_date" form:"ill_date"`
	DistrictId      int64  `gorm:"column:district_id" json:"district_id" form:"district_id"`
}

func (SgjUserCustomer) TableName() string {
	return "sgj_user_customer"
}

type PatientCourseOfDiseases struct {
	ID         int64  `gorm:"column:id" json:"id" form:"id"`
	OrgId      int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	PatientId  int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Recorder   int64  `gorm:"column:recorder" json:"recorder" form:"recorder"`
	RecordTime int64  `gorm:"column:record_time" json:"record_time" form:"record_time"`
	Content    string `gorm:"column:content" json:"content" form:"content"`
	Status     int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime      int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime      int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Title      string `gorm:"column:title" json:"title" form:"title"`
	UserName   string `gorm:"column:user_name" json:"user_name" form:"user_name"`
}

type PatientCourseOfDiseasess struct {
	ID         int64  `gorm:"column:id" json:"id" form:"id"`
	OrgId      int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	PatientId  int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Recorder   int64  `gorm:"column:recorder" json:"recorder" form:"recorder"`
	RecordTime int64  `gorm:"column:record_time" json:"record_time" form:"record_time"`
	Content    string `gorm:"column:content" json:"content" form:"content"`
	Status     int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime      int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime      int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Title      string `gorm:"column:title" json:"title" form:"title"`
	UserName   string `gorm:"column:user_name" json:"user_name" form:"user_name"`
	Name       string `gorm:"column:name" json:"name" form:"name"`
}

type PatientCourseOfDisease struct {
	ID         int64  `gorm:"column:id" json:"id" form:"id"`
	OrgId      int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	PatientId  int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Recorder   int64  `gorm:"column:recorder" json:"recorder" form:"recorder"`
	RecordTime int64  `gorm:"column:record_time" json:"record_time" form:"record_time"`
	Content    string `gorm:"column:content" json:"content" form:"content"`
	Status     int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime      int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime      int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Title      string `gorm:"column:title" json:"title" form:"title"`
}

func (PatientCourseOfDisease) TableName() string {

	return "xt_patient_course_of_disease"
}

type XtPatientsInfectiousDiseases struct {
	ID          int64 `gorm:"column:id" json:"id" form:"id"`
	PatientId   int64 `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	DiseaseId   int64 `gorm:"column:disease_id" json:"disease_id" form:"disease_id"`
	Status      int64 `gorm:"column:status" json:"status" form:"status"`
	CreatedTime int64 `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime int64 `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
}

func (XtPatientsInfectiousDiseases) TableName() string {

	return "xt_patients_infectious_diseases"
}

type XtInspectionReference struct {
	ID               int64  `gorm:"column:id" json:"id" form:"id"`
	OrgId            int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	ProjectName      string `gorm:"column:project_name" json:"project_name" form:"project_name"`
	Project          string `gorm:"column:project" json:"project" form:"project"`
	ProjectId        int64  `gorm:"column:project_id" json:"project_id" form:"project_id"`
	ItemName         string `gorm:"column:item_name" json:"item_name" form:"item_name"`
	ItemNameAddition string `gorm:"column:item_name_addition" json:"item_name_addition" form:"item_name_addition"`
	ItemId           int64  `gorm:"column:item_id" json:"item_id" form:"item_id"`
	Item             string `gorm:"column:item" json:"item" form:"item"`
	RangeType        int64  `gorm:"column:range_type" json:"range_type" form:"range_type"`
	RangeMin         string `gorm:"column:range_min" json:"range_min" form:"range_min"`
	RangeMax         string `gorm:"column:range_max" json:"range_max" form:"range_max"`
	RangeValue       string `gorm:"column:range_value" json:"range_value" form:"range_value"`
	RangeOptions     string `gorm:"column:range_options" json:"range_options" form:"range_options"`
	Unit             string `gorm:"column:unit" json:"unit" form:"unit"`
	Status           int64  `gorm:"column:status" json:"status" form:"status"`
	CreatedTime      int64  `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime      int64  `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
}

func (XtInspectionReference) TableName() string {

	return "xt_inspection_reference"
}

type VmXtInspection struct {
	ID           int64  `gorm:"column:id" json:"id" form:"id"`
	PatientId    int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	OrgId        int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	ProjectId    int64  `gorm:"column:project_id" json:"project_id" form:"project_id"`
	ItemId       int64  `gorm:"column:item_id" json:"item_id" form:"item_id"`
	ItemName     string `gorm:"column:item_name" json:"item_name" form:"item_name"`
	ProjectName  string `gorm:"column:project_name" json:"project_name" form:"project_name"`
	InspectType  int64  `gorm:"column:inspect_type" json:"inspect_type" form:"inspect_type"`
	InspectValue string `gorm:"column:inspect_value" json:"inspect_value" form:"inspect_value"`
	InspectDate  int64  `gorm:"column:inspect_date" json:"inspect_date" form:"inspect_date"`
	Status       int64  `gorm:"column:status" json:"status" form:"status"`
	CreatedTime  int64  `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime  int64  `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	RangeType    int64  `gorm:"column:range_type" json:"range_type" form:"range_type"`
	RangeMin     string `gorm:"column:range_min" json:"range_min" form:"range_min"`
	RangeMax     string `gorm:"column:range_max" json:"range_max" form:"range_max"`
	RangeValue   string `gorm:"column:range_value" json:"range_value" form:"range_value"`
}

type XtInspection struct {
	ID           int64  `gorm:"column:id" json:"id" form:"id"`
	PatientId    int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	OrgId        int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	ProjectId    int64  `gorm:"column:project_id" json:"project_id" form:"project_id"`
	ItemId       int64  `gorm:"column:item_id" json:"item_id" form:"item_id"`
	ItemName     string `gorm:"column:item_name" json:"item_name" form:"item_name"`
	ProjectName  string `gorm:"column:project_name" json:"project_name" form:"project_name"`
	InspectType  int64  `gorm:"column:inspect_type" json:"inspect_type" form:"inspect_type"`
	InspectValue string `gorm:"column:inspect_value" json:"inspect_value" form:"inspect_value"`
	InspectDate  int64  `gorm:"column:inspect_date" json:"inspect_date" form:"inspect_date"`
	Status       int64  `gorm:"column:status" json:"status" form:"status"`
	CreatedTime  int64  `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime  int64  `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
}

func (XtInspection) TableName() string {

	return "xt_inspection"
}

type VmInspection struct {
	ID           int64  `gorm:"column:id" json:"id" form:"id"`
	PatientId    int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	OrgId        int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	ProjectId    int64  `gorm:"column:project_id" json:"project_id" form:"project_id"`
	ItemId       int64  `gorm:"column:item_id" json:"item_id" form:"item_id"`
	ItemName     string `gorm:"column:item_name" json:"item_name" form:"item_name"`
	ProjectName  string `gorm:"column:project_name" json:"project_name" form:"project_name"`
	InspectType  int64  `gorm:"column:inspect_type" json:"inspect_type" form:"inspect_type"`
	InspectValue string `gorm:"column:inspect_value" json:"inspect_value" form:"inspect_value"`
	InspectDate  int64  `gorm:"column:inspect_date" json:"inspect_date" form:"inspect_date"`
	Status       int64  `gorm:"column:status" json:"status" form:"status"`
	CreatedTime  int64  `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime  int64  `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	RangeMin     string `gorm:"column:range_min" json:"range_min" form:"range_min"`
	RangeMax     string `gorm:"column:range_max" json:"range_max" form:"range_max"`
	RangeValue   string `gorm:"column:range_value" json:"range_value" form:"range_value"`
	Unit         string `gorm:"column:unit" json:"unit" form:"unit"`
}

type BloodXtPatients struct {
	ID         int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId  int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	DialysisNo string `gorm:"column:dialysis_no" json:"dialysis_no" form:"dialysis_no"`
	Name       string `gorm:"column:name" json:"name" form:"name"`
	IdCardNo   string `gorm:"column:id_card_no" json:"id_card_no" form:"id_card_no"`
}

func (BloodXtPatients) TableName() string {

	return "xt_patients"
}

type XtPatients struct {
	ID                           int64   `gorm:"column:id" json:"id" form:"id"`
	UserOrgId                    int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	UserId                       int64   `gorm:"column:user_id" json:"user_id" form:"user_id"`
	Avatar                       string  `gorm:"column:avatar" json:"avatar" form:"avatar"`
	PatientType                  int64   `gorm:"column:patient_type" json:"patient_type" form:"patient_type"`
	DialysisNo                   string  `gorm:"column:dialysis_no" json:"dialysis_no" form:"dialysis_no"`
	AdmissionNumber              string  `gorm:"column:admission_number" json:"admission_number" form:"admission_number"`
	Source                       int64   `gorm:"column:source" json:"source" form:"source"`
	Lapseto                      int64   `gorm:"column:lapseto" json:"lapseto" form:"lapseto"`
	PartitionId                  int64   `gorm:"column:partition_id" json:"partition_id" form:"partition_id"`
	BedId                        int64   `gorm:"column:bed_id" json:"bed_id" form:"bed_id"`
	Name                         string  `gorm:"column:name" json:"name" form:"name"`
	Alias                        string  `gorm:"column:alias" json:"alias" form:"alias"`
	Gender                       int64   `gorm:"column:gender" json:"gender" form:"gender"`
	MaritalStatus                int64   `gorm:"column:marital_status" json:"marital_status" form:"marital_status"`
	IdCardNo                     string  `gorm:"column:id_card_no" json:"id_card_no" form:"id_card_no"`
	Birthday                     int64   `gorm:"column:birthday" json:"birthday" form:"birthday"`
	ReimbursementWayId           int64   `gorm:"column:reimbursement_way_id" json:"reimbursement_way_id" form:"reimbursement_way_id"`
	HealthCareType               int64   `gorm:"column:health_care_type" json:"health_care_type" form:"health_care_type"`
	HealthCareNo                 string  `gorm:"column:health_care_no" json:"health_care_no" form:"health_care_no"`
	HealthCareDueDate            int64   `gorm:"column:health_care_due_date" json:"health_care_due_date" form:"health_care_due_date"`
	Height                       int64   `gorm:"column:height" json:"height" form:"height"`
	BloodType                    int64   `gorm:"column:blood_type" json:"blood_type" form:"blood_type"`
	Rh                           int64   `gorm:"column:rh" json:"rh" form:"rh"`
	HealthCareDueAlertDate       int64   `gorm:"column:health_care_due_alert_date" json:"health_care_due_alert_date" form:"health_care_due_alert_date"`
	EducationLevel               int64   `gorm:"column:education_level" json:"education_level" form:"education_level"`
	Profession                   int64   `gorm:"column:profession" json:"profession" form:"profession"`
	Phone                        string  `gorm:"column:phone" json:"phone" form:"phone"`
	HomeTelephone                string  `gorm:"column:home_telephone" json:"home_telephone" form:"home_telephone"`
	RelativePhone                string  `gorm:"column:relative_phone" json:"relative_phone" form:"relative_phone"`
	RelativeRelations            string  `gorm:"column:relative_relations" json:"relative_relations" form:"relative_relations"`
	HomeAddress                  string  `gorm:"column:home_address" json:"home_address" form:"home_address"`
	WorkUnit                     string  `gorm:"column:work_unit" json:"work_unit" form:"work_unit"`
	UnitAddress                  string  `gorm:"column:unit_address" json:"unit_address" form:"unit_address"`
	Children                     int64   `gorm:"column:children" json:"children" form:"children"`
	ReceivingDate                int64   `gorm:"column:receiving_date" json:"receiving_date" form:"receiving_date"`
	IsHospitalFirstDialysis      int64   `gorm:"column:is_hospital_first_dialysis" json:"is_hospital_first_dialysis" form:"is_hospital_first_dialysis"`
	FirstDialysisDate            int64   `gorm:"column:first_dialysis_date" json:"first_dialysis_date" form:"first_dialysis_date"`
	FirstDialysisHospital        string  `gorm:"column:first_dialysis_hospital" json:"first_dialysis_hospital" form:"first_dialysis_hospital"`
	PredialysisCondition         string  `gorm:"column:predialysis_condition" json:"predialysis_condition" form:"predialysis_condition"`
	PreHospitalDialysisFrequency string  `gorm:"column:pre_hospital_dialysis_frequency" json:"pre_hospital_dialysis_frequency" form:"pre_hospital_dialysis_frequency"`
	PreHospitalDialysisTimes     int64   `gorm:"column:pre_hospital_dialysis_times" json:"pre_hospital_dialysis_times" form:"pre_hospital_dialysis_times"`
	HospitalFirstDialysisDate    int64   `gorm:"column:hospital_first_dialysis_date" json:"hospital_first_dialysis_date" form:"hospital_first_dialysis_date"`
	InductionPeriod              int64   `gorm:"column:induction_period" json:"induction_period" form:"induction_period"`
	InitialDialysis              int64   `gorm:"column:initial_dialysis" json:"initial_dialysis" form:"initial_dialysis"`
	TotalDialysis                int64   `gorm:"column:total_dialysis" json:"total_dialysis" form:"total_dialysis"`
	AttendingDoctorId            int64   `gorm:"column:attending_doctor_id" json:"attending_doctor_id" form:"attending_doctor_id"`
	HeadNurseId                  int64   `gorm:"column:head_nurse_id" json:"head_nurse_id" form:"head_nurse_id"`
	Evaluate                     string  `gorm:"column:evaluate" json:"evaluate" form:"evaluate"`
	Diagnose                     string  `gorm:"column:diagnose" json:"diagnose" form:"diagnose"`
	Remark                       string  `gorm:"column:remark" json:"remark" form:"remark"`
	RegistrarsId                 int64   `gorm:"column:registrars_id" json:"registrars_id" form:"registrars_id"`
	Registrars                   string  `gorm:"column:registrars" json:"registrars" form:"registrars"`
	QrCode                       string  `gorm:"column:qr_code" json:"qr_code" form:"qr_code"`
	BindingState                 int64   `gorm:"column:binding_state" json:"binding_state" form:"binding_state"`
	PatientComplains             string  `gorm:"column:patient_complains" json:"patient_complains" form:"patient_complains"`
	PresentHistory               string  `gorm:"column:present_history" json:"present_history" form:"present_history"`
	PastHistory                  string  `gorm:"column:past_history" json:"past_history" form:"past_history"`
	Temperature                  float64 `gorm:"column:temperature" json:"temperature" form:"temperature"`
	Pulse                        int64   `gorm:"column:pulse" json:"pulse" form:"pulse"`
	Respiratory                  int64   `gorm:"column:respiratory" json:"respiratory" form:"respiratory"`
	Sbp                          int64   `gorm:"column:sbp" json:"sbp" form:"sbp"`
	Dbp                          int64   `gorm:"column:dbp" json:"dbp" form:"dbp"`
	Status                       int64   `gorm:"column:status" json:"status" form:"status"`
	CreatedTime                  int64   `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime                  int64   `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	Nation                       string  `gorm:"column:nation" json:"nation" form:"nation"`
	NativePlace                  string  `gorm:"column:native_place" json:"native_place" form:"native_place"`
	Age                          int64   `gorm:"column:age" json:"age" form:"age"`
	InfectiousNextRecordTime     int64   `gorm:"column:infectious_next_record_time" json:"infectious_next_record_time" form:"infectious_next_record_time"`
	IsInfectious                 int64   `gorm:"column:is_infectious" json:"is_infectious" form:"is_infectious"`
	RemindCycle                  int64   `gorm:"column:remind_cycle" json:"remind_cycle" form:"remind_cycle"`
	ResponseResult               string  `gorm:"column:response_result" json:"response_result" form:"response_result"`
	IsOpenRemind                 int64   `gorm:"column:is_open_remind" json:"is_open_remind" form:"is_open_remind"`
	FirstTreatmentDate           int64   `gorm:"column:first_treatment_date" json:"first_treatment_date" form:"first_treatment_date"`
	DialysisAge                  int64   `gorm:"column:dialysis_age" json:"dialysis_age" form:"dialysis_age"`
	ExpenseKind                  int64   `gorm:"column:expense_kind" json:"expense_kind" form:"expense_kind"`
	TellPhone                    string  `gorm:"column:tell_phone" json:"tell_phone" form:"tell_phone"`
	ContactName                  string  `gorm:"column:contact_name" json:"contact_name" form:"contact_name"`
	UserSysBeforeCount           int64   `gorm:"column:user_sys_before_count" json:"user_sys_before_count" form:"user_sys_before_count"`
	SchRemark                    string  `gorm:"column:sch_remark" json:"sch_remark" form:"sch_remark"`
	ScheduleRemark               string  `gorm:"column:schedule_remark" json:"schedule_remark" form:"schedule_remark"`
	TreatmentPlan                string  `gorm:"column:treatment_plan" json:"treatment_plan" form:"treatment_plan"`
	Url                          string  `gorm:"column:url" json:"url" form:"url"`
	FirstLetter                  string  `gorm:"column:first_letter" json:"first_letter" form:"first_letter"`
}

func (XtPatients) TableName() string {

	return "xt_patients"
}

type SgjUserAdminLoginLog struct {
	ID          int64  `gorm:"column:id" json:"id" form:"id"`
	AdminUserId int64  `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
	OrgId       int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	AppId       int64  `gorm:"column:app_id" json:"app_id" form:"app_id"`
	Ip          string `gorm:"column:ip" json:"ip" form:"ip"`
	OperateType int64  `gorm:"column:operate_type" json:"operate_type" form:"operate_type"`
	AppType     int64  `gorm:"column:app_type" json:"app_type" form:"app_type"`
	Ctime       int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
}

func (SgjUserAdminLoginLog) TableName() string {

	return "sgj_user_admin_login_log"
}

type KyActivityTable struct {
	ID           int64  `gorm:"column:id" json:"id" form:"id"`
	Name         string `gorm:"column:name" json:"name" form:"name"`
	Phone        string `gorm:"column:phone" json:"phone" form:"phone"`
	Address      string `gorm:"column:address" json:"address" form:"address"`
	Position     int64  `gorm:"column:position" json:"position" form:"position"`
	HospitalName string `gorm:"column:hospital_name" json:"hospital_name" form:"hospital_name"`
	IsUser       int64  `gorm:"column:is_user" json:"is_user" form:"is_user"`
	IsThink      int64  `gorm:"column:is_think" json:"is_think" form:"is_think"`
	OtherMode    string `gorm:"column:other_mode" json:"other_mode" form:"other_mode"`
	OtherRemark  string `gorm:"column:other_remark" json:"other_remark" form:"other_remark"`
	Gift         int64  `gorm:"column:gift" json:"gift" form:"gift"`
	OtherMessage string `gorm:"column:other_message" json:"other_message" form:"other_message"`
	UserOrgId    int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status       int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime        int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime        int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	SystemName   string `gorm:"column:system_name" json:"system_name" form:"system_name"`
	AdminUserId  int64  `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
}

func (KyActivityTable) TableName() string {

	return "ky_activity_table"
}

type SgjUserRole struct {
	ID               int64  `gorm:"column:id" json:"id" form:"id"`
	RoleName         string `gorm:"column:role_name" json:"role_name" form:"role_name"`
	RoleIntroduction string `gorm:"column:role_introduction" json:"role_introduction" form:"role_introduction"`
	Creator          int64  `gorm:"column:creator" json:"creator" form:"creator"`
	OrgId            int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	AppId            int64  `gorm:"column:app_id" json:"app_id" form:"app_id"`
	IsSuperAdmin     int64  `gorm:"column:is_super_admin" json:"is_super_admin" form:"is_super_admin"`
	Status           int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime            int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime            int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Number           int64  `gorm:"column:number" json:"number" form:"number"`
	IsSystem         int64  `gorm:"column:is_system" json:"is_system" form:"is_system"`
}

func (SgjUserRole) TableName() string {

	return "sgj_user_role"
}

type ExportErrLog struct {
	ID         int64  `gorm:"column:id" json:"id" form:"id"`
	LogType    int64  `gorm:"column:log_type" json:"log_type" form:"log_type"`
	UserOrgId  int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	ErrMsg     string `gorm:"column:err_msg" json:"err_msg" form:"err_msg"`
	CreateTime int64  `gorm:"column:create_time" json:"create_time" form:"create_time"`
	UpdateTime int64  `gorm:"column:update_time" json:"update_time" form:"update_time"`
	Status     int64  `gorm:"column:status" json:"status" form:"status"`
	ExportTime int64  `gorm:"column:export_time" json:"export_time" form:"export_time"`
}

func (ExportErrLog) TableName() string {
	return "xt_export_err_log"
}

type ExportLog struct {
	ID           int64           `gorm:"column:id" json:"id" form:"id"`
	LogType      int64           `gorm:"column:log_type" json:"log_type" form:"log_type"`
	UserOrgId    int64           `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	TotalNum     int64           `gorm:"column:total_num" json:"total_num" form:"total_num"`
	FailNum      int64           `gorm:"column:fail_num" json:"fail_num" form:"fail_num"`
	SuccessNum   int64           `gorm:"column:success_num" json:"success_num" form:"success_num"`
	CreateTime   int64           `gorm:"column:create_time" json:"create_time" form:"create_time"`
	UpdateTime   int64           `gorm:"column:update_time" json:"update_time" form:"update_time"`
	ExportTime   int64           `gorm:"column:export_time" json:"export_time" form:"export_time"`
	Status       int64           `gorm:"column:status" json:"status" form:"status"`
	ExportErrLog []*ExportErrLog `json:"err_logs" gorm:"foreignkey:ExportTime;AssociationForeignKey:ExportTime;"`
}

func (ExportLog) TableName() string {
	return "xt_export_log"
}

type XtTemplateSummary struct {
	ID                        int64           `gorm:"column:id" json:"id" form:"id"`
	StartYear                 int64           `gorm:"column:start_year" json:"start_year" form:"start_year"`
	StartMonth                int64           `gorm:"column:start_month" json:"start_month" form:"start_month"`
	Radio                     int64           `gorm:"column:radio" json:"radio" form:"radio"`
	Quarter                   int64           `gorm:"column:quarter" json:"quarter" form:"quarter"`
	DryWeight                 float64         `gorm:"column:dry_weight" json:"dry_weight" form:"dry_weight"`
	DialysisCount             int64           `gorm:"column:dialysis_count" json:"dialysis_count" form:"dialysis_count"`
	HdCount                   int64           `gorm:"column:hd_count" json:"hd_count" form:"hd_count"`
	HdfCount                  int64           `gorm:"column:hdf_count" json:"hdf_count" form:"hdf_count"`
	HpCount                   int64           `gorm:"column:hp_count" json:"hp_count" form:"hp_count"`
	OtherCount                int64           `gorm:"column:other_count" json:"other_count" form:"other_count"`
	DialzerApparatus          string          `gorm:"column:dialzer_apparatus" json:"dialzer_apparatus" form:"dialzer_apparatus"`
	PerfusionApparatus        string          `gorm:"column:perfusion_apparatus" json:"perfusion_apparatus" form:"perfusion_apparatus"`
	Anticoagulant             int64           `gorm:"column:anticoagulant" json:"anticoagulant" form:"anticoagulant"`
	Kalium                    float64         `gorm:"column:kalium" json:"kalium" form:"kalium"`
	Autunite                  float64         `gorm:"column:autunite" json:"autunite" form:"autunite"`
	Natrium                   float64         `gorm:"column:natrium" json:"natrium" form:"natrium"`
	Hour                      int64           `gorm:"column:hour" json:"hour" form:"hour"`
	Minute                    int64           `gorm:"column:minute" json:"minute" form:"minute"`
	BeforWeight               float64         `gorm:"column:befor_weight" json:"befor_weight" form:"befor_weight"`
	AfterWeight               float64         `gorm:"column:after_weight" json:"after_weight" form:"after_weight"`
	BeforPressure             string          `gorm:"column:befor_pressure" json:"befor_pressure" form:"befor_pressure"`
	AfterPressure             string          `gorm:"column:after_pressure" json:"after_pressure" form:"after_pressure"`
	TemplateSummaryId         int64           `gorm:"column:template_summary_id" json:"template_summary_id" form:"template_summary_id"`
	TemplateSummaryContent    string          `gorm:"column:template_summary_content" json:"template_summary_content" form:"template_summary_content"`
	TemplatePlanId            int64           `gorm:"column:template_plan_id" json:"template_plan_id" form:"template_plan_id"`
	TemplatePlanContent       string          `gorm:"column:template_plan_content" json:"template_plan_content" form:"template_plan_content"`
	TemplateInspectionId      int64           `gorm:"column:template_inspection_id" json:"template_inspection_id" form:"template_inspection_id"`
	TemplateInspectionContent string          `gorm:"column:template_inspection_content" json:"template_inspection_content" form:"template_inspection_content"`
	AdminUserId               int64           `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
	RecordTime                int64           `gorm:"column:record_time" json:"record_time" form:"record_time"`
	PatientId                 int64           `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	UserOrgId                 int64           `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status                    int64           `gorm:"column:status" json:"status" form:"status"`
	Ctime                     int64           `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                     int64           `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Title                     string          `gorm:"column:title" json:"title" form:"title"`
	ProjectId                 string          `gorm:"column:project_id" json:"project_id" form:"project_id"`
	InspectDate               string          `gorm:"column:inspect_date" json:"inspect_date" form:"inspect_date"`
	Patients                  VmPatients      `gorm:"ForeignKey:PatientId;AssociationForeignKey:ID" json:"patient"`
	Children                  []*VmInspection `gorm:"column:children" json:"children" form:"children"`
}

func (XtTemplateSummary) TableName() string {
	return "xt_template_summary"
}

type VmPatients struct {
	ID                           int64   `gorm:"column:id" json:"id" form:"id"`
	UserOrgId                    int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	UserId                       int64   `gorm:"column:user_id" json:"user_id" form:"user_id"`
	Avatar                       string  `gorm:"column:avatar" json:"avatar" form:"avatar"`
	PatientType                  int64   `gorm:"column:patient_type" json:"patient_type" form:"patient_type"`
	DialysisNo                   string  `gorm:"column:dialysis_no" json:"dialysis_no" form:"dialysis_no"`
	AdmissionNumber              string  `gorm:"column:admission_number" json:"admission_number" form:"admission_number"`
	Source                       int64   `gorm:"column:source" json:"source" form:"source"`
	Lapseto                      int64   `gorm:"column:lapseto" json:"lapseto" form:"lapseto"`
	PartitionId                  int64   `gorm:"column:partition_id" json:"partition_id" form:"partition_id"`
	BedId                        int64   `gorm:"column:bed_id" json:"bed_id" form:"bed_id"`
	Name                         string  `gorm:"column:name" json:"name" form:"name"`
	Alias                        string  `gorm:"column:alias" json:"alias" form:"alias"`
	Gender                       int64   `gorm:"column:gender" json:"gender" form:"gender"`
	MaritalStatus                int64   `gorm:"column:marital_status" json:"marital_status" form:"marital_status"`
	IdCardNo                     string  `gorm:"column:id_card_no" json:"id_card_no" form:"id_card_no"`
	Birthday                     int64   `gorm:"column:birthday" json:"birthday" form:"birthday"`
	ReimbursementWayId           int64   `gorm:"column:reimbursement_way_id" json:"reimbursement_way_id" form:"reimbursement_way_id"`
	HealthCareType               int64   `gorm:"column:health_care_type" json:"health_care_type" form:"health_care_type"`
	HealthCareNo                 string  `gorm:"column:health_care_no" json:"health_care_no" form:"health_care_no"`
	HealthCareDueDate            int64   `gorm:"column:health_care_due_date" json:"health_care_due_date" form:"health_care_due_date"`
	Height                       int64   `gorm:"column:height" json:"height" form:"height"`
	BloodType                    int64   `gorm:"column:blood_type" json:"blood_type" form:"blood_type"`
	Rh                           int64   `gorm:"column:rh" json:"rh" form:"rh"`
	HealthCareDueAlertDate       int64   `gorm:"column:health_care_due_alert_date" json:"health_care_due_alert_date" form:"health_care_due_alert_date"`
	EducationLevel               int64   `gorm:"column:education_level" json:"education_level" form:"education_level"`
	Profession                   int64   `gorm:"column:profession" json:"profession" form:"profession"`
	Phone                        string  `gorm:"column:phone" json:"phone" form:"phone"`
	HomeTelephone                string  `gorm:"column:home_telephone" json:"home_telephone" form:"home_telephone"`
	RelativePhone                string  `gorm:"column:relative_phone" json:"relative_phone" form:"relative_phone"`
	RelativeRelations            string  `gorm:"column:relative_relations" json:"relative_relations" form:"relative_relations"`
	HomeAddress                  string  `gorm:"column:home_address" json:"home_address" form:"home_address"`
	WorkUnit                     string  `gorm:"column:work_unit" json:"work_unit" form:"work_unit"`
	UnitAddress                  string  `gorm:"column:unit_address" json:"unit_address" form:"unit_address"`
	Children                     int64   `gorm:"column:children" json:"children" form:"children"`
	ReceivingDate                int64   `gorm:"column:receiving_date" json:"receiving_date" form:"receiving_date"`
	IsHospitalFirstDialysis      int64   `gorm:"column:is_hospital_first_dialysis" json:"is_hospital_first_dialysis" form:"is_hospital_first_dialysis"`
	FirstDialysisDate            int64   `gorm:"column:first_dialysis_date" json:"first_dialysis_date" form:"first_dialysis_date"`
	FirstDialysisHospital        string  `gorm:"column:first_dialysis_hospital" json:"first_dialysis_hospital" form:"first_dialysis_hospital"`
	PredialysisCondition         string  `gorm:"column:predialysis_condition" json:"predialysis_condition" form:"predialysis_condition"`
	PreHospitalDialysisFrequency string  `gorm:"column:pre_hospital_dialysis_frequency" json:"pre_hospital_dialysis_frequency" form:"pre_hospital_dialysis_frequency"`
	PreHospitalDialysisTimes     int64   `gorm:"column:pre_hospital_dialysis_times" json:"pre_hospital_dialysis_times" form:"pre_hospital_dialysis_times"`
	HospitalFirstDialysisDate    int64   `gorm:"column:hospital_first_dialysis_date" json:"hospital_first_dialysis_date" form:"hospital_first_dialysis_date"`
	InductionPeriod              int64   `gorm:"column:induction_period" json:"induction_period" form:"induction_period"`
	InitialDialysis              int64   `gorm:"column:initial_dialysis" json:"initial_dialysis" form:"initial_dialysis"`
	TotalDialysis                int64   `gorm:"column:total_dialysis" json:"total_dialysis" form:"total_dialysis"`
	AttendingDoctorId            int64   `gorm:"column:attending_doctor_id" json:"attending_doctor_id" form:"attending_doctor_id"`
	HeadNurseId                  int64   `gorm:"column:head_nurse_id" json:"head_nurse_id" form:"head_nurse_id"`
	Evaluate                     string  `gorm:"column:evaluate" json:"evaluate" form:"evaluate"`
	Diagnose                     string  `gorm:"column:diagnose" json:"diagnose" form:"diagnose"`
	Remark                       string  `gorm:"column:remark" json:"remark" form:"remark"`
	RegistrarsId                 int64   `gorm:"column:registrars_id" json:"registrars_id" form:"registrars_id"`
	Registrars                   string  `gorm:"column:registrars" json:"registrars" form:"registrars"`
	QrCode                       string  `gorm:"column:qr_code" json:"qr_code" form:"qr_code"`
	BindingState                 int64   `gorm:"column:binding_state" json:"binding_state" form:"binding_state"`
	PatientComplains             string  `gorm:"column:patient_complains" json:"patient_complains" form:"patient_complains"`
	PresentHistory               string  `gorm:"column:present_history" json:"present_history" form:"present_history"`
	PastHistory                  string  `gorm:"column:past_history" json:"past_history" form:"past_history"`
	Temperature                  float64 `gorm:"column:temperature" json:"temperature" form:"temperature"`
	Pulse                        int64   `gorm:"column:pulse" json:"pulse" form:"pulse"`
	Respiratory                  int64   `gorm:"column:respiratory" json:"respiratory" form:"respiratory"`
	Sbp                          int64   `gorm:"column:sbp" json:"sbp" form:"sbp"`
	Dbp                          int64   `gorm:"column:dbp" json:"dbp" form:"dbp"`
	Status                       int64   `gorm:"column:status" json:"status" form:"status"`
	CreatedTime                  int64   `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime                  int64   `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	Nation                       string  `gorm:"column:nation" json:"nation" form:"nation"`
	NativePlace                  string  `gorm:"column:native_place" json:"native_place" form:"native_place"`
	Age                          int64   `gorm:"column:age" json:"age" form:"age"`
	InfectiousNextRecordTime     int64   `gorm:"column:infectious_next_record_time" json:"infectious_next_record_time" form:"infectious_next_record_time"`
	IsInfectious                 int64   `gorm:"column:is_infectious" json:"is_infectious" form:"is_infectious"`
	IsOpenRemind                 int64   `gorm:"column:is_open_remind" json:"is_open_remind" form:"is_open_remind"`
	RemindCycle                  int64   `gorm:"column:remind_cycle" json:"remind_cycle" form:"remind_cycle"`
	ResponseResult               string  `gorm:"column:response_result" json:"response_result" form:"response_result"`
	FirstTreatmentDate           int64   `gorm:"column:first_treatment_date" json:"first_treatment_date" form:"first_treatment_date"`
	DialysisAge                  int64   `gorm:"column:dialysis_age" json:"dialysis_age" form:"dialysis_age"`
	ExpenseKind                  int64   `gorm:"column:expense_kind" json:"expense_kind" form:"expense_kind"`
	TellPhone                    string  `gorm:"column:tell_phone" json:"tell_phone" form:"tell_phone"`
	ContactName                  string  `gorm:"column:contact_name" json:"contact_name" form:"contact_name"`
	UserSysBeforeCount           int64   `gorm:"column:user_sys_before_count" json:"user_sys_before_count" form:"user_sys_before_count"`
	IsExcelExport                int64   `gorm:"column:is_excel_export" json:"is_excel_export" form:"is_excel_export"`
	SchRemark                    string  `gorm:"column:sch_remark" json:"sch_remark" form:"sch_remark"`
	OutReason                    string  `gorm:"column:out_reason" json:"out_reason" form:"out_reason"`
	DeathTime                    int64   `gorm:"column:death_time" json:"death_time" form:"death_time"`
}

func (VmPatients) TableName() string {
	return "xt_patients"
}

type XtAssessmentBeforeDislysis struct {
	ID                             int64   `gorm:"column:id" json:"id" form:"id"`
	UserOrgId                      int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId                      int64   `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	AssessmentDate                 int64   `gorm:"column:assessment_date" json:"assessment_date" form:"assessment_date"`
	DialysisOrderId                int64   `gorm:"column:dialysis_order_id" json:"dialysis_order_id" form:"dialysis_order_id"`
	Temperature                    float64 `gorm:"column:temperature" json:"temperature" form:"temperature"`
	PulseFrequency                 float64 `gorm:"column:pulse_frequency" json:"pulse_frequency" form:"pulse_frequency"`
	BreathingRate                  string  `gorm:"column:breathing_rate" json:"breathing_rate" form:"breathing_rate"`
	SystolicBloodPressure          float64 `gorm:"column:systolic_blood_pressure" json:"systolic_blood_pressure" form:"systolic_blood_pressure"`
	DiastolicBloodPressure         float64 `gorm:"column:diastolic_blood_pressure" json:"diastolic_blood_pressure" form:"diastolic_blood_pressure"`
	BloodPressureType              int64   `gorm:"column:blood_pressure_type" json:"blood_pressure_type" form:"blood_pressure_type"`
	DryWeight                      float64 `gorm:"column:dry_weight" json:"dry_weight" form:"dry_weight"`
	WeightAfterLastTransparency    float64 `gorm:"column:weight_after_last_transparency" json:"weight_after_last_transparency" form:"weight_after_last_transparency"`
	WeighingWay                    string  `gorm:"column:weighing_way" json:"weighing_way" form:"weighing_way"`
	WeighingBefore                 float64 `gorm:"column:weighing_before" json:"weighing_before" form:"weighing_before"`
	AdditionalWeight               float64 `gorm:"column:additional_weight" json:"additional_weight" form:"additional_weight"`
	WeightBefore                   float64 `gorm:"column:weight_before" json:"weight_before" form:"weight_before"`
	WeightGain                     float64 `gorm:"column:weight_gain" json:"weight_gain" form:"weight_gain"`
	PreloadedDewatering            float64 `gorm:"column:preloaded_dewatering" json:"preloaded_dewatering" form:"preloaded_dewatering"`
	UltrafiltrationAmount          float64 `gorm:"column:ultrafiltration_amount" json:"ultrafiltration_amount" form:"ultrafiltration_amount"`
	DialysisInterphase             string  `gorm:"column:dialysis_interphase" json:"dialysis_interphase" form:"dialysis_interphase"`
	LastPostDialysis               string  `gorm:"column:last_post_dialysis" json:"last_post_dialysis" form:"last_post_dialysis"`
	SymptomBeforeDialysis          string  `gorm:"column:symptom_before_dialysis" json:"symptom_before_dialysis" form:"symptom_before_dialysis"`
	InternalFistula                string  `gorm:"column:internal_fistula" json:"internal_fistula" form:"internal_fistula"`
	InternalFistulaSkin            string  `gorm:"column:internal_fistula_skin" json:"internal_fistula_skin" form:"internal_fistula_skin"`
	CatheterBend                   int64   `gorm:"column:catheter_bend" json:"catheter_bend" form:"catheter_bend"`
	Catheter                       string  `gorm:"column:catheter" json:"catheter" form:"catheter"`
	Complication                   string  `gorm:"column:complication" json:"complication" form:"complication"`
	Evaluator                      int64   `gorm:"column:evaluator" json:"evaluator" form:"evaluator"`
	Creater                        int64   `gorm:"column:creater" json:"creater" form:"creater"`
	Remark                         string  `gorm:"column:remark" json:"remark" form:"remark"`
	Status                         int64   `gorm:"column:status" json:"status" form:"status"`
	CreatedTime                    int64   `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime                    int64   `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	Modifier                       int64   `gorm:"column:modifier" json:"modifier" form:"modifier"`
	BloodAccessPartId              string  `gorm:"column:blood_access_part_id" json:"blood_access_part_id" form:"blood_access_part_id"`
	BloodAccessPartOperaId         int64   `gorm:"column:blood_access_part_opera_id" json:"blood_access_part_opera_id" form:"blood_access_part_opera_id"`
	IsHemorrhage                   int64   `gorm:"column:is_hemorrhage" json:"is_hemorrhage" form:"is_hemorrhage"`
	Hemorrhage                     string  `gorm:"column:hemorrhage" json:"hemorrhage" form:"hemorrhage"`
	HemorrhageOther                string  `gorm:"column:hemorrhage_other" json:"hemorrhage_other" form:"hemorrhage_other"`
	PunctureMethod                 string  `gorm:"column:puncture_method" json:"puncture_method" form:"puncture_method"`
	BloodAccessInternalFistula     string  `gorm:"column:blood_access_internal_fistula" json:"blood_access_internal_fistula" form:"blood_access_internal_fistula"`
	InternalFistulaOther           string  `gorm:"column:internal_fistula_other" json:"internal_fistula_other" form:"internal_fistula_other"`
	BloodAccessNoise               int64   `gorm:"column:blood_access_noise" json:"blood_access_noise" form:"blood_access_noise"`
	PunctureWay                    string  `gorm:"column:puncture_way" json:"puncture_way" form:"puncture_way"`
	VenousCatheterization          int64   `gorm:"column:venous_catheterization" json:"venous_catheterization" form:"venous_catheterization"`
	VenousCatheterizationPart      int64   `gorm:"column:venous_catheterization_part" json:"venous_catheterization_part" form:"venous_catheterization_part"`
	VenousCatheterizationPartOther string  `gorm:"column:venous_catheterization_part_other" json:"venous_catheterization_part_other" form:"venous_catheterization_part_other"`
	DuctusArantii                  string  `gorm:"column:ductus_arantii" json:"ductus_arantii" form:"ductus_arantii"`
	EmergencyTreatment             int64   `gorm:"column:emergency_treatment" json:"emergency_treatment" form:"emergency_treatment"`
	EmergencyTreatmentOther        string  `gorm:"column:emergency_treatment_other" json:"emergency_treatment_other" form:"emergency_treatment_other"`
	DialysisCount                  string  `gorm:"column:dialysis_count" json:"dialysis_count" form:"dialysis_count"`
	AssessmentDoctor               int64   `gorm:"column:assessment_doctor" json:"assessment_doctor" form:"assessment_doctor"`
	AssessmentTime                 int64   `gorm:"column:assessment_time" json:"assessment_time" form:"assessment_time"`
	MachineType                    string  `gorm:"column:machine_type" json:"machine_type" form:"machine_type"`
	IsInfect                       int64   `gorm:"column:is_infect" json:"is_infect" form:"is_infect"`
	Exposed                        float64 `gorm:"column:exposed" json:"exposed" form:"exposed"`
	Skin                           string  `gorm:"column:skin" json:"skin" form:"skin"`
	SkinOther                      string  `gorm:"column:skin_other" json:"skin_other" form:"skin_other"`
	InfectOther                    string  `gorm:"column:infect_other" json:"infect_other" form:"infect_other"`
	DuctusArantiiOther             string  `gorm:"column:ductus_arantii_other" json:"ductus_arantii_other" form:"ductus_arantii_other"`
	PunctureNeedle                 string  `gorm:"column:puncture_needle" json:"puncture_needle" form:"puncture_needle"`
	DialysisIntakesUnit            int64   `gorm:"column:dialysis_intakes_unit" json:"dialysis_intakes_unit" form:"dialysis_intakes_unit"`
	HumorExcessiveSymptom          string  `gorm:"column:humor_excessive_symptom" json:"humor_excessive_symptom" form:"humor_excessive_symptom"`
	LastPostDialysisOther          string  `gorm:"column:last_post_dialysis_other" json:"last_post_dialysis_other" form:"last_post_dialysis_other"`
	SymptomBeforeDialysisOther     string  `gorm:"column:symptom_before_dialysis_other" json:"symptom_before_dialysis_other" form:"symptom_before_dialysis_other"`
	DialysisInterphaseOther        string  `gorm:"column:dialysis_interphase_other" json:"dialysis_interphase_other" form:"dialysis_interphase_other"`
	Pinholing                      string  `gorm:"column:pinholing" json:"pinholing" form:"pinholing"`
	CatheterSuture                 string  `gorm:"column:catheter_suture" json:"catheter_suture" form:"catheter_suture"`
	CatheterSutureOther            string  `gorm:"column:catheter_suture_other" json:"catheter_suture_other" form:"catheter_suture_other"`
	UrineVolume                    float64 `gorm:"column:urine_volume" json:"urine_volume" form:"urine_volume"`
	Edema                          string  `gorm:"column:edema" json:"edema" form:"edema"`
	SpecialTreatment               string  `gorm:"column:special_treatment" json:"special_treatment" form:"special_treatment"`
	CatheterMaintenance            string  `gorm:"column:catheter_maintenance" json:"catheter_maintenance" form:"catheter_maintenance"`
	ThrombusAv                     string  `gorm:"column:thrombus_av" json:"thrombus_av" form:"thrombus_av"`
	ThromubusA                     string  `gorm:"column:thromubus_a" json:"thromubus_a" form:"thromubus_a"`
	ThromubusV                     string  `gorm:"column:thromubus_v" json:"thromubus_v" form:"thromubus_v"`
	ThromubusType                  int64   `gorm:"column:thromubus_type" json:"thromubus_type" form:"thromubus_type"`
	Dehydration                    string  `gorm:"column:dehydration" json:"dehydration" form:"dehydration"`
	PreDialysisDrugs               string  `gorm:"column:pre_dialysis_drugs" json:"pre_dialysis_drugs" form:"pre_dialysis_drugs"`
	EstimatedFoodIntake            string  `gorm:"column:estimated_food_intake" json:"estimated_food_intake" form:"estimated_food_intake"`
	Period                         int64   `gorm:"column:period" json:"period" form:"period"`
	BloodPressureDuringDialysis    string  `gorm:"column:blood_pressure_during_dialysis" json:"blood_pressure_during_dialysis" form:"blood_pressure_during_dialysis"`
}

func (XtAssessmentBeforeDislysis) TableName() string {
	return "xt_assessment_before_dislysis"
}

type MsDeviceNumber struct {
	ID      int64  `gorm:"column:id" json:"id" form:"id"`
	OrgId   int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	Number  string `gorm:"column:number" json:"number" form:"number"`
	GroupId int64  `gorm:"column:group_id" json:"group_id" form:"group_id"`
	ZoneId  int64  `gorm:"column:zone_id" json:"zone_id" form:"zone_id"`
	Status  int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime   int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime   int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Sort    int64  `gorm:"column:sort" json:"sort" form:"sort"`
}

func (MsDeviceNumber) TableName() string {
	return "xt_device_number"
}

type MsDeviceZone struct {
	ID     int64  `gorm:"column:id" json:"id" form:"id"`
	OrgId  int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	Name   string `gorm:"column:name" json:"name" form:"name"`
	Type   int64  `gorm:"column:type" json:"type" form:"type"`
	Status int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime  int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime  int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Sort   int64  `gorm:"column:sort" json:"sort" form:"sort"`
}

func (MsDeviceZone) TableName() string {
	return "xt_device_zone"
}

type XtHospitalSummary struct {
	ID                       int64  `gorm:"column:id" json:"id" form:"id"`
	PatientId                int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	AdmissionTime            int64  `gorm:"column:admission_time" json:"admission_time" form:"admission_time"`
	DischargeTime            int64  `gorm:"column:discharge_time" json:"discharge_time" form:"discharge_time"`
	SickPersonnel            string `gorm:"column:sick_personnel" json:"sick_personnel" form:"sick_personnel"`
	Xray                     string `gorm:"column:xray" json:"xray" form:"xray"`
	Connecticut              string `gorm:"column:connecticut" json:"connecticut" form:"connecticut"`
	NuclearMagneticResonance string `gorm:"column:nuclear_magnetic_resonance" json:"nuclear_magnetic_resonance" form:"nuclear_magnetic_resonance"`
	Ultrasound               string `gorm:"column:ultrasound" json:"ultrasound" form:"ultrasound"`
	Pathology                string `gorm:"column:pathology" json:"pathology" form:"pathology"`
	AdmittingDiagnosisId     string `gorm:"column:admitting_diagnosis_id" json:"admitting_diagnosis_id" form:"admitting_diagnosis_id"`
	AdmittingDiagnosis       string `gorm:"column:admitting_diagnosis" json:"admitting_diagnosis" form:"admitting_diagnosis"`
	DischargeDiagnosisId     string `gorm:"column:discharge_diagnosis_id" json:"discharge_diagnosis_id" form:"discharge_diagnosis_id"`
	DischargeDiagnosis       string `gorm:"column:discharge_diagnosis" json:"discharge_diagnosis" form:"discharge_diagnosis"`
	DiagnosisAdmissionId     string `gorm:"column:diagnosis_admission_id" json:"diagnosis_admission_id" form:"diagnosis_admission_id"`
	DiagnosisAdmission       string `gorm:"column:diagnosis_admission" json:"diagnosis_admission" form:"diagnosis_admission"`
	TreatmentId              string `gorm:"column:treatment_id" json:"treatment_id" form:"treatment_id"`
	Treatment                string `gorm:"column:treatment" json:"treatment" form:"treatment"`
	IllnessDischargeId       string `gorm:"column:illness_discharge_id" json:"illness_discharge_id" form:"illness_discharge_id"`
	IllnessDischarge         string `gorm:"column:illness_discharge" json:"illness_discharge" form:"illness_discharge"`
	DischargeAdviceId        string `gorm:"column:discharge_advice_id" json:"discharge_advice_id" form:"discharge_advice_id"`
	DischargeAdvice          string `gorm:"column:discharge_advice" json:"discharge_advice" form:"discharge_advice"`
	UserOrgId                int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status                   int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime                    int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                    int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	RecordTime               int64  `gorm:"column:record_time" json:"record_time" form:"record_time"`
	Title                    string `gorm:"column:title" json:"title" form:"title"`
	Doctor                   int64  `gorm:"column:doctor" json:"doctor" form:"doctor"`
	RecordDate               int64  `gorm:"column:record_date" json:"record_date" form:"record_date"`
	DeanId                   int64  `gorm:"column:dean_id" json:"dean_id" form:"dean_id"`
}

func (XtHospitalSummary) TableName() string {
	return "xt_hospital_summary"
}

type VmDialysisSolution struct {
	UserOrgId                  int64                 `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId                  int64                 `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	DialysisStrainer           string                `gorm:"column:dialysis_strainer" json:"dialysis_strainer" form:"dialysis_strainer"`
	DialysisDialyszers         string                `gorm:"column:dialysis_dialyszers" json:"dialysis_dialyszers" form:"dialysis_dialyszers"`
	DialysisIrrigation         string                `gorm:"column:dialysis_irrigation" json:"dialysis_irrigation" form:"dialysis_irrigation"`
	DialyzerPerfusionApparatus string                `gorm:"column:dialyzer_perfusion_apparatus" json:"dialyzer_perfusion_apparatus"`
	ModeName                   string                `gorm:"column:mode_name" json:"mode_name" form:"mode_name"`
	ModeId                     int64                 `gorm:"column:mode_id" json:"mode_id" form:"mode_id"`
	Anticoagulant              int64                 `gorm:"column:anticoagulant" json:"anticoagulant" form:"anticoagulant"`
	DialysisSolution           VmDialysisSolutionOne `gorm:"ForeignKey:PatientId,ModeId;AssociationForeignKey:PatientId,ModeId" json:"solution"`
	SolutionStatus             int64                 `gorm:"column:solution_status" json:"solution_status" form:"solution_status"`
}

func (VmDialysisSolution) TableName() string {
	return "xt_dialysis_solution"
}

type VmDialysisSolutionOne struct {
	UserOrgId                  int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId                  int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	DialysisDialyszers         string `gorm:"column:dialysis_dialyszers" json:"dialysis_dialyszers" form:"dialysis_dialyszers"`
	DialysisIrrigation         string `gorm:"column:dialysis_irrigation" json:"dialysis_irrigation" form:"dialysis_irrigation"`
	DialyzerPerfusionApparatus string `gorm:"column:dialyzer_perfusion_apparatus" json:"dialyzer_perfusion_apparatus"`
	ModeName                   string `gorm:"column:mode_name" json:"mode_name" form:"mode_name"`
	ModeId                     int64  `gorm:"column:mode_id" json:"mode_id" form:"mode_id"`
	SolutionStatus             int64  `gorm:"column:solution_status" json:"solution_status" form:"solution_status"`
	Anticoagulant              int64  `gorm:"column:anticoagulant" json:"anticoagulant" form:"anticoagulant"`
}

func (VmDialysisSolutionOne) TableName() string {
	return "xt_dialysis_solution"
}

type VmDialysisPrescription struct {
	UserOrgId                  int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId                  int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	DialysisDialyszers         string `gorm:"column:dialysis_dialyszers" json:"dialysis_dialyszers" form:"dialysis_dialyszers"`
	DialysisIrrigation         string `gorm:"column:dialysis_irrigation" json:"dialysis_irrigation" form:"dialysis_irrigation"`
	DialyzerPerfusionApparatus string `gorm:"column:dialyzer_perfusion_apparatus" json:"dialyzer_perfusion_apparatus"`
	ModeName                   string `gorm:"column:mode_name" json:"mode_name" form:"mode_name"`
	ModeId                     int64  `gorm:"column:mode_id" json:"mode_id" form:"mode_id"`
	Anticoagulant              int64  `gorm:"column:anticoagulant" json:"anticoagulant" form:"anticoagulant"`
}

func (VmDialysisPrescription) TableName() string {
	return "xt_dialysis_prescription"
}

type XtScheduleList struct {
	UserOrgId            int64                `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PartitionId          int64                `gorm:"column:partition_id" json:"partition_id" form:"partition_id"`
	BedId                int64                `gorm:"column:bed_id" json:"bed_id" form:"bed_id"`
	PatientId            int64                `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	ScheduleDate         int64                `gorm:"column:schedule_date" json:"schedule_date" form:"schedule_date"`
	ScheduleType         int64                `gorm:"column:schedule_type" json:"schedule_type" form:"schedule_type"`
	ScheduleWeek         int64                `gorm:"column:schedule_week" json:"schedule_week" form:"schedule_week"`
	ModeId               int64                `gorm:"column:mode_id" json:"mode_id" form:"mode_id"`
	IsExport             int64                `gorm:"column:is_export" json:"is_export" form:"is_export"`
	DialysisSolution     VmDialysisSolution   `gorm:"ForeignKey:PatientId,ModeId;AssociationForeignKey:PatientId,ModeId" json:"vmsolution"`
	DialysisPrescription DialysisPrescription `gorm:"ForeignKey:PatientId,RecordDate;AssociationForeignKey:PatientId,ScheduleDate" json:"prescription"`
	Status               int64                `gorm:"column:status" json:"status" form:"status"`
}

func (XtScheduleList) TableName() string {
	return "xt_schedule"
}

type DialysisPrescriptionTwenty struct {
	ID                         int64  `gorm:"column:id" json:"id"`
	UserOrgId                  int64  `gorm:"column:user_org_id" json:"user_org_id"`
	PatientId                  int64  `gorm:"column:patient_id" json:"patient_id"`
	ModeId                     int64  `gorm:"column:mode_id" json:"mode_id"`
	Anticoagulant              int64  `gorm:"column:anticoagulant" json:"anticoagulant"`
	DialysateFormulation       int64  `gorm:"column:dialysate_formulation" json:"dialysate_formulation"`
	DialyzerPerfusionApparatus string `gorm:"column:dialyzer_perfusion_apparatus" json:"dialyzer_perfusion_apparatus"`
	DialysisDialyszers         string `gorm:"column:dialysis_dialyszers" json:"dialysis_dialyszers" form:"dialysis_dialyszers"`
	DialysisIrrigation         string `gorm:"column:dialysis_irrigation" json:"dialysis_irrigation" form:"dialysis_irrigation"`
}

func (DialysisPrescriptionTwenty) TableName() string {
	return "xt_dialysis_prescription"
}

type DialysisPrescriptionThrity struct {
	ID             int64  `gorm:"column:id" json:"id"`
	UserOrgId      int64  `gorm:"column:user_org_id" json:"user_org_id"`
	PatientId      int64  `gorm:"column:patient_id" json:"patient_id"`
	Remark         string `gorm:"column:remark" json:"remark" form:"remark"`
	Chaptalization string `gorm:"column:chaptalization" json:"chaptalization" form:"chaptalization"`
}

func (DialysisPrescriptionThrity) TableName() string {
	return "xt_dialysis_prescription"
}

type PatientsThirty struct {
	ID            int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId     int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	DialysisNo    string `gorm:"column:dialysis_no" json:"dialysis_no" form:"dialysis_no"`
	Name          string `gorm:"column:name" json:"name" form:"name"`
	TotalDialysis int64  `gorm:"column:total_dialysis" json:"total_dialysis" form:"total_dialysis"`
	Lapseto       int64  `gorm:"column:lapseto" json:"lapseto" form:"lapseto"`
}

func (PatientsThirty) TableName() string {
	return "xt_patients"
}

type XtNewPatients struct {
	ID                 int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId          int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	DialysisNo         string `gorm:"column:dialysis_no" json:"dialysis_no" form:"dialysis_no"`
	AdmissionNumber    string `gorm:"column:admission_number" json:"admission_number" form:"admission_number"`
	Source             int64  `gorm:"column:source" json:"source" form:"source"`
	Lapseto            int64  `gorm:"column:lapseto" json:"lapseto" form:"lapseto"`
	Name               string `gorm:"column:name" json:"name" form:"name"`
	Gender             int64  `gorm:"column:gender" json:"gender" form:"gender"`
	IdCardNo           string `gorm:"column:id_card_no" json:"id_card_no" form:"id_card_no"`
	Birthday           int64  `gorm:"column:birthday" json:"birthday" form:"birthday"`
	UserSysBeforeCount int64  `gorm:"column:user_sys_before_count" json:"user_sys_before_count" form:"user_sys_before_count"`
	SchRemark          string `gorm:"column:sch_remark" json:"sch_remark" form:"sch_remark"`
	ScheduleRemark     string `gorm:"column:schedule_remark" json:"schedule_remark" form:"schedule_remark"`
	Status             int64  `gorm:"column:status" json:"status" form:"status"`
}

func (XtNewPatients) TableName() string {

	return "xt_patients"
}

type XtNewAssessmentBeforeDislysis struct {
	ID                    int64   `gorm:"column:id" json:"id" form:"id"`
	UserOrgId             int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId             int64   `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	AssessmentDate        int64   `gorm:"column:assessment_date" json:"assessment_date" form:"assessment_date"`
	DryWeight             float64 `gorm:"column:dry_weight" json:"dry_weight" form:"dry_weight"`
	WeightBefore          float64 `gorm:"column:weight_before" json:"weight_before" form:"weight_before"`
	UltrafiltrationAmount float64 `gorm:"column:ultrafiltration_amount" json:"ultrafiltration_amount" form:"ultrafiltration_amount"`
	Remark                string  `gorm:"column:remark" json:"remark" form:"remark"`
	Status                int64   `gorm:"column:status" json:"status" form:"status"`
}

func (XtNewAssessmentBeforeDislysis) TableName() string {
	return "xt_assessment_before_dislysis"
}

type NewDialysisSolution struct {
	ID                     int64   `gorm:"column:id" json:"id" form:"id"`
	Name                   string  `gorm:"column:name" json:"name" form:"name"`
	UserOrgId              int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId              int64   `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Type                   int64   `gorm:"column:type" json:"type" form:"type"`
	Anticoagulant          int64   `gorm:"column:anticoagulant" json:"anticoagulant" form:"anticoagulant"`
	AnticoagulantShouji    float64 `gorm:"column:anticoagulant_shouji" json:"anticoagulant_shouji" form:"anticoagulant_shouji"`
	AnticoagulantWeichi    float64 `gorm:"column:anticoagulant_weichi" json:"anticoagulant_weichi" form:"anticoagulant_weichi"`
	AnticoagulantZongliang float64 `gorm:"column:anticoagulant_zongliang" json:"anticoagulant_zongliang" form:"anticoagulant_zongliang"`
	ModeName               string  `gorm:"column:mode_name" json:"mode_name" form:"mode_name"`
	ModeId                 int64   `gorm:"column:mode_id" json:"mode_id" form:"mode_id"`
	Glucose                float64 `gorm:"column:glucose" json:"glucose" form:"glucose"`
	Kalium                 float64 `gorm:"column:kalium" json:"kalium" form:"kalium"`
	Sodium                 float64 `gorm:"column:sodium" json:"sodium" form:"sodium"`
	Calcium                float64 `gorm:"column:calcium" json:"calcium" form:"calcium"`
	Remark                 string  `gorm:"column:remark" json:"remark" form:"remark"`
	Status                 int64   `gorm:"column:status" json:"status" form:"status"`
	Ultrafiltration        float64 `gorm:"column:ultrafiltration" json:"ultrafiltration"`
	DialysisDurationHour   int64   `gorm:"column:dialysis_duration_hour" json:"dialysis_duration_hour" form:"dialysis_duration_hour"`
	DialysisDurationMinute int64   `gorm:"column:dialysis_duration_minute" json:"dialysis_duration_minute" form:"dialysis_duration_minute"`
	TargetUltrafiltration  float64 `gorm:"column:target_ultrafiltration" json:"target_ultrafiltration" form:"target_ultrafiltration"`
	DialysisDialyszers     string  `gorm:"column:dialysis_dialyszers" json:"dialysis_dialyszers" form:"dialysis_dialyszers"`
	DialysisIrrigation     string  `gorm:"column:dialysis_irrigation" json:"dialysis_irrigation" form:"dialysis_irrigation"`
	MaxUltrafiltrationRate float64 `gorm:"column:max_ultrafiltration_rate" json:"max_ultrafiltration_rate" form:"max_ultrafiltration_rate"`
	SolutionStatus         int64   `gorm:"column:solution_status" json:"solution_status" form:"solution_status"`
	DialysisRemark         string  `gorm:"column:dialysis_remark" json:"dialysis_remark" form:"dialysis_remark"`
	BloodAccess            int64   `gorm:"column:blood_access" json:"blood_access"`
}

func (NewDialysisSolution) TableName() string {
	return "xt_dialysis_solution"
}

type NewDialysisPrescription struct {
	ID                         int64   `gorm:"column:id" json:"id"`
	UserOrgId                  int64   `gorm:"column:user_org_id" json:"user_org_id"`
	PatientId                  int64   `gorm:"column:patient_id" json:"patient_id"`
	Dialyzer                   int64   `gorm:"column:dialyzer" json:"dialyzer"`
	Anticoagulant              int64   `gorm:"column:anticoagulant" json:"anticoagulant"`
	AnticoagulantShouji        float64 `gorm:"column:anticoagulant_shouji" json:"anticoagulant_shouji"`
	AnticoagulantWeichi        float64 `gorm:"column:anticoagulant_weichi" json:"anticoagulant_weichi"`
	AnticoagulantZongliang     float64 `gorm:"column:anticoagulant_zongliang" json:"anticoagulant_zongliang"`
	ModeId                     int64   `gorm:"column:mode_id" json:"mode_id"`
	DialysisDuration           float64 `gorm:"column:dialysis_duration" json:"dialysis_duration"`
	ReplacementTotal           float64 `gorm:"column:replacement_total" json:"replacement_total"`
	ReplacementWay             int64   `gorm:"column:replacement_way" json:"replacement_way"`
	HemodialysisMachine        int64   `gorm:"column:hemodialysis_machine" json:"hemodialysis_machine"`
	Remark                     string  `gorm:"column:remark" json:"remark"`
	Status                     int64   `gorm:"column:status" json:"status"`
	RecordDate                 int64   `gorm:"column:record_date" json:"record_date"`
	DialysisDurationHour       int64   `gorm:"column:dialysis_duration_hour" json:"dialysis_duration_hour"`
	DialysisDurationMinute     int64   `gorm:"column:dialysis_duration_minute" json:"dialysis_duration_minute"`
	DialysateFormulation       int64   `gorm:"column:dialysate_formulation" json:"dialysate_formulation"`
	TargetUltrafiltration      float64 `gorm:"column:target_ultrafiltration" json:"target_ultrafiltration"`
	BloodAccess                int64   `gorm:"column:blood_access" json:"blood_access"`
	Ultrafiltration            float64 `gorm:"column:ultrafiltration" json:"ultrafiltration"`
	Dialyzers                  int64   `gorm:"column:dialyzers" json:"dialyzers"`
	Blood                      string  `gorm:"column:blood" json:"blood"`
	DialysisDialyszers         string  `gorm:"column:dialysis_dialyszers" json:"dialysis_dialyszers" form:"dialysis_dialyszers"`
	DialysisIrrigation         string  `gorm:"column:dialysis_irrigation" json:"dialysis_irrigation" form:"dialysis_irrigation"`
	AdminUserId                int64   `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
	DialysisRemark             string  `gorm:"column:dialysis_remark" json:"dialysis_remark" form:"dialysis_remark"`
	DialyzerPerfusionApparatus string  `gorm:"column:dialyzer_perfusion_apparatus" json:"dialyzer_perfusion_apparatus"`
	DialysateFlow              float64 `gorm:"column:dialysate_flow" json:"dialysate_flow" form:"dialysate_flow"`
	DisplaceLiquiValue         float64 `gorm:"column:displace_liqui_value" json:"displace_liqui_value" form:"displace_liqui_value"`
	BloodFlowVolume            float64 `gorm:"column:blood_flow_volume" json:"blood_flow_volume" form:"blood_flow_volume"`
	PrescriptionWater          float64 `gorm:"column:prescription_water" json:"prescription_water" form:"prescription_water"`
	DisplaceLiquiPart          int64   `gorm:"column:displace_liqui_part" json:"displace_liqui_part" form:"displace_liqui_part"`
}

func (NewDialysisPrescription) TableName() string {
	return "xt_dialysis_prescription"
}

type NewDialysisSolutionOne struct {
	ID                         int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId                  int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId                  int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	ModeId                     int64  `gorm:"column:mode_id" json:"mode_id" form:"mode_id"`
	Status                     int64  `gorm:"column:status" json:"status" form:"status"`
	DialyzerPerfusionApparatus string `gorm:"column:dialyzer_perfusion_apparatus" json:"dialyzer_perfusion_apparatus"`
	DialysisDialyszers         string `gorm:"column:dialysis_dialyszers" json:"dialysis_dialyszers" form:"dialysis_dialyszers"`
	DialysisIrrigation         string `gorm:"column:dialysis_irrigation" json:"dialysis_irrigation" form:"dialysis_irrigation"`
	SolutionStatus             int64  `gorm:"column:solution_status" json:"solution_status" form:"solution_status"`
}

func (NewDialysisSolutionOne) TableName() string {
	return "xt_dialysis_solution"
}

type XtPatientFirstDisease struct {
	ID                    int64  `gorm:"column:id" json:"id" form:"id"`
	Title                 string `gorm:"column:title" json:"title" form:"title"`
	RecordDate            int64  `gorm:"column:record_date" json:"record_date" form:"record_date"`
	Doctor                int64  `gorm:"column:doctor" json:"doctor" form:"doctor"`
	MainContent           string `gorm:"column:main_content" json:"main_content" form:"main_content"`
	PatientCase           string `gorm:"column:patient_case" json:"patient_case" form:"patient_case"`
	TentativeDiagnosis    string `gorm:"column:tentative_diagnosis" json:"tentative_diagnosis" form:"tentative_diagnosis"`
	DiagnosticBasis       string `gorm:"column:diagnostic_basis" json:"diagnostic_basis" form:"diagnostic_basis"`
	DifferentialDiagnosis string `gorm:"column:differential_diagnosis" json:"differential_diagnosis" form:"differential_diagnosis"`
	TreatmentPlan         string `gorm:"column:treatment_plan" json:"treatment_plan" form:"treatment_plan"`
	UserOrgId             int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId             int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Ctime                 int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                 int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status                int64  `gorm:"column:status" json:"status" form:"status"`
	ProjectId             string `gorm:"column:project_id" json:"project_id" form:"project_id"`
	InspectDate           string `gorm:"column:inspect_date" json:"inspect_date" form:"inspect_date"`
}

func (XtPatientFirstDisease) TableName() string {
	return "xt_patient_first_disease"
}

type XtDialysisFinish struct {
	ID         int64 `gorm:"column:id" json:"id" form:"id"`
	IsFinish   int64 `gorm:"column:is_finish" json:"is_finish" form:"is_finish"`
	UserOrgId  int64 `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status     int64 `gorm:"column:status" json:"status" form:"status"`
	Ctime      int64 `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime      int64 `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Module     int64 `gorm:"column:module" json:"module" form:"module"`
	RecordDate int64 `gorm:"column:record_date" json:"record_date" form:"record_date"`
	Sourse     int64 `gorm:"column:sourse" json:"sourse" form:"sourse"`
	PatientId  int64 `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
}

func (XtDialysisFinish) TableName() string {
	return "xt_dialysis_finish"
}

type XtDialysisInformaitonSetting struct {
	ID        int64 `gorm:"column:id" json:"id" form:"id"`
	WeekDay   int64 `gorm:"column:week_day" json:"week_day" form:"week_day"`
	UserOrgId int64 `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status    int64 `gorm:"column:status" json:"status" form:"status"`
	Ctime     int64 `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64 `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtDialysisInformaitonSetting) TableName() string {
	return "xt_dialysis_informaiton_setting"
}

type XtPatientSickHistory struct {
	ID                      int64                  `gorm:"column:id" json:"id" form:"id"`
	OrgId                   int64                  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	PatientId               int64                  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Recorder                int64                  `gorm:"column:recorder" json:"recorder" form:"recorder"`
	RecordTime              int64                  `gorm:"column:record_time" json:"record_time" form:"record_time"`
	RecordDate              int64                  `gorm:"column:record_date" json:"record_date" form:"record_date"`
	Content                 string                 `gorm:"column:content" json:"content" form:"content"`
	Status                  int64                  `gorm:"column:status" json:"status" form:"status"`
	Ctime                   int64                  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                   int64                  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Title                   string                 `gorm:"column:title" json:"title" form:"title"`
	IsShenyizhiHistory      int64                  `gorm:"column:is_shenyizhi_history" json:"is_shenyizhi_history" form:"is_shenyizhi_history"`
	IsFumoDialysisHistory   int64                  `gorm:"column:is_fumo_dialysis_history" json:"is_fumo_dialysis_history" form:"is_fumo_dialysis_history"`
	HypersusceptibilityDesc string                 `gorm:"column:hypersusceptibility_desc" json:"hypersusceptibility_desc" form:"hypersusceptibility_desc"`
	DoctorId                int64                  `gorm:"column:doctor_id" json:"doctor_id" form:"doctor_id"`
	IsHypersusceptibility   int64                  `gorm:"column:is_hypersusceptibility" json:"is_hypersusceptibility" form:"is_hypersusceptibility"`
	XtPatientPhysiqueCheck  XtPatientPhysiqueCheck `gorm:"json:"ppc"`
}

func (XtPatientSickHistory) TableName() string {
	return "xt_patient_sick_history"
}

type XtPatientPhysiqueCheck struct {
	ID         int64 `gorm:"column:id" json:"id" form:"id"`
	OrgId      int64 `gorm:"column:org_id" json:"org_id" form:"org_id"`
	PatientId  int64 `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Recorder   int64 `gorm:"column:recorder" json:"recorder" form:"recorder"`
	RecordTime int64 `gorm:"column:record_time" json:"record_time" form:"record_time"`
	RecordDate int64 `gorm:"column:record_date" json:"record_date" form:"record_date"`

	Status           int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime            int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime            int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	T                string `gorm:"column:t" json:"t" form:"t"`
	P                string `gorm:"column:p" json:"p" form:"p"`
	R                string `gorm:"column:r" json:"r" form:"r"`
	BpRight          string `gorm:"column:bp_right" json:"bp_right" form:"bp_right"`
	BpLeft           string `gorm:"column:bp_left" json:"bp_left" form:"bp_left"`
	Pinxuerongmao    int64  `gorm:"column:pinxuerongmao" json:"pinxuerongmao" form:"pinxuerongmao"`
	Tiwei            int64  `gorm:"column:tiwei" json:"tiwei" form:"tiwei"`
	Fuzhong          int64  `gorm:"column:fuzhong" json:"fuzhong" form:"fuzhong"`
	Chuxuedian       int64  `gorm:"column:chuxuedian" json:"chuxuedian" form:"chuxuedian"`
	Fayu             int64  `gorm:"column:fayu" json:"fayu" form:"fayu"`
	Yinyang          int64  `gorm:"column:yinyang" json:"yinyang" form:"yinyang"`
	Shenzhi          int64  `gorm:"column:shenzhi" json:"shenzhi" form:"shenzhi"`
	Pifunianmo       int64  `gorm:"column:pifunianmo" json:"pifunianmo" form:"pifunianmo"`
	Buwei            string `gorm:"column:buwei" json:"buwei" form:"buwei"`
	Chengdu          string `gorm:"column:chengdu" json:"chengdu" form:"chengdu"`
	Pixiachuxue      int64  `gorm:"column:pixiachuxue" json:"pixiachuxue" form:"pixiachuxue"`
	Zidian           int64  `gorm:"column:zidian" json:"zidian" form:"zidian"`
	Pifuwendu        int64  `gorm:"column:pifuwendu" json:"pifuwendu" form:"pifuwendu"`
	Qita             string `gorm:"column:qita" json:"qita" form:"qita"`
	Linbazhongda     int64  `gorm:"column:linbazhongda" json:"linbazhongda" form:"linbazhongda"`
	Linbabuwei       string `gorm:"column:linbabuwei" json:"linbabuwei" form:"linbabuwei"`
	Yanlian          int64  `gorm:"column:yanlian" json:"yanlian" form:"yanlian"`
	Tongkong         int64  `gorm:"column:tongkong" json:"tongkong" form:"tongkong"`
	Zuo              string `gorm:"column:zuo" json:"zuo" form:"zuo"`
	You              string `gorm:"column:you" json:"you" form:"you"`
	Duiguangfanshe   string `gorm:"column:duiguangfanshe" json:"duiguangfanshe" form:"duiguangfanshe"`
	Biantaoti        string `gorm:"column:biantaoti" json:"biantaoti" form:"biantaoti"`
	Yanbu            string `gorm:"column:yanbu" json:"yanbu" form:"yanbu"`
	Toubuqita        string `gorm:"column:toubuqita" json:"toubuqita" form:"toubuqita"`
	Huxiyin          string `gorm:"column:huxiyin" json:"huxiyin" form:"huxiyin"`
	Xiongmomocayin   int64  `gorm:"column:xiongmomocayin" json:"xiongmomocayin" form:"xiongmomocayin"`
	Feizhangbuwei    int64  `gorm:"column:feizhangbuwei" json:"feizhangbuwei" form:"feizhangbuwei"`
	Luoyin           int64  `gorm:"column:luoyin" json:"luoyin" form:"luoyin"`
	Desc             string `gorm:"column:desc" json:"desc" form:"desc"`
	Xinzangdaxiao    int64  `gorm:"column:xinzangdaxiao" json:"xinzangdaxiao" form:"xinzangdaxiao"`
	Xinlv            int64  `gorm:"column:xinlv" json:"xinlv" form:"xinlv"`
	Xinbaomocasheng  int64  `gorm:"column:xinbaomocasheng" json:"xinbaomocasheng" form:"xinbaomocasheng"`
	Zayin            int64  `gorm:"column:zayin" json:"zayin" form:"zayin"`
	Fujiayin         int64  `gorm:"column:fujiayin" json:"fujiayin" form:"fujiayin"`
	Xinzangdesc      string `gorm:"column:xinzangdesc" json:"xinzangdesc" form:"xinzangdesc"`
	Fushuizheng      int64  `gorm:"column:fushuizheng" json:"fushuizheng" form:"fushuizheng"`
	Ganjingjingmai   string `gorm:"column:ganjingjingmai" json:"ganjingjingmai" form:"ganjingjingmai"`
	GangzhangYatong  int64  `gorm:"column:gangzhang_yatong" json:"gangzhang_yatong" form:"gangzhang_yatong"`
	GangzhangKoutong int64  `gorm:"column:gangzhang_koutong" json:"gangzhang_koutong" form:"gangzhang_koutong"`
	PizhangYatong    int64  `gorm:"column:pizhang_yatong" json:"pizhang_yatong" form:"pizhang_yatong"`
	PizhangKoutong   int64  `gorm:"column:pizhang_koutong" json:"pizhang_koutong" form:"pizhang_koutong"`
	ShenzhangYatong  int64  `gorm:"column:shenzhang_yatong" json:"shenzhang_yatong" form:"shenzhang_yatong"`
	ShenzhangKoutong int64  `gorm:"column:shenzhang_koutong" json:"shenzhang_koutong" form:"shenzhang_koutong"`
	FubuDesc         string `gorm:"column:fubu_desc" json:"fubu_desc" form:"fubu_desc"`
	OthDesc          string `gorm:"column:oth_desc" json:"oth_desc" form:"oth_desc"`
	DoctorId         int64  `gorm:"column:doctor_id" json:"doctor_id" form:"doctor_id"`
}

func (XtPatientPhysiqueCheck) TableName() string {
	return "xt_patient_physique_check"
}

type ConScheduleList struct {
	UserOrgId    int64 `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PartitionId  int64 `gorm:"column:partition_id" json:"partition_id" form:"partition_id"`
	BedId        int64 `gorm:"column:bed_id" json:"bed_id" form:"bed_id"`
	PatientId    int64 `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	ScheduleDate int64 `gorm:"column:schedule_date" json:"schedule_date" form:"schedule_date"`
	ScheduleType int64 `gorm:"column:schedule_type" json:"schedule_type" form:"schedule_type"`
	ScheduleWeek int64 `gorm:"column:schedule_week" json:"schedule_week" form:"schedule_week"`
	ModeId       int64 `gorm:"column:mode_id" json:"mode_id" form:"mode_id"`
	IsExport     int64 `gorm:"column:is_export" json:"is_export" form:"is_export"`
	Status       int64 `gorm:"column:status" json:"status" form:"status"`
}

func (ConScheduleList) TableName() string {
	return "xt_schedule"
}

type XtPatientAllergic struct {
	ID             int64  `gorm:"column:id" json:"id" form:"id"`
	PatientId      int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	UserOrgId      int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	StartTime      int64  `gorm:"column:start_time" json:"start_time" form:"start_time"`
	EndTime        int64  `gorm:"column:end_time" json:"end_time" form:"end_time"`
	PatientSource  int64  `gorm:"column:patient_source" json:"patient_source" form:"patient_source"`
	Status         int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime          int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime          int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Remake         string `gorm:"column:remake" json:"remake" form:"remake"`
	PatientAddress string `gorm:"column:patient_address" json:"patient_address" form:"patient_address"`
}

func (XtPatientAllergic) TableName() string {
	return "xt_patient_allergic"
}

type VmDoubleCheck struct {
	ID             int64 `gorm:"column:id" json:"id"`
	UserOrgId      int64 `gorm:"column:user_org_id" json:"user_org_id"`
	PatientId      int64 `gorm:"column:patient_id" json:"patient_id"`
	CheckDate      int64 `gorm:"column:check_date" json:"check_date"`
	Status         int64 `gorm:"column:status" json:"status"`
	Creater        int64 `gorm:"column:creater" json:"creater"`
	Modifier       int64 `gorm:"column:modifier" json:"modifier"`
	CheckTime      int64 `gorm:"column:check_time" json:"check_time"`
	FirstCheckTime int64 `gorm:"column:first_check_time" json:"first_check_time"`
}

func (VmDoubleCheck) TableName() string {
	return "xt_double_check"
}

type XtDialysisPrescriptionLog struct {
	ID          int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId   int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Ctime       int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime       int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	ErrLog      string `gorm:"column:err_log" json:"err_log" form:"err_log"`
	AdminUserId int64  `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
	RecordDate  int64  `gorm:"column:record_date" json:"record_date" form:"record_date"`
	PatientId   int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Source      string `gorm:"column:source" json:"source" form:"source"`
	Status      int64  `gorm:"column:status" json:"status" form:"status"`
}

func (XtDialysisPrescriptionLog) TableName() string {
	return "xt_dialysis_prescription_log"
}

type XtAssessmentBeforeDislysisLog struct {
	ID          int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId   int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	AdminUserId int64  `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
	ErrLog      string `gorm:"column:err_log" json:"err_log" form:"err_log"`
	PatientId   int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	RecordDate  int64  `gorm:"column:record_date" json:"record_date" form:"record_date"`
	Ctime       int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime       int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status      int64  `gorm:"column:status" json:"status" form:"status"`
	Source      string `gorm:"column:source" json:"source" form:"source"`
}

func (XtAssessmentBeforeDislysisLog) TableName() string {
	return "xt_assessment_before_dislysis_log"
}

type XtAssessmentAfterDialysisLog struct {
	ID          int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId   int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId   int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	RecordDate  int64  `gorm:"column:record_date" json:"record_date" form:"record_date"`
	Status      int64  `gorm:"column:status" json:"status" form:"status"`
	ErrLog      string `gorm:"column:err_log" json:"err_log" form:"err_log"`
	AdminUserId int64  `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
	Ctime       int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime       int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Source      string `gorm:"column:source" json:"source" form:"source"`
}

func (XtAssessmentAfterDialysisLog) TableName() string {
	return "xt_assessment_after_dialysis_log"
}

type XtDoctorAdviceLog struct {
	ID          int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId   int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId   int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	AdminUserId int64  `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
	Module      int64  `gorm:"column:module" json:"module" form:"module"`
	ErrLog      string `gorm:"column:err_log" json:"err_log" form:"err_log"`
	Status      int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime       int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime       int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Source      string `gorm:"column:source" json:"source" form:"source"`
	RecordDate  int64  `gorm:"column:record_date" json:"record_date" form:"record_date"`
}

func (XtDoctorAdviceLog) TableName() string {
	return "xt_doctor_advice_log"
}

type XtMonitorRecordLog struct {
	ID          int64  `gorm:"column:id" json:"id" form:"id"`
	RecordDate  int64  `gorm:"column:record_date" json:"record_date" form:"record_date"`
	PatientId   int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Module      int64  `gorm:"column:module" json:"module" form:"module"`
	AdminUserId int64  `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
	Ctime       int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime       int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status      int64  `gorm:"column:status" json:"status" form:"status"`
	UserOrgId   int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	ErrLog      string `gorm:"column:err_log" json:"err_log" form:"err_log"`
	Source      string `gorm:"column:source" json:"source" form:"source"`
}

func (XtMonitorRecordLog) TableName() string {
	return "xt_monitor_record_log"
}

type XtScheduleLog struct {
	ID          int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId   int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	RecordDate  int64  `gorm:"column:record_date" json:"record_date" form:"record_date"`
	Status      int64  `gorm:"column:status" json:"status" form:"status"`
	PatientId   int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Ctime       int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime       int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	ErrLog      string `gorm:"column:err_log" json:"err_log" form:"err_log"`
	Source      string `gorm:"column:source" json:"source" form:"source"`
	Module      int64  `gorm:"column:module" json:"module" form:"module"`
	AdminUserId int64  `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
}

func (XtScheduleLog) TableName() string {
	return "xt_schedule_log"
}

type XtDeviceValsualMap struct {
	ID                           int64                           `gorm:"column:id" json:"id" form:"id"`
	PatientId                    int64                           `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	IsAppend                     int64                           `gorm:"column:is_append" json:"is_append" form:"is_append"`
	IsImgV                       int64                           `gorm:"column:is_img_v" json:"is_img_v" form:"is_img_v"`
	IsImgA                       int64                           `gorm:"column:is_img_a" json:"is_img_a" form:"is_img_a"`
	VNum                         float64                         `gorm:"column:v_num" json:"v_num" form:"v_num"`
	Status                       int64                           `gorm:"column:status" json:"status" form:"status"`
	UserOrgId                    int64                           `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	ATop                         float64                         `gorm:"column:a_top" json:"a_top" form:"a_top"`
	AvBkx                        float64                         `gorm:"column:av_bkx" json:"av_bkx" form:"av_bkx"`
	AvBky                        float64                         `gorm:"column:av_bky" json:"av_bky" form:"av_bky"`
	FangxiangALeft               float64                         `gorm:"column:fangxiang_a_left" json:"fangxiang_a_left" form:"fangxiang_a_left"`
	FangxiangANum                float64                         `gorm:"column:fangxiang_a_num" json:"fangxiang_a_num" form:"fangxiang_a_num"`
	FangxiangATop                float64                         `gorm:"column:fangxiang_a_top" json:"fangxiang_a_top" form:"fangxiang_a_top"`
	FangxiangVLeft               float64                         `gorm:"column:fangxiang_v_left" json:"fangxiang_v_left" form:"fangxiang_v_left"`
	FangxiangVNum                float64                         `gorm:"column:fangxiang_v_num" json:"fangxiang_v_num" form:"fangxiang_v_num"`
	FangxiangVTop                float64                         `gorm:"column:fangxiang_v_top" json:"fangxiang_v_top" form:"fangxiang_v_top"`
	FuzhuALeft                   float64                         `gorm:"column:fuzhu_a_left" json:"fuzhu_a_left" form:"fuzhu_a_left"`
	FuzhuANum                    float64                         `gorm:"column:fuzhu_a_num" json:"fuzhu_a_num" form:"fuzhu_a_num"`
	FuzhuATop                    float64                         `gorm:"column:fuzhu_a_top" json:"fuzhu_a_top" form:"fuzhu_a_top"`
	FuzhuVLeft                   float64                         `gorm:"column:fuzhu_v_left" json:"fuzhu_v_left" form:"fuzhu_v_left"`
	FuzhuVNum                    float64                         `gorm:"column:fuzhu_v_num" json:"fuzhu_v_num" form:"fuzhu_v_num"`
	FuzhuVTop                    float64                         `gorm:"column:fuzhu_v_top" json:"fuzhu_v_top" form:"fuzhu_v_top"`
	ScaleaNum                    float64                         `gorm:"column:scalea_num" json:"scalea_num" form:"scalea_num"`
	ScalevNum                    float64                         `gorm:"column:scalev_num" json:"scalev_num" form:"scalev_num"`
	TextLeft                     float64                         `gorm:"column:text_left" json:"text_left" form:"text_left"`
	TextNum                      float64                         `gorm:"column:text_num" json:"text_num" form:"text_num"`
	TextTop                      float64                         `gorm:"column:text_top" json:"text_top" form:"text_top"`
	VTop                         float64                         `gorm:"column:v_top" json:"v_top" form:"v_top"`
	XuanzhuanA                   float64                         `gorm:"column:xuanzhuan_a" json:"xuanzhuan_a" form:"xuanzhuan_a"`
	XuanzhuanV                   float64                         `gorm:"column:xuanzhuan_v" json:"xuanzhuan_v" form:"xuanzhuan_v"`
	ALeft                        float64                         `gorm:"column:a_left" json:"a_left" form:"a_left"`
	VLeft                        float64                         `gorm:"column:v_left" json:"v_left" form:"v_left"`
	ImgUrl                       string                          `gorm:"column:img_url" json:"img_url" form:"img_url"`
	XtDeviceValsualALeft         []*XtDeviceValsualALeft         `gorm:"ForeignKey:PatientId;AssociationForeignKey:PatientId" json:"DeviceValsualALeft"`
	XtDeviceValsualMapFangxiangA []*XtDeviceValsualMapFangxiangA `gorm:"ForeignKey:PatientId;AssociationForeignKey:PatientId" json:"DeviceValsualMapFangxiangA"`
	XtDeviceValsualMapFangxiangV []*XtDeviceValsualMapFangxiangV `gorm:"ForeignKey:PatientId;AssociationForeignKey:PatientId" json:"DeviceValsualMapFangxiangV"`
	XtDeviceValsualFuzhuA        []*XtDeviceValsualFuzhuA        `gorm:"ForeignKey:PatientId;AssociationForeignKey:PatientId" json:"DeviceValsualFuzhuA"`
	XtDeviceValsualFuzhuV        []*XtDeviceValsualFuzhuV        `gorm:"ForeignKey:PatientId;AssociationForeignKey:PatientId" json:"DeviceValsualFuzhuV"`
	XtDeviceValsualTextArr       []*XtDeviceValsualTextArr       `gorm:"ForeignKey:PatientId;AssociationForeignKey:PatientId" json:"DeviceValsualTextArr"`
	XtDeviceValsualVLeft         []*XtDeviceValsualVLeft         `gorm:"ForeignKey:PatientId;AssociationForeignKey:PatientId" json:"XtDeviceValsualVLeft"`
	DeviceValusalMapArr          []*XtDeviceValusalMapArr        `gorm:"ForeignKey:PatientId;AssociationForeignKey:PatientId" json:"DeviceValusalMapArr"`
	XtDeviceValusalMapVrr        []*XtDeviceValusalMapVrr        `gorm:"ForeignKey:PatientId;AssociationForeignKey:PatientId" json:"DeviceValusalMapVrr"`
}

func (XtDeviceValsualMap) TableName() string {
	return "xt_device_valsual_map"
}

type XtDeviceValsualALeft struct {
	ID        int64   `gorm:"column:id" json:"id" form:"id"`
	ANum      float64 `gorm:"column:a_num" json:"a_num" form:"a_num"`
	MarkNum   float64 `gorm:"column:mark_num" json:"mark_num" form:"mark_num"`
	UserOrgId int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId int64   `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Ctime     int64   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64   `gorm:"column:mtime" json:"mtime" form:"mtime"`
	MapId     int64   `gorm:"column:map_id" json:"map_id" form:"map_id"`
	Status    int64   `gorm:"column:status" json:"status" form:"status"`
}

func (XtDeviceValsualALeft) TableName() string {
	return "xt_device_valsual_a_left"
}

type XtDeviceValsualMapFangxiangA struct {
	ID        int64   `gorm:"column:id" json:"id" form:"id"`
	PatientId int64   `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	UserOrgId int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status    int64   `gorm:"column:status" json:"status" form:"status"`
	Left      float64 `gorm:"column:left" json:"left" form:"left"`
	MarkNum   float64 `gorm:"column:mark_num" json:"mark_num" form:"mark_num"`
	Top       float64 `gorm:"column:top" json:"top" form:"top"`
	MapId     int64   `gorm:"column:map_id" json:"map_id" form:"map_id"`
	Ctime     int64   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64   `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtDeviceValsualMapFangxiangA) TableName() string {
	return "xt_device_valsual_map_fangxiang_a"
}

type XtDeviceValsualMapFangxiangV struct {
	ID        int64   `gorm:"column:id" json:"id" form:"id"`
	PatientId int64   `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	UserOrgId int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status    int64   `gorm:"column:status" json:"status" form:"status"`
	Ctime     int64   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64   `gorm:"column:mtime" json:"mtime" form:"mtime"`
	MarkNum   float64 `gorm:"column:mark_num" json:"mark_num" form:"mark_num"`
	Left      float64 `gorm:"column:left" json:"left" form:"left"`
	Top       float64 `gorm:"column:top" json:"top" form:"top"`
	MapId     int64   `gorm:"column:map_id" json:"map_id" form:"map_id"`
}

func (XtDeviceValsualMapFangxiangV) TableName() string {
	return "xt_device_valsual_map_fangxiang_v"
}

type XtDeviceValsualFuzhuA struct {
	ID        int64   `gorm:"column:id" json:"id" form:"id"`
	PatientId int64   `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	UserOrgId int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status    int64   `gorm:"column:status" json:"status" form:"status"`
	Ctime     int64   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64   `gorm:"column:mtime" json:"mtime" form:"mtime"`
	ALeft     float64 `gorm:"column:a_left" json:"a_left" form:"a_left"`
	AMarkNum  float64 `gorm:"column:a_mark_num" json:"a_mark_num" form:"a_mark_num"`
	ATop      float64 `gorm:"column:a_top" json:"a_top" form:"a_top"`
	MapId     int64   `gorm:"column:map_id" json:"map_id" form:"map_id"`
}

func (XtDeviceValsualFuzhuA) TableName() string {
	return "xt_device_valsual_fuzhu_a"
}

type XtDeviceValsualFuzhuV struct {
	ID        int64   `gorm:"column:id" json:"id" form:"id"`
	PatientId int64   `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	UserOrgId int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status    int64   `gorm:"column:status" json:"status" form:"status"`
	Ctime     int64   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64   `gorm:"column:mtime" json:"mtime" form:"mtime"`
	VMarkNum  float64 `gorm:"column:v_mark_num" json:"v_mark_num" form:"v_mark_num"`
	VLeft     float64 `gorm:"column:v_left" json:"v_left" form:"v_left"`
	VTop      float64 `gorm:"column:v_top" json:"v_top" form:"v_top"`
	MapId     int64   `gorm:"column:map_id" json:"map_id" form:"map_id"`
}

func (XtDeviceValsualFuzhuV) TableName() string {
	return "xt_device_valsual_fuzhu_v"
}

type XtDeviceValsualTextArr struct {
	ID        int64   `gorm:"column:id" json:"id" form:"id"`
	PatientId int64   `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	UserOrgId int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Ctime     int64   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64   `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status    int64   `gorm:"column:status" json:"status" form:"status"`
	Left      float64 `gorm:"column:left" json:"left" form:"left"`
	Text      string  `gorm:"column:text" json:"text" form:"text"`
	Top       float64 `gorm:"column:top" json:"top" form:"top"`
	Width     float64 `gorm:"column:width" json:"width" form:"width"`
	MapId     int64   `gorm:"column:map_id" json:"map_id" form:"map_id"`
}

func (XtDeviceValsualTextArr) TableName() string {
	return "xt_device_valsual_text_arr"
}

type XtDeviceValsualVLeft struct {
	ID        int64   `gorm:"column:id" json:"id" form:"id"`
	PatientId int64   `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	UserOrgId int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status    int64   `gorm:"column:status" json:"status" form:"status"`
	Ctime     int64   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64   `gorm:"column:mtime" json:"mtime" form:"mtime"`
	MarkNum   float64 `gorm:"column:mark_num" json:"mark_num" form:"mark_num"`
	VNum      float64 `gorm:"column:v_num" json:"v_num" form:"v_num"`
	MapId     int64   `gorm:"column:map_id" json:"map_id" form:"map_id"`
}

func (XtDeviceValsualVLeft) TableName() string {
	return "xt_device_valsual_v_left"
}

type XtDeviceValusalMapArr struct {
	ID        int64   `gorm:"column:id" json:"id" form:"id"`
	PatientId int64   `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	UserOrgId int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status    int64   `gorm:"column:status" json:"status" form:"status"`
	MarkNum   float64 `gorm:"column:mark_num" json:"mark_num" form:"mark_num"`
	Left      float64 `gorm:"column:left" json:"left" form:"left"`
	Top       float64 `gorm:"column:top" json:"top" form:"top"`
	IsStatus  float64 `gorm:"column:is_status" json:"is_status" form:"is_status"`
	Ctime     int64   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64   `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtDeviceValusalMapArr) TableName() string {
	return "xt_device_valusal_map_arr"
}

type XtDeviceValusalMapVrr struct {
	ID        int64   `gorm:"column:id" json:"id" form:"id"`
	PatientId int64   `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	UserOrgId int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status    int64   `gorm:"column:status" json:"status" form:"status"`
	MarkNum   float64 `gorm:"column:mark_num" json:"mark_num" form:"mark_num"`
	Left      float64 `gorm:"column:left" json:"left" form:"left"`
	Top       float64 `gorm:"column:top" json:"top" form:"top"`
	IsStatus  float64 `gorm:"column:is_status" json:"is_status" form:"is_status"`
	Ctime     int64   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64   `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtDeviceValusalMapVrr) TableName() string {
	return "xt_device_valusal_map_vrr"
}

type PatientsTwenty struct {
	ID        int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Name      string `gorm:"column:name" json:"name" form:"name"`
	Status    int64  `gorm:"column:status" json:"status" form:"status"`
}

func (PatientsTwenty) TableName() string {
	return "xt_patients"
}

type XtFallOutPrint struct {
	ID        int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Content   string `gorm:"column:content" json:"content" form:"content"`
	Status    int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime     int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtFallOutPrint) TableName() string {
	return "xt_fall_out_print"
}

type XtFilterInformed struct {
	ID        int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Content   string `gorm:"column:content" json:"content" form:"content"`
	Status    int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime     int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtFilterInformed) TableName() string {
	return "xt_filter_informed"
}

type XtProfundaInformed struct {
	ID        int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Content   string `gorm:"column:content" json:"content" form:"content"`
	Status    int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime     int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtProfundaInformed) TableName() string {
	return "xt_profunda_informed"
}

type XtArterOvenous struct {
	ID        int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Content   string `gorm:"column:content" json:"content" form:"content"`
	Status    int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime     int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtArterOvenous) TableName() string {
	return "xt_arter_ovenous"
}

type XtHightRisk struct {
	ID        int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Content   string `gorm:"column:content" json:"content" form:"content"`
	Status    int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime     int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtHightRisk) TableName() string {
	return "xt_hight_risk"
}

type XtAuticoagutionPrint struct {
	ID        int64  `gorm:"column:id" json:"id" form:"id"`
	Content   string `gorm:"column:content" json:"content" form:"content"`
	UserOrgId int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status    int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime     int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtAuticoagutionPrint) TableName() string {
	return "xt_auticoagution_print"
}

type XtCriticalinfomedPrint struct {
	ID        int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Content   string `gorm:"column:content" json:"content" form:"content"`
	Status    int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime     int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtCriticalinfomedPrint) TableName() string {
	return "xt_criticalinfomed_print"
}

type XtHemoperfusionmedPrint struct {
	ID        int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Content   string `gorm:"column:content" json:"content" form:"content"`
	Status    int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime     int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtHemoperfusionmedPrint) TableName() string {
	return "xt_hemoperfusionmed_print"
}

type XtBringinformedPrint struct {
	ID        int64  `gorm:"column:id" json:"id" form:"id"`
	Content   string `gorm:"column:content" json:"content" form:"content"`
	UserOrgId int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Ctime     int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status    int64  `gorm:"column:status" json:"status" form:"status"`
}

func (XtBringinformedPrint) TableName() string {
	return "xt_bring_print"
}

type XtCathetercationPrint struct {
	ID        int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Content   string `gorm:"column:content" json:"content" form:"content"`
	Status    int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime     int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtCathetercationPrint) TableName() string {
	return "xt_cathetercation_print"
}

type XtDialyszerinformedPrint struct {
	ID        int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Content   string `gorm:"column:content" json:"content" form:"content"`
	Status    int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime     int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtDialyszerinformedPrint) TableName() string {
	return "xt_dialyszerinformed_print"
}

type XtTheapyinformedPrint struct {
	ID        int64  `gorm:"column:id" json:"id" form:"id"`
	Content   string `gorm:"column:content" json:"content" form:"content"`
	UserOrgId int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status    int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime     int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtTheapyinformedPrint) TableName() string {
	return "xt_theapyinformed_print"
}

type XtMedicalHistory struct {
	ID        int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	Ctime     int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status    int64  `gorm:"column:status" json:"status" form:"status"`
	Content   string `gorm:"column:content" json:"content" form:"content"`
}

func (XtMedicalHistory) TableName() string {
	return "xt_medical_history"
}

// 评分系统
type XtPatientFallassessment struct {
	ID               int64  `gorm:"column:id" json:"id" form:"id"`
	PatientId        int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	UserOrgId        int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	RecordDate       int64  `gorm:"column:record_date" json:"record_date" form:"record_date"`
	PingDate         int64  `gorm:"column:ping_date" json:"ping_date" form:"ping_date"`
	AdminUserId      int64  `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
	Status           int64  `gorm:"column:status" json:"status" form:"status"`
	IsCheck          int64  `gorm:"column:is_check" json:"is_check" form:"is_check"`
	IsCheckOne       int64  `gorm:"column:is_check_one" json:"is_check_one" form:"is_check_one"`
	IsCheckTwo       int64  `gorm:"column:is_check_two" json:"is_check_two" form:"is_check_two"`
	IsCheckThree     int64  `gorm:"column:is_check_three" json:"is_check_three" form:"is_check_three"`
	IsCheckFour      int64  `gorm:"column:is_check_four" json:"is_check_four" form:"is_check_four"`
	IsCheckFive      int64  `gorm:"column:is_check_five" json:"is_check_five" form:"is_check_five"`
	IsCheckSix       int64  `gorm:"column:is_check_six" json:"is_check_six" form:"is_check_six"`
	IsCheckSeven     int64  `gorm:"column:is_check_seven" json:"is_check_seven" form:"is_check_seven"`
	IsCheckEight     int64  `gorm:"column:is_check_eight" json:"is_check_eight" form:"is_check_eight"`
	IsCheckNight     int64  `gorm:"column:is_check_night" json:"is_check_night" form:"is_check_night"`
	IsCheckTen       int64  `gorm:"column:is_check_ten" json:"is_check_ten" form:"is_check_ten"`
	IsCheckEleven    int64  `gorm:"column:is_check_eleven" json:"is_check_eleven" form:"is_check_eleven"`
	IsCheckTwelve    int64  `gorm:"column:is_check_twelve" json:"is_check_twelve" form:"is_check_twelve"`
	IsCheckThirteen  int64  `gorm:"column:is_check_thirteen" json:"is_check_thirteen" form:"is_check_thirteen"`
	IsCheckFourteen  int64  `gorm:"column:is_check_fourteen" json:"is_check_fourteen" form:"is_check_fourteen"`
	IsCheckFifteen   int64  `gorm:"column:is_check_fifteen" json:"is_check_fifteen" form:"is_check_fifteen"`
	IsCheckSixteen   int64  `gorm:"column:is_check_sixteen" json:"is_check_sixteen" form:"is_check_sixteen"`
	IsCheckSeventeen int64  `gorm:"column:is_check_seventeen" json:"is_check_seventeen" form:"is_check_seventeen"`
	IsCheckEighteen  int64  `gorm:"column:is_check_eighteen" json:"is_check_eighteen" form:"is_check_eighteen"`
	IsCheckNineteen  int64  `gorm:"column:is_check_nineteen" json:"is_check_nineteen" form:"is_check_nineteen"`
	Ctime            int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime            int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Total            int64  `gorm:"column:total" json:"total" form:"total"`
	Content          string `gorm:"column:content" json:"content" form:"content"`
	ContentOne       string `gorm:"column:content_one" json:"content_one" form:"content_one"`
	ContentTwo       string `gorm:"column:content_two" json:"content_two" form:"content_two"`
	ContentThree     string `gorm:"column:content_three" json:"content_three" form:"content_three"`
	ContentFour      string `gorm:"column:content_four" json:"content_four" form:"content_four"`
	ContentFive      string `gorm:"column:content_five" json:"content_five" form:"content_five"`
	ContentSix       string `gorm:"column:content_six" json:"content_six" form:"content_six"`
	ContentSeven     string `gorm:"column:content_seven" json:"content_seven" form:"content_seven"`
	ContentEight     string `gorm:"column:content_eight" json:"content_eight" form:"content_eight"`
	ContentNight     string `gorm:"column:content_night" json:"content_night" form:"content_night"`
	ContentAdd       string `gorm:"column:content_add" json:"content_add" form:"content_add"`
	ContentAddOne    string `gorm:"column:content_add_one" json:"content_add_one" form:"content_add_one"`
}

func (XtPatientFallassessment) TableName() string {
	return "xt_patient_fallassessment"
}

type XtPatientPedFallssessment struct {
	ID          int64  `gorm:"column:id" json:"id" form:"id"`
	PatientId   int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	UserOrgId   int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status      int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime       int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime       int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Text        string `gorm:"column:text" json:"text" form:"text"`
	RecordDate  int64  `gorm:"column:record_date" json:"record_date" form:"record_date"`
	Total       int64  `gorm:"column:total" json:"total" form:"total"`
	AdminUserId int64  `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
	Type        int64  `gorm:"column:type" json:"type" form:"type"`
	Age         int64  `gorm:"column:age" json:"age" form:"age"`
	Cognize     int64  `gorm:"column:cognize" json:"cognize" form:"cognize"`
	Diagnosis   int64  `gorm:"column:diagnosis" json:"diagnosis" form:"diagnosis"`
	Environment int64  `gorm:"column:environment" json:"environment" form:"environment"`
	Medicine    int64  `gorm:"column:medicine" json:"medicine" form:"medicine"`
	Sex         int64  `gorm:"column:sex" json:"sex" form:"sex"`
	Tumble      int64  `gorm:"column:tumble" json:"tumble" form:"tumble"`
}

func (XtPatientPedFallssessment) TableName() string {
	return "xt_patient_ped_fallssessment"
}

type XtPatientCritical struct {
	ID        int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Content   string `gorm:"column:content" json:"content" form:"content"`
	Status    int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime     int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtPatientCritical) TableName() string {
	return "xt_patient_critical"
}

type XtPatientCriticalOne struct {
	ID        int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Content   string `gorm:"column:content" json:"content" form:"content"`
	Status    int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime     int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime     int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtPatientCriticalOne) TableName() string {
	return "xt_patient_critical_one"
}

type XtPatientBraden struct {
	ID           int64  `gorm:"column:id" json:"id" form:"id"`
	PatientId    int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	UserOrgId    int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	AdminUserId  int64  `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
	RecordDate   int64  `gorm:"column:record_date" json:"record_date" form:"record_date"`
	Total        int64  `gorm:"column:total" json:"total" form:"total"`
	FirstPingfen int64  `gorm:"column:first_pingfen" json:"first_pingfen" form:"first_pingfen"`
	TwoPingfen   int64  `gorm:"column:two_pingfen" json:"two_pingfen" form:"two_pingfen"`
	ThreePingfen int64  `gorm:"column:three_pingfen" json:"three_pingfen" form:"three_pingfen"`
	FourPingfen  int64  `gorm:"column:four_pingfen" json:"four_pingfen" form:"four_pingfen"`
	FivePingfen  int64  `gorm:"column:five_pingfen" json:"five_pingfen" form:"five_pingfen"`
	SixPingfen   int64  `gorm:"column:six_pingfen" json:"six_pingfen" form:"six_pingfen"`
	FamaliySign  string `gorm:"column:famaliy_sign" json:"famaliy_sign" form:"famaliy_sign"`
	PingDate     int64  `gorm:"column:ping_date" json:"ping_date" form:"ping_date"`
	FirstLapeso  int64  `gorm:"column:first_lapeso" json:"first_lapeso" form:"first_lapeso"`
	PingSign     string `gorm:"column:ping_sign" json:"ping_sign" form:"ping_sign"`
	LeaderSign   string `gorm:"column:leader_sign" json:"leader_sign" form:"leader_sign"`
	LeaderDate   int64  `gorm:"column:leader_date" json:"leader_date" form:"leader_date"`
	Ctime        int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime        int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status       int64  `gorm:"column:status" json:"status" form:"status"`
	FirstCheck   int64  `gorm:"column:first_check" json:"first_check" form:"first_check"`
	TwoCheck     int64  `gorm:"column:two_check" json:"two_check" form:"two_check"`
	ThreeCheck   int64  `gorm:"column:three_check" json:"three_check" form:"three_check"`
	FourCheck    int64  `gorm:"column:four_check" json:"four_check" form:"four_check"`
	FiveCheck    int64  `gorm:"column:five_check" json:"five_check" form:"five_check"`
	SixCheck     int64  `gorm:"column:six_check" json:"six_check" form:"six_check"`
	TwoLapeso    int64  `gorm:"column:two_lapeso" json:"two_lapeso" form:"two_lapeso"`
	ThreeLapeso  int64  `gorm:"column:three_lapeso" json:"three_lapeso" form:"three_lapeso"`
	Content      string `gorm:"column:content" json:"content" form:"content"`
}

func (XtPatientBraden) TableName() string {
	return "xt_patient_braden"
}

type XtPatientBradenChild struct {
	ID            int64  `gorm:"column:id" json:"id" form:"id"`
	PatientId     int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	IsCheckStatus int64  `gorm:"column:is_check_status" json:"is_check_status" form:"is_check_status"`
	FassementId   int64  `gorm:"column:fassement_id" json:"fassement_id" form:"fassement_id"`
	UserOrgId     int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Content       string `gorm:"column:content" json:"content" form:"content"`
	Status        int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime         int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime         int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtPatientBradenChild) TableName() string {
	return "xt_patient_braden_child"
}

type XtAgePatients struct {
	ID                          int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId                   int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Name                        string `gorm:"column:name" json:"name" form:"name"`
	Status                      int64  `gorm:"column:status" json:"status" form:"status"`
	Age                         int64  `gorm:"column:age" json:"age" form:"age"`
	Lapseto                     int64  `gorm:"column:lapseto" json:"lapseto" form:"lapseto"`
	DialysisNo                  string `gorm:"column:dialysis_no" json:"dialysis_no" form:"dialysis_no"`
	BeforSystolicBloodPressure  float64
	BeforDiastolicBloodPressure float64
	AfterSystolicBloodPressure  float64
	AfterDiastolicBloodPressure float64
	XueLin                      string
	XueHongDanBai               string
	XueGai                      string
	JiaoZhengGai                string
	JiaPanSu                    string
	YiTieDanBai                 string
	TieDanBai                   string
	QianBaiDanBai               string
	Crp                         string
	Mg                          string
	URR                         string
	KTV                         string
}

func (XtAgePatients) TableName() string {

	return "xt_patients"
}

type NewInspection struct {
	ID              int64  `gorm:"column:id" json:"id" form:"id"`
	PatientId       int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	OrgId           int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	ProjectId       int64  `gorm:"column:project_id" json:"project_id" form:"project_id"`
	ProjectName     string `gorm:"column:project_name" json:"project_name" form:"project_name"`
	InspectDate     int64  `gorm:"column:inspect_date" json:"inspect_date" form:"inspect_date"`
	Status          int64  `gorm:"column:status" json:"status" form:"status"`
	Count           int64
	LastInspectData int64
}

type XtTreatmentPlan struct {
	ID        int64  `gorm:"column:id" json:"id" form:"id"`
	UserOrgId int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Content   string `gorm:"column:content" json:"content" form:"content"`
	Ctime     int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Status    int64  `gorm:"column:status" json:"status" form:"status"`
	Mtime     int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (XtTreatmentPlan) TableName() string {

	return "xt_treatment_plan"
}

type XtPatientLaspseRecord struct {
	ID             int64  `gorm:"column:id" json:"id" form:"id"`
	PatientId      int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	RecordDate     int64  `gorm:"column:record_date" json:"record_date" form:"record_date"`
	LapseDate      int64  `gorm:"column:lapse_date" json:"lapse_date" form:"lapse_date"`
	LapseType      int64  `gorm:"column:lapse_type" json:"lapse_type" form:"lapse_type"`
	LapseClass     int64  `gorm:"column:lapse_class" json:"lapse_class" form:"lapse_class"`
	LapseReason    string `gorm:"column:lapse_reason" json:"lapse_reason" form:"lapse_reason"`
	AdminUserId    int64  `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
	Remark         string `gorm:"column:remark" json:"remark" form:"remark"`
	UserOrgId      int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Ctime          int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime          int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status         int64  `gorm:"column:status" json:"status" form:"status"`
	LapseTypeName  string `gorm:"column:lapse_type_name" json:"lapse_type_name" form:"lapse_type_name"`
	HisType        int64  `gorm:"column:his_type" json:"his_type" form:"his_type"`
	HisZone        string `gorm:"column:his_zone" json:"his_zone" form:"his_zone"`
	HisBed         string `gorm:"column:his_bed" json:"his_bed" form:"his_bed"`
	PatientAddress string `gorm:"column:patient_address" json:"patient_address" form:"patient_address"`
	StartTime      int64  `gorm:"column:start_time" json:"start_time" form:"start_time"`
	EndTime        int64  `gorm:"column:end_time" json:"end_time" form:"end_time"`
	StartTimeOne   int64  `gorm:"column:start_time_one" json:"start_time_one" form:"start_time_one"`
	EndTimeOne     int64  `gorm:"column:end_time_one" json:"end_time_one" form:"end_time_one"`
}

func (XtPatientLaspseRecord) TableName() string {

	return "xt_patient_laspse_record"
}

type XtDeathSummary struct {
	ID             int64  `gorm:"column:id" json:"id" form:"id"`
	PatientId      int64  `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	UserOrgId      int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	RecordDate     int64  `gorm:"column:record_date" json:"record_date" form:"record_date"`
	ReasonOne      string `gorm:"column:reason_one" json:"reason_one" form:"reason_one"`
	ReasonTwo      string `gorm:"column:reason_two" json:"reason_two" form:"reason_two"`
	ReasonThree    string `gorm:"column:reason_three" json:"reason_three" form:"reason_three"`
	ReasonFour     string `gorm:"column:reason_four" json:"reason_four" form:"reason_four"`
	DeathWay       string `gorm:"column:death_way" json:"death_way" form:"death_way"`
	ReplaceWay     string `gorm:"column:replace_way" json:"replace_way" form:"replace_way"`
	ReplaceReason  string `gorm:"column:replace_reason" json:"replace_reason" form:"replace_reason"`
	Transplant     string `gorm:"column:transplant" json:"transplant" form:"transplant"`
	Ctime          int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Remark         string `gorm:"column:remark" json:"remark" form:"remark"`
	Mtime          int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status         int64  `gorm:"column:status" json:"status" form:"status"`
	AdminUserId    int64  `gorm:"column:admin_user_id" json:"admin_user_id" form:"admin_user_id"`
	UpdateCreater  int64  `gorm:"column:update_creater" json:"update_creater" form:"update_creater"`
	LastRecordDate int64  `gorm:"column:last_record_date" json:"last_record_date" form:"last_record_date"`
}

func (XtDeathSummary) TableName() string {

	return "xt_death_summary"
}
